
/*** CARVCOMP.  Version control Compare utility. 
/  
/    CARVCOMP compares the Carve-marks in two files, A and B.
/    If they are identical, or the carve-marks in one file is
/    a proper subset of the marks in the other, CARVCOMP exits
/    with a status code of 1.  Otherwise, the two files represent
/    a "branch", and it exits with a status code of 0.
/
/    Invoked as:
/       carvcomp  file_a  file_b
/ */

/*: CR  3/01/89 15:56 Start carve-marking carve source code. */
/*: CR  7/06/89 23:40 Add beginning comments. */

#include <stdio.h>

#define  NOT   !

main (argc, argv)
   int   argc;
   char *argv[];
{
   FILE *fa, *fb, *fopen();
   int  a, b;
   char stra[202], strb[202];

   if (argc < 3  ||  (fa = fopen (argv[1], "r")) == NULL  ||
                     (fb = fopen (argv[2], "r")) == NULL) {
      printf ("Usage:  CARVCOMP  file_a  file_b\n");
      exit   (2);
   }

   while (1) {
      a = getnextmark (fa, stra);
      b = getnextmark (fb, strb);

      if (a  &&  b  &&  NOT streq (stra, strb))  exit (0);
      if (NOT a)  exit(1);
      if (NOT b)  exit(1);
   }
}

getnextmark (fp, str)
   FILE  *fp;
   char  *str;
{
   while (1) {
      if (fgets (str, 200,  fp) == NULL)  return (0);
      if (strindex (str, "/*:") == 0)     break;
   }
   str[21] = '\0';
   return (1);
}


/*** STRINDEX.  Return starting position in string S of string T. */

strindex (s, t)
   char  s[], t[];
{
   register int  i, j, k;

   for (i=0;  s[i] != '\0';  i++) {
      for (j=i, k=0;  t[k] != '\0' && s[j]==t[k];  j++, k++) ;
      if (t[k] == '\0')  return (i);
   }
   return (-1);
}


/*** STREQ.   Return 1 if string S equals string T; 0 otherwise. */

streq (s, t)
   char *s, *t;
{

   while (*s == *t)  {
      if (NOT *s)  return (1);
      ++s;
      ++t;
   }
   return (0);
}
