/*** TEXTEDIT.  Edit the text in FILE.
/
/    TEXTEDIT invokes EDITOR on the text in FILE.  TRUNCATE is
/    supplied because the Caucus editor, one of the possible
/    choices, understands the truncation of lines longer than
/    77 characters.
/
/    Once the text is edited, TEXTEDIT invokes TEXTFORMAT to reformat
/    or truncate the text so that everything fits nicely in 77 columns.
/    (If it doesn't, TEXTEDIT offers the user the chance to edit
/    the file again, or else it will just truncate at column 78.)
/
/    TEXTEDIT returns 1, unless EDITOR could not be used, in which
/    case it immediately RETURNs 0. */

/*** Copyright (C) 1984 Camber-Roth.  All rights reserved. */

/*: AA  7/29/88 17:32 Source code master starting point */
/*: JV  7/22/90 17:13 Change def of TRUNCATE to match caucus.h. */
/*: JX  3/28/92 13:00 Chixify. */
/*: JX  5/16/92 16:52 Fix Chix. */

#include "caucus.h"
#include "chixuse.h"
#include "ced.h"

FUNCTION  textedit (file, editor, truncate)
   int    file;
   Chix   editor;
   char   truncate;
{
   Chix  edit2;
   int   success;

   ENTRY ("textedit", "");

   edit2 = chxalloc (40L, THIN, "texte edit2");

   if (NOT editfile  (file, editor, truncate))
      FAIL;

   while (NOT textform (file, truncate, edit2)) 
      editfile (file, edit2, truncate);

   SUCCEED;
done:
   chxfree (edit2);
   RETURN (success);
}
