/*** TEXTINPUT.  Read a LINE of text from the user. 
/
/    If the user presses <CANCEL>, TEXTINPUT queries the user
/    if this text entry should be canceled.  If the user
/    confirms, TEXTINPUT returns -1.  Otherwise, TEXTINPUT
/    prompts again for a line of input.
/
/    If the user types an EOT, TEXTINPUT returns 0.
/
/    Otherwise, the text is returned in LINE, and TEXTINPUT
/    returns 1.   LENGTH is the maximum length of the line
/    of text that will be accepted.   Note that tabs are
/    converted into the proper # of spaces on input. */

/*** Copyright (C) 1984-1992 Camber-Roth.  All rights reserved. */

/*: AA  7/29/88 17:32 Source code master starting point */
/*: AM  2/07/89 10:24 Jcaucus changes*/
/*: CW  7/21/89 15:44 Echoinput() input text line. */
/*: CW  7/24/89 15:11 Add preprompt/promptstr. */
/*: CR  9/12/89 15:11 Remove result. */
/*: JX  3/28/92 13:20 Chixify. */
/*: JX  5/16/92 17:01 Fix Chix. */

#include "caucus.h"
#include "chixuse.h"
#include <stdio.h>

extern struct flag_template  flag;
extern Userreg               thisuser;
extern Chix                  yesnotable;
extern Chix                  ss_inprom;

FUNCTION  textinput (line, length)
   Chix   line;
   int    length;
{
   static Chix preprompt;
   short  code;
   int    success;
   Chix   yes, promptstr, prompt;

   ENTRY ("textinput", "");

   yes       = chxalloc (40L, THIN, "texti yes");
   prompt    = chxalloc (20L, THIN, "texti prompt");
   promptstr = chxalloc (200L, THIN, "texti promptstr");

   mdstr  (promptstr, "ent_Tpreprom", &preprompt);
   chxcpy (prompt,  flag.no1prompt ? CQ("") : ss_inprom);
   chxcat (promptstr, prompt);

   do {
      code = prompter (promptstr, nullchix, 0, "ced_Htexin",
                      length, line, nullchix);

      if (code <= -3) {
         chxtoken (yes, nullchix, 2, yesnotable);
         if (mdprompter ("ced_Pcantex", yesnotable, 2, "ced_Htexcan", 10, 
                            line, yes) != 0)  success = -1; goto done;
      }

      if (chxeq (line, thisuser->eot))  { chxclear (line);   FAIL; }

      echoinput (prompt, line);
   } while (code <= -3);

   sysclean(line);
   fixtabs (line);
   SUCCEED;

done:
   chxfree (yes);
   chxfree (prompt);
   chxfree (promptstr);
   RETURN (success);
}
