
/*** ORG_CONFIRM.  Does the Organizer confirm changing this?
/
/    ORG_CONFIRM is called when the user tries to change something
/    (item, response) that does not belong to him.  It returns
/    1 if the user is the Organizer and confirms that he really
/    wants make the change, and returns 0 otherwise. */

/*** Copyright (C) 1987 Camber-Roth.  All rights reserved. */

/*: AA  7/29/88 17:34 Source code master starting point */
/*: CR 11/09/88 13:05 Handle <CANCEL> while changing another's response. */
/*: CW  5/18/89 13:25 Add XW unitcodes. */
/*: CR  7/13/90 14:36 Use thisuser.is_organizer. */
/*: DE  3/17/92 12:02 Chixified */

#include "caucus.h"
#include <stdio.h>

extern Userreg                thisuser;
extern union  null_t          null;
extern Chix                   yesnotable;

FUNCTION  org_confirm()
{
   Chix   answer, def;
   short  s, success;

   ENTRY ("orgconfirm", "");

   answer    = chxalloc (20L, THIN, "orgconfi answer");
   def       = chxalloc (20L, THIN, "orgconfi def"); 
   success   = 0;

   if (NOT thisuser->is_organizer)  FAIL;

   chxtoken (def, null.chx, 1, yesnotable);
   mdwrite  (XWTX, "chg_Torgcon", null.md);
   s = mdprompter ("chg_Porgcon", yesnotable, 2, "chg_Horgcon", 
                                  10, answer, def);
   if (s <= -3)  sysbrkset();
   DONE(s > 0);

done:

   chxfree ( answer );
   chxfree ( def );

   RETURN ( success );

}
