
/*** CHXCPY.  Copy one chix into another.
/
/    chxcpy (a, b);
/
/    Parameters:
/       Chix  a, b;
/
/    Purpose:
/       Copy chix B into chix A, overwriting old contents of A.
/       A gets B's data and type.
/
/    How it works:
/
/    Returns: 1
/
/    Error Conditions:  none
/  
/    Side effects:      none
/
/    Related functions:
/
/    Called by:  Application.
/
/    Operating system dependencies: none
/
/    Known bugs:      none
/
/    Home:  chx/chxcpy.c.
/ */

/*** Copyright (C) 1990 Camber-Roth.  All rights reserved. */

/*: CX 12/10/90 23:36 New function. */
/*: CR  7/08/91 15:31 Fix chxcheck() call. */
/*: CR 10/20/91 11:54 Copy dic field as well. */
/*: CR 12/11/92 13:20 Chxresize last arg is long *. */

#include <stdio.h>
#include "chixdef.h"

FUNCTION  chxcpy (a, b)
   Chix   a, b;
{
   long   len, bytes, i;

   ENTRY ("chxcpy", "");

   if (NOT chxcheck (a, "chxcpy")  ||  NOT chxcheck (b, "chxcpy"))  RETURN(1);
   
   len = chxlen (b) + 1;
   if (a->type != b->type  ||  a->maxlen < len) {
      chxresize (a, b->type, len+5);
      a->type = b->type;
   }

   bytes = len * b->type;
   for (i=0;   i<bytes;   ++i)  a->p[i] = b->p[i];
   a->actlen = b->actlen;
   a->dic    = b->dic;

   RETURN  (1);
}
