/*** DELMESS.   Delete a range of messages. */

/*** Copyright (C) 1987 Camber-Roth.  All rights reserved. */

/*: AA  7/29/88 17:38 Source code master starting point*/
/*: JV  8/23/89 14:02 Chg'd err message on no match. */
/*: CW  5/17/89 16:22 Use XW unitcodes in place of XITT.*/
/*: CR 10/09/89 11:13 Simplify "no messages found" message. */
/*: CR  3/20/90 16:30 Use message_t mess. */
/*: CR  3/22/90 16:25 Tell user what we're about to delete. */
/*: CR  8/12/90 20:27 Cast messparse arg to make Lint happy. */
/*: CR  4/08/91 18:49 Add new unit_lock argument. */
/*: CR  8/07/91 14:25 Add 'confnum' arg to syspdir() call. */
/*: CX 11/12/91 15:12 Chixify. */
/*: UL 12/11/91 18:42 Make unit_lock args 3-6 long.*/
/*: CR  2/08/93 14:29 chxfree last! */
/*: CK  9/19/93 12:03 Add 'old' arg to messparse() call. */

#include <stdio.h>
#include "caucus.h"
#define  I(x)  ( (int) x )

extern struct message_t       mess;
extern struct pdir_t          pdir;
extern union  null_t          null;
extern Chix   yesnotable;
extern Chix   ss_dotnl;

static Chix  reptab[] = 
  {nullchix,  nullchix,  nullchix,  nullchix,  nullchix,  nullchix};

FUNCTION  delmess (comline)
   Chix   comline;
{
   static Chix mesmodtab = nullchix;
   static Chix s_confirm = nullchix;
   short  m;
   char   ftab[10];
   int    success;
   Chix   id, range, confirm, last, no, answer, all, format, output;

   ENTRY ("delmess", "");

   id      = chxalloc (20L, THIN, "delmess id");
   no      = chxalloc (20L, THIN, "delmess no");
   all     = chxalloc (20L, THIN, "delmess all");
   last    = chxalloc (20L, THIN, "delmess last");
   range   = chxalloc (80L, THIN, "delmess range");
   answer  = chxalloc (80L, THIN, "delmess answer");
   confirm = chxalloc (80L, THIN, "delmess confirm");
   format  = chxalloc (80L, THIN, "delmess format");
   output  = chxalloc (80L, THIN, "delmess output");

   mdtable ("mes_Amod", &mesmodtab);

   /*** Load the current message directory. */
   sysuserid (id);
   unit_lock (XUMD, READ, 0L, 0L, 0L, 0L, id);
   mess.highest = loadmdir (0, mess.num);
   unit_unlk (XUMD);

   if (mess.highest == 0) {
      mdwrite (XWER, "mes_Thave0", null.md);
      SUCCEED;
   }

   /*** Pluck RANGE off of command line, or else prompt for it. */
   if (chxtoken (null.chx, range, 3, comline) < 0) {
      if (mdprompter ("del_Pmess", null.chx, 0, "del_Hmess", 80, range, CQ(""))
                       < -1)  FAIL;
   }

   /*** Prepare to tell the user just what we're going to delete. */
   mdstr  (confirm, "mes_Tconmess", &s_confirm);
   chxcat (confirm, range);
   chxcat (confirm, NEWLINE);

   /*** Parse ALL, LAST, NEW, etc. */
   chxformat (all,  CQ(" 1-%d "), (long) mess.highest, 0L, null.chx, null.chx);
   chxformat (last, CQ(" %d "),   (long) mess.highest, 0L, null.chx, null.chx);
   reptab[0] = all;
   reptab[1] = last;
   parsewords (range, mesmodtab, reptab, ftab);

   if (NOT messparse (range, I(ftab[2]), I(ftab[5]), mess.highest, mess.num)) {
      chxsimplify (range);
      mdstr (format, "mes_F0selected", null.md);
      chxformat (output, format, (long) range, 0L, null.chx, null.chx);
      unit_write (XWER, output);
      SUCCEED;
   }

   /*** Prompt for confirmation before actually deleting messages. */
   sysbrkclear();
   chxtoken (no, null.chx, 1, yesnotable);
   unit_write (XWTX, confirm);
   if (mdprompter ("del_Pmok", yesnotable, 2, "del_Hmok", 10, answer, no) <= 0)
      FAIL;
      

   /*** Mark all the selected messages as 'to-be-deleted'. */
   for (m=1;   m<=mess.highest;   ++m)
      if (mess.num[m] & MSG_SEE)   mess.num[m] |= MSG_DEL;

   /*** Reload the message directory, integrating it with the list
   /    of messages to be deleted. */
   unit_lock (XUMD, WRITE, 0L, 0L, 0L, 0L, id);
   mess.highest = loadmdir (mess.highest, mess.num);
   syspdir (&pdir, XUMF, 0, 0, id);

   /*** Actually delete the messages, and rewrite the message dir. */
   mess.highest   = messdel (&pdir, mess.highest, mess.num);
   mess.high_seen = min (mess.highest, mess.high_seen);
   if (NOT sysbrktest())  storemdir (mess.highest, mess.num);
   unit_unlk (XUMD);
   SUCCEED;

done:
   chxfree (output);
   chxfree (format);
   chxfree (confirm);
   chxfree (answer);
   chxfree (range);
   chxfree (all);
   chxfree (no);
   chxfree (id);
   chxfree (last);
   RETURN  (success);
}
