
/*** DESCITEM.   CLI: Describe items/responses selected in COMMAND. */

/*** Copyright (C) 1987 Camber-Roth.  All rights reserved. */

/*: AA  7/29/88 17:38 Source code master starting point*/
/*: JV  8/23/89 11:46 Changed error message on invalid item range. */
/*: CW  5/17/89 16:22 Use XW unitcodes in place of XITT.*/
/*: CR 10/11/89 16:11 Revert to "no items selected" if parserange fails. */
/*: CX 11/12/91 17:41 Chixify. */
/*: CR  1/20/92 16:45 Add cnum arg to load_header() call. */
/*: JX  5/13/92 11:49 Add cnum arg to descitem() (never defined on 1/20/92). */
/*: CR 10/06/92 15:15 Do not clear used.lines. */
/*: JV  4/03/93 11:24 Add attach arg to load_header. */
/*: JV  6/08/93 16:57 Don't need title or header. */
/*: CN  5/15/93 13:41 Replace parse_range with newparse(). */
/*: CT  5/28/93 13:47 Replace SELECT with Rlist. */
/*: CP  6/23/93 23:43 Use new form of new_parse(). */
/*: CP  6/24/93 15:39 Simplify, using new Rlists. */
/*: CP  7/14/93 14:13 Integrate 2.5 changes. */
/*: CK  7/28/93 17:07 Check R0 *and* R1 for -1. */
/*: CP  8/04/93 16:45 Skip item if first > last. */
/*: CP  8/06/93 12:06 Use r_bound() to limit first/last. */
/*: CP  8/09/93 11:41 Add 'attach' arg to new_parse() call. */
/*: CP  8/10/93 13:37 Use new Redirect object in handling redirection. */
/*: CP  9/09/93 17:15 Replace new_parse() with parse_or_ask(). */
/*: CK  9/15/93 14:04 Add 'mod1st' arg to parse_or_ask(). */
/*: CK 10/07/93 16:33 Pass &thisitem to parse_or_ask(). */
/*: CK 10/14/93 14:46 mod[M_ITEMS] -> NOT mod[M_RESPONSES]. */
/*: CP 11/11/93 13:37 Add 'resp1' arg to show_format() call. */
/*: CP 11/18/93 15:35 Add cnum, inum args to r_bound() call. */
/*: CP 12/10/93 21:31 Add 'final' arg to r_bound() call. */

#include <stdio.h>
#include "caucus.h"
#include "modifier.h"
#include "api.h"
#include "redirect.h"
#define   RLNULL   ( (Rlist) NULL )

extern struct master_template  master;
extern struct this_template    thisitem;
extern union  null_t           null;

FUNCTION  descitem (cnum, red, range)
   int       cnum;
   Redirect *red;
   Chix      range;
{
   int    success, last, first, final, i;
   Chix   itemform, respform, output;
   char   modifier[MODIFIERS+5];
   Rlist  rptr, result;

   ENTRY ("descitem", "");

   itemform = chxalloc (80L, THIN, "descitem itemform");
   respform = chxalloc (80L, THIN, "descitem respform");
   output   = chxalloc (80L, THIN, "descitem format");
   result   = RLNULL;

   if (NOT parse_or_ask (range, &result, modifier, nullchix, cnum, 
                                &thisitem, 1))   SUCCEED; /* ?? */

   if (modifier[M_BRIEF]) {
      mdstr (itemform, "res_Fshowhead3", null.md);
      mdstr (respform, "res_Fshowhead4", null.md);
   }
   else {
      mdstr (itemform, "res_Fshowhead5", null.md);
      mdstr (respform, "res_Fshowhead6", null.md);
   }

   sysbrkclear();
   apply_redirect (red);
   unit_write (red->unit, NEWCPAGE);
   for (rptr=result->next;   rptr!=RLNULL;   rptr=rptr->next) {
      for (i=rptr->i0;   i<=rptr->i1;   ++i) {
         if (sysbrktest())   break;
   
         if (i == 0)                                        continue;
         if (NOT r_bound (&first, &last, &final, rptr, cnum, i, 
                                     master.responses[i]))  continue;

         if (NOT modifier[M_RESPONSES]  &&  first == 0  &&
               (last == master.responses[i] || rptr->r1 < 0) )
            show_format (red->unit, itemform, i, 0, 0, 0, 0, nullchix, nullchix);
         else 
            show_format (red->unit, respform, i, 0, first, last, 0, nullchix, 
                                    nullchix);
      }
   }
   SUCCEED;

done:
   a_fre_rlist (result);
   chxfree (output);
   chxfree (itemform);
   chxfree (respform);
   RETURN  (success);
}
