/*** DESCMESS.   Describe a set of messages as instructed by the user.
/
/    DESCMESS is handed a command line COMLINE which is a request
/    by the user to describe a set of messages.  It parses the list of
/    messages, and calls MESSLIST to actually describe the selected
/    messages on unit OUT. */

/*** Copyright (C) 1987 Camber-Roth.  All rights reserved. */

/*: AA  7/29/88 17:38 Source code master starting point*/
/*: JV  8/23/89 11:52 Changed error message if not a valid mess range */
/*: CW  5/17/89 16:22 Use XW unitcodes in place of XITT.*/
/*: CR  8/28/89 13:50 Remove close, unlk on OUT. */
/*: CR 10/09/89 11:13 Simplify "no messages found" message. */
/*: CR 11/30/89 13:53 Use mes_T0selected instead of mes_F0selected. */
/*: CR  3/20/90 16:34 Use message_t mess. */
/*: CR  8/12/90 19:20 Cast messlist/messparse arg. */
/*: CR  4/08/91 18:49 Add new unit_lock argument. */
/*: CX 11/12/91 18:03 Chixify. */
/*: UL 12/11/91 18:42 Make unit_lock args 3-6 long.*/
/*: CP  8/10/93 13:37 Use new Redirect object in handling redirection. */
/*: CK  9/19/93 12:03 Add 'old' arg to messparse() call. */

#include <stdio.h>
#include "caucus.h"
#include "redirect.h"
#define  I(x)  ( (int) x )

extern struct message_t        mess;
extern union  null_t           null;
extern Chix                    ss_dotnl;

static Chix reptab[] = 
  { nullchix,  nullchix,  nullchix,  nullchix,  nullchix,  nullchix};

FUNCTION  descmess (red, comline)
   Redirect *red;
   Chix      comline;
{
   static Chix  mesmodtab = nullchix;
   char   ftab[10];
   int    success;
   Chix   id, all, last, args;

   ENTRY ("descmess", "");

   id   = chxalloc (20L, THIN, "descmess id");
   all  = chxalloc (20L, THIN, "descmess all");
   last = chxalloc (20L, THIN, "descmess last");
   args = chxalloc (20L, THIN, "descmess args");

   mdtable ("mes_Amod", &mesmodtab);

   /*** Load the current message directory. */
   sysuserid (id);
   unit_lock (XUMD, READ, 0L, 0L, 0L, 0L, id);
   mess.highest = loadmdir (0, mess.num);
   unit_unlk (XUMD);

   if (mess.highest >= MAXMESS)  mdwrite (XWER, "mes_Tbinfull", null.md);

   apply_redirect (red);
   if (mess.highest > 0) {

      chxformat (all, CQ(" 1-%d "), (long)mess.highest, 0L, null.chx, null.chx);
      chxformat (last, CQ(" %d "),  (long)mess.highest, 0L, null.chx, null.chx);
      reptab[0] = all;
      reptab[1] = last;

      chxtoken (null.chx, args, 3, comline);
      parsewords (args, mesmodtab, reptab, ftab);

      if (messparse (args, I(ftab[2]), I(ftab[5]), mess.highest, mess.num))  
              messlist   (red->unit, mess.num, mess.highest, I(ftab[4]));
      else    mdwrite (XWER, "mes_T0selected", null.md);
   }

   else       mdwrite (XWER, "mes_Thave0", null.md);

   SUCCEED;

done:
   chxfree (args);
   chxfree (last);
   chxfree (all);
   chxfree (id);
   RETURN  (success);
}
