/*** SHOWSEEN.   Display how much of certain items a selected user has seen.
/
/    THATUSER is the participation record for a particular person for
/    this conference.  FLAGS is the list of items selected by the
/    user.  SHOWSEEN displays (on unit OUT) how much of each item FLAGS
/    has been seen by THATUSER.   */

/*** Copyright (C) 1988 Camber-Roth.  All rights reserved. */

/*: AA  7/29/88 17:38 Source code master starting point*/
/*: AM  2/07/89 10:26 Jcaucus changes*/
/*: CW  5/17/89 16:22 Use XW unitcodes in place of XITT.*/
/*: CR  1/20/92 16:50 Add cnum arg to load_header() call. */
/*: JX  5/13/92 15:09 Chixify. */
/*: CR 10/22/92 11:31 Use -61s on title, not chxcatsub. */
/*: CL 12/11/92 11:13 Long Chxcatsub args. */
/*: JV  4/02/93 11:26 Add attach arg to load_header(). */
/*: CN  5/15/93 17:21 Replace char * 'flags' with short * 'select'. */
/*: CT  5/28/93 13:47 Replace SELECT with Rlist. */
/*: CP  7/01/93 15:08 Test for <CANCEL> during display. */
/*: CP  8/06/93 15:09 Screen out item "0". */

#include <stdio.h>
#include "caucus.h"
#include "chixuse.h"
#include "api.h"
#define   RLNULL   ( (Rlist) NULL )

extern struct master_template master;
extern union  null_t          null;
extern short                  confnum;

FUNCTION  showseen (out, result, thatuser)
   int    out;
   Rlist  result;
   struct partic_t *thatuser;
{
   short  i;
   Chix   title, header, mtu;
   Rlist  rptr;

   ENTRY ("showseen", "");

   mtu   = chxalloc (100L, THIN, "showseen mtu");
   title = chxalloc (100L, THIN, "showseen title");
   header= chxalloc (100L, THIN, "showseen header");

   mdwrite (out, "sho_Tseehed", null.md);

   sysbrkclear();
   for (rptr=result->next;   rptr!=RLNULL;   rptr=rptr->next) {
      for (i=rptr->i0;   i<=rptr->i1;   ++i) {
         if (i == 0)             continue;
         if (sysbrktest())       break;
         if (NOT load_header (confnum, i, header, title, (Attachment) NULL))
                                 continue;

         chxclear (mtu);
         chxformat (mtu, CQ("%4d %4d "), L(i), L(master.responses[i]),
                    null.chx, null.chx);
         chxformat (mtu, CQ("%4d %-61s\n"), L(thatuser->responses[i]), 0L,
                    title, nullchix);
         unit_write (out, mtu);
      }
   }

   chxfree (mtu);
   chxfree (title);
   chxfree (header);
   RETURN (1);
}
