/*** LOGGER.   Parse & process the "_log" command.  */

/*** Copyright (C) 1992 Camber-Roth.  All rights reserved. */

/*: CR  9/09/92 17:18 New function.  */
/*: CI 10/07/92 17:07 Chixify. */
/*: CL 12/11/92 11:13 Long Chxcatsub args. */

#include <stdio.h>
#include "caucus.h"

FUNCTION  logger (command)
   Chix   command;
{
   long   ivalue, starttime, count, size;
   long   pos;
   int    i;
   Chix   feature, svalue, temp;

   ENTRY ("logger", "");

   feature = chxalloc (10L, THIN, "logger feature");
   svalue  = chxalloc (10L, THIN, "logger svalue");
   temp    = chxalloc (10L, THIN, "logger temp");

   /*** Pluck off the arguments from _log: 
   /       feature, svalue, ivalue, starttime, count, size. */
   ivalue = starttime = count = size = 0L;
   for (i=2;   i<8;   ++i) {
      if (chxtoken (temp, nullchix, i, command) == -1)  break;
      
      pos = 0;
      switch (i) {
         case (2):   chxcatsub (feature, temp, 0L,  L(8));     break;
         case (3):   chxcatsub (svalue,  temp, 0L, L(12));     break;
         case (4):   ivalue    = chxlong (temp, &pos);     break;
         case (5):   starttime = chxlong (temp, &pos);     break;
         case (6):   count     = chxlong (temp, &pos);     break;
         case (7):   size      = chxlong (temp, &pos);     break;
      }
   }

   logfeature (feature, svalue, ivalue, starttime, count, size);

   chxfree (feature);
   chxfree (svalue);
   chxfree (temp);
   RETURN  (1);
}
