/*** SHOWFOUND.  SHOW where we found the words we were looking for with FIND.
/
/    SHOWFOUND writes up to 3 lines of text around line LINE in item I,
/    response R.  
/
/    LASTLINE is the last line on which we found the word(s) in this item
/    or response.  It controls just how much text we show around LINE. */

/*** Copyright (C) 1987 Camber-Roth.  All rights reserved. */

/*: AA  7/29/88 17:40 Source code master starting point */
/*: CR  2/19/91 18:29 Use person_format() to format author's name. */
/*: CR  7/16/91 17:08 Add HOST argument to person_format() calls. */
/*: CR 10/29/91 11:45 Add confnum arg to getline() call. */
/*: JV 10/31/91 13:09 Declare sprintf */
/*: JX  5/26/92 20:06 Chixify. */
/*: JV 10/10/92 14:53 Move chxfree(s). */

#include <stdio.h>
#include "caucus.h"

extern union null_t null;
extern short        confnum;

FUNCTION  showfound (out, i, r, line, lastline, header)
   int    out, i, r, line, lastline;
   Chix   header;
{
   static Chix s_author;
   Chix    ptr, author, s;
   Chix    mtu, format, userid;
   short   n;
   Chix    getline(),  person_format();

   ENTRY ("showfound", "");

   mtu    = chxalloc (100L, THIN, "showfound mtu");
   format = chxalloc (40L, THIN, "showfound format");
   author = chxalloc (40L, THIN, "showfound userid");
   userid = chxalloc (40L, THIN, "showfound userid");

   if (lastline < 0) {

      /*** Get the author of the "found" item or response, and
      /    format it according to fnd_Fauthor.  Result is in S. */
      chxtoken (userid, nullchix, 2, header);
      chxtoken (mtu, author, 6, header);
      mdstr (format, "fnd_Fauthor", &s_author);
      s = person_format (format, author, userid, nullchix, nullchix, null.nl);

      if (r) {
         mdstr   (format, "fnd_FshowR", null.md);
         chxclear  (mtu);
         chxformat (mtu, format, L(i), L(r), s, nullchix);
      }
      else {
         mdstr   (format, "fnd_FshowI", null.md);
         chxclear  (mtu);
         chxformat (mtu, format, L(i), 0L, s, nullchix);
      }
      chxfree (s);
      unit_write (out, mtu);
   }
   else if (line > lastline+3)  mdwrite (out, "fnd_Tdots", null.md);

   /*** Display the "hit" line and one line above and below it. */
   for (n = max (line-1, lastline+2);    n<=line+1;    ++n)  if (n>0) {
      if ( (ptr = getline (XCRD, XCRF, confnum, nullchix, i, r, n, 
                           (Textbuf) NULL)) != nullchix) {
         unit_write (out, CQ(" "));
         unit_write (out, ptr);
         unit_write (out, CQ("\n"));
      }
   }

   chxfree (mtu);
   chxfree (format);
   chxfree (author);
   chxfree (userid);

   RETURN (1);
}
