/*** COSTART.  Start a new CAUCUS conference.   CV2.   */

/*** Copyright (C) 1988-1992 Camber-Roth.  All rights reserved. */

/*: AA  7/29/88 17:59 Source code master starting point */
/*: JV  9/14/88 00:00 cnumber must not be called with a literal string */
/*: CR  9/20/88 14:00 org userid must be 1 word, lower case*/
/*: CR  9/20/88 14:00 Declare char *strtoken(); */
/*: CR 11/03/88 14:56 Replace unit_name/sysmkdir with sysmkconf(). */
/*: CR 11/12/88 18:48 Change XCMA 2nd line to "0 0 0". */
/*: CR 12/05/88 12:51 Fix inconsistent 3rd arg to nladd(). */
/*: CR  3/01/89 15:48 Change name from cstart() to costart(). */
/*: JV  8/21/89 19:00 Fix ENTRY (cstart->costart). */
/*: JV  8/21/89 20:00 Robusted use of return from cnumber. */
/*: CW  7/20/89 14:28 Add XW unit codes. */
/*: CR 10/09/89 11:36 Use XW unit codes. */
/*: CR 11/20/89 14:35 Use cst_Kinexdef as default permission for new conf. */
/*: CR  7/25/90 14:02 New, longer conference-creation dialogue. */
/*: CR  4/08/91 18:49 Add new unit_lock argument. */
/*: CR  7/02/91  0:00 Include "unitwipe.h". */
/*: CR  7/30/91 18:14 Add 3rd arg to loadreg(). */
/*: CR  8/02/91 12:44 Add NOPUNCT as new last arg to modnames() call. */
/*: JV 10/28/91 14:50 Added 2nd arg to cnumber(), 3rd field to XSCN.*/
/*: JV 11/01/91 16:20 Deal with LocalConf vs TrueConfname */
/*: JV 11/05/91 17:28 Add automated code, remove screen def. */
/*: JV 11/06/91 09:56 Move conf creation code to make_conf(). */
/*: CR 11/20/91 13:48 Add "@host" to organizer id. */
/*: CR 11/21/91 17:52 Allow for longer organizer names. */
/*: WC 11/29/91 21:14 Add 3rd arg to cnumber(). */
/*: UL 12/11/91 18:42 Make unit_lock args 3-6 long.*/
/*: CR  1/08/92 12:32 Remove setdecode() call. */
/*: JV  1/15/92 10:57 Add sysdirchk() call to ensure XITX is there. */
/*: CR  8/10/92 17:01 Return confnum. */
/*: JX  3/04/92 13:48 Chixify. */
/*: DE  3/26/92 16:39 Patched chxindex w/ 0, */
/*: DE  5/26/92 13:45 Fix chixification */
/*: JX  5/27/92 11:08 Fix userreg stuff. */
/*: CX  6/05/92 16:05 XKEY --> u_keybd. */
/*: CI 10/07/92 17:38 Chix Integration. */
/*: TP 10/19/92 15:32 Replace unit_read() with input_control(). */
/*: CR 12/07/92 15:48 Rationalize initial userlist; use ulist's. */
/*: CL 12/10/92 15:22 Long chxindex args. */
/*: JZ  9/28/93 15:37 Add file library prompt, storage. */

#include <stdio.h>
#include "caucus.h"
#include "inputcon.h"
#include "unitwipe.h"
#include "derr.h"
#include "chixuse.h"
#include "done.h"

extern struct screen_template  used;
extern Chix                    confname;
extern Chix                    yesnotable, ss_dotnl, ss_caucus;
extern Chix                    ss_inred, ss_inprom;
extern short                   confnum;
extern int                     debug;
extern union  null_t           null;

FUNCTION  costart (auto_confname)
   Chix auto_confname;
{
   static Chix  pubtable, libtable;
   struct namlist_t *nlnode();
   Userreg  a_user, make_userreg();
   short    c;
   int      allopen, like_conf, listed, edit_it, error, v, success, org;
   int      i, errors, library;
   Chix     orgname, host, str, yes, no, userid, format, message;
   Chix    *ulist, *make_ulist();

   ENTRY ("costart", "");

   str     = chxalloc (100L, THIN, "str");
   no      = chxalloc (60L,  THIN, "no");
   yes     = chxalloc (60L,  THIN, "yes");
   host    = chxalloc (100L, THIN, "host");
   format  = chxalloc (80L,  THIN, "format");
   userid  = chxalloc (80L,  THIN, "userid");
   orgname = chxalloc (80L,  THIN, "orgname");
   message = chxalloc (200L, THIN, "message");
   a_user  = make_userreg();
   ulist   = make_ulist();

   /*** Tell the would-be-Organizer what we're about. */
   unit_write (XWTX, NEWCPAGE);
   mdwrite    (XWTX, "cst_Tintro", null.md);

   /*** Prompt the user for the name of the conference, and loop until
   /    an acceptable one is picked. */
   do {
      mdwrite (XWPM, "cst_Tcname", null.md);
      used.width = used.lines = 0;
      input_control (IC_GETLIN | IC_DATA, confname);
      jixreduce  (confname);
      if (sysbrktest())  FAIL;
   } UNTIL (oknewconf (confname));


   /*** Get the Organizer's userid! */
   while (1) {
      c = mdprompter ("cst_Porgid", nullchix, 0, "cst_Horgid", 35,
                      orgname, nullchix);
      if (c <  -2)  FAIL;
      if (c == -2)  continue;
      if (chxtoken (str, nullchix, 2, orgname) == -1)  break;

      mdwrite (XWTX, "cst_Tnotname", null.md);
   }
   jixreduce (orgname);
   if (chxindex (orgname, 0L, CQ("@")) < 0) {
      getmyhost (host);
      chxcat (orgname, CQ("@"));
      chxcat (orgname, host);
   }

   /*** Make sure there is a user directory to contain the temporary
   /    editing file. */
   sysdirchk();

   /*** Should this conference be open for everyone to join? */
   chxtoken (no,  nullchix, 1, yesnotable);
   chxtoken (yes, nullchix, 2, yesnotable);
   allopen = mdprompter ("cst_Pallopen", yesnotable, 2,
                         "cst_Hallopen", 35, str, yes);
   if (allopen <  -2)  FAIL;

   /*** Initialize paragraph 1 of the userlist to empty comments. */
   for (i=2;   i<5;   ++i) {
      ulist[i] = chxalloc (4L, THIN, "costart ulist[i]");
      chxcpy (ulist[i], CQ("#\n"));
   }

   /*** "Open for everyone => ":1.1 include\n *".   Otherwise, ask
   /    if this should be like another conference, and if so, copy
   /    its userlist file. */
   if (allopen)  chxcpy (ulist[2], CQ("*\n"));
   else {

      /*** Permit this conference like another conference? */
      like_conf = mdprompter ("cst_Plike", yesnotable, 2,
                              "cst_Hlike", 35, str, no);
      if (like_conf <  -2)  FAIL;

      /*** If YES, get the name of the conference, and make sure
      /    that it exists. */
      if (like_conf) while (1) {
         if ( (c = mdprompter ("cst_Plikewhat", nullchix, 0, "cst_Hlikewhat",
                                35, str, nullchix)) < -2)  FAIL;
         jixreduce (str);
         if ( (like_conf = cnumber (str, LOCALCONF, &v)) > 0)  break;

         /*** No such conference name. */
         if (like_conf == -1) {
            mdwrite    (XWER, "mai_Enoconf", null.md);
            unit_write (XWER, str);
            unit_write (XWER, ss_dotnl);
         }

         /*** No unique match for conference name. */
         if (like_conf == 0) {
            mdstr   (format, "mai_Eambconf", null.md);
            chxformat (message, format, 0L, 0L, str, nullchix);
            unit_write (XWER, message);
         }
      }

      /*** Load the "other" conference userlist into ULIST. */
      if (like_conf) {
         free_ulist (ulist);
         ulist = make_ulist();
         load_ulist (XCUS, like_conf, ulist, &errors);
      }
   }

   /*** Make this conference LISTED or UNLISTED? */
   mdtable ("cus_Acuspub", &pubtable);
   listed = mdprompter ("cus_Pcuspub", pubtable, 2, "cus_Hcuspub", 20,
                        str, nullchix);
   if (listed < -2)  FAIL;

   /*** Is this a conference or a file library? */
   mdtable ("cus_Acuslib", &libtable);
   library = mdprompter ("cus_Pcuslib", libtable, 2, "cus_Hcuslib", 20,
                        str, nullchix);
   if (library < -2)  FAIL;

   /*** Figure out first unused ":organizer" sub paragraph in ulist. 
   /    That's where we'll put the primary & any additional 2ndary
   /    organizers. */
   for (org=i=5;   i<MAXULIST;   i+=4) {
      if (ulist[i] == nullchix) {
         ulist[i] = chxalloc (40L, THIN, "costart ulist[o]");
         org = i;
         break;
      }
   }

   /*** Always explicitly list the primary organizer in :organizer's. */
   chxcpy    (ulist[org], orgname);
   chxcatval (ulist[org], THIN, L('\n'));

   /*** Add additional organizers? */
   mdwrite  (XWTX, "cst_Paddorg", null.md);
   while (prompter (ss_inprom, nullchix, 0, "cst_Haddorg",
                                80, str, nullchix) >= -1) {
      chxcat    (ulist[org], str);
      chxcatval (ulist[org], THIN, L('\n'));
   }

   /*** Include additional groups? */
   mdwrite  (XWTX, "cst_Paddgrp", null.md);
   while (prompter (ss_inprom, nullchix, 0, "cst_Haddgrp",
                             80, str, nullchix) >= -1) {
      chxcat    (ulist[2], ss_inred);
      chxcat    (ulist[2], str);
      chxcatval (ulist[2], THIN, L('\n'));
   }

   /*** Store the result in a temporary file. */
   store_ulist (0, XITX, ulist);

   /*** Edit the result? */
   edit_it = mdprompter ("cst_Peditxcus", yesnotable, 2, "cst_Heditxcus",
                          60, str, yes);
   /*** Figure out what editor to use: if the current userid exists,
   /    use its SET EDITOR value.  Otherwise, ask the user for
   /    an editor. */
   if (edit_it >  0) {
      sysuserid (userid);
      a_user->briefs = nlnode(1);
      a_user->print  = nlnode(1);
      if (sysudnum (userid, -1, 0) > 0  &&
         loadreg (userid, a_user, NULLSITE)) ;
      else
         edit_it = (mdprompter ("cst_Puseedit", nullchix, 0, "cst_Huseedit",
                                 60, a_user->editor, ss_caucus) >= -1);
   }
   unit_lock (XITX, WRITE, 0L, 0L, 0L, 0L, nullchix);
   if (edit_it >  0)  editfile (XITX, a_user->editor, 1);
   unit_unlk (XITX);
   if (edit_it < -2)  FAIL;

   /*** Tell the user we're trying to create it now... */
   mdstr   (format, "cst_Fworking", null.md);
   chxformat (message, format, 0L, 0L, confname, nullchix);
   unit_write (XWTX, message);

   /*** ...and now we actually create the empty conference. */
   if (NOT make_conf (confname, orgname, listed, library, XITX, &error)) {
      if      (error == DBADDB)     mdwrite (XWER, "err_Ebaddata", null.md);
      else if (error == DMKDIR)     mdwrite (XWTX, "cst_Tmkdir",   null.md);
      FAIL;
   }

   mdwrite    (XWTX, "cst_Tcreat0", null.md);
   unit_write (XWTX, confname);
   mdwrite    (XWTX, "cst_Tcreat1", null.md);
   DONE (confnum);

done:
   chxfree (str);
   chxfree (no);
   chxfree (yes);
   chxfree (host);
   chxfree (format);
   chxfree (userid);
   chxfree (orgname);
   chxfree (message);
   free_userreg (a_user);
   free_ulist   (ulist);
   RETURN (success);
}
