
/*** COPYPROTECT.  Check license & expiration protection.
/
/    Caucus is usually licensed by a unique CPU identifier, or
/    with an expiration date.  COPYPROTECT returns 1 if this
/    is a proper license that hasn't expired.  Otherwise it
/    complains to the user and returns 0. */

/*** Copyright (C) 1987 Camber-Roth..  All rights reserved.  */

/*: AA  7/29/88 17:41 Source code master starting point*/
/*: CW  5/18/89 14:25 Add XW unitcodes. */
/*: DE  3/31/92 12:32 Chixified */
/*: JX  5/27/92 15:19 De-Chixified license. */
/*: CR  1/26/93 15:49 Use PLAIN and strplain() to decrypt license info. */

#include "caucus.h"

extern union  null_t     null;
extern struct license_t  license;

FUNCTION  copyprotect()
{
   Chix   sid;
   short  ok, i;
   long   systime();
   int    success;
   char  *strplain();

   ENTRY ("copyprotect", "");

   sid       = chxalloc (20L, THIN, "copyprot sid");
   success   = 0;

   /*** If the list of allowable sys id's is not empty, make sure that
   /    the current system id is in the list. */
   if (NOT NULLSTR (license.sysid[0])) {
      systemid (sid);
      for (i=ok=0;   NOT NULLSTR(license.sysid[i]);   ++i) {
         if (chxeq (sid, CQ(strplain(license.sysid[i]))))  ok = 1;
      }

      if (NOT ok) { mdwrite (XWER, "sys_Tbadcpu", null.md);   FAIL; }
   }


   /*** If this license doesn't expire, we're OK.  Otherwise, make sure
   /    it hasn't expired, and that the clock hasn't been artificially
   /    set back. */
   if (NOT PLAIN(license.expires))   SUCCEED;

   if (systime() > PLAIN(license.expires)) {
      mdwrite (XWER, "sys_Hexpire", null.md);
      FAIL;
   }

   if (NOT sysclkchk (0)) {
      mdwrite (XWER, "sys_Tbadtime", null.md);
      FAIL;
   }

   SUCCEED;

 done:

   chxfree ( sid );

   RETURN ( success );

}
