
/*** EXPWARN.  Warn user, if desired, about expiration date.
/
/    If this license expires, and either Caucus was invoked with
/    the -w option, or the user had SET EXPIRATION ON, display
/    a warning about when Caucus expires.  */

/*** Copyright (C) 1989 Camber-Roth..  All rights reserved.  */

/*: AA  7/29/88 17:41 Source code master starting point*/
/*: CR  1/17/89 12:16 New function. */
/*: CW  5/18/89 14:25 Add XW unitcodes. */
/*: JV 10/31/91 15:13 Declare sprintf */
/*: DE  3/31/92 12:41 Chixified */
/*: JX  6/06/92 19:50 Add FORMAT arg to sysdaytime(). */
/*: CR  1/26/93 15:49 Use PLAIN and strplain() to decrypt license info. */

#include "caucus.h"

extern union  null_t         null;
extern struct license_t      license;
extern Userreg               thisuser;
extern struct flag_template  flag;

FUNCTION  expwarn()
{
   Chix   expdate, format, newstr;
   Chix   day, time;
   int    success;

   ENTRY ("expwarn", "");

   expdate    = chxalloc (60L, THIN, "expwarn expdate");
   format     = chxalloc (80L, THIN, "expwarn format");
   newstr     = chxalloc (80L, THIN, "expwarn newstr");
   day        = chxalloc (30L, THIN, "expwarn day");
   time       = chxalloc (30L, THIN, "expwarn time");
   success    = 0;

   /*** Only display a warning if the license expires and the user
   /    wants to see the warning. */
   if (PLAIN(license.expires)  &&  (flag.expwarn || thisuser->expwarn)  &&
       mdstr (format, "gen_Fexpwarn", null.md)) {

      sysdaytime (day, time, 0, PLAIN(license.expires));
      chxformat  (expdate, CQ("%s %s"), 0L, 0L, day, time);
      chxformat  (newstr, format, 0L, 0L, expdate, null.chx);
      unit_write (XWAN, newstr);
   }
   SUCCEED;

 done:

   chxfree ( expdate );
   chxfree ( format );
   chxfree ( newstr );
   chxfree ( day );
   chxfree ( time );

   RETURN ( success );
}
