
/*** LOADPRINT.   Load the print codes from file U.
/
/    Loads printcode instructions from file U into the THISUSER.PRINT
/    namelist.  If LOCK is true, LOADPRINT locks and unlocks file U.
/    Otherwise, the caller must handle the locking and unlocking. */

/*** Copyright (C) 1987 Camber-Roth.  All rights reserved. */

/*: AA  7/29/88 17:41 Source code master starting point*/
/*: CR  4/08/91 18:49 Add new unit_lock argument. */
/*: UL 12/11/91 18:42 Make unit_lock args 3-6 long.*/
/*: DE  3/31/92 14:51 Chixified */
/*: DE  6/02/92 11:12 Added maxlen arg to unit_read */

#include "caucus.h"

extern union null_t       null;

FUNCTION  loadprint  (print, u, lock)
   struct namlist_t **print;
   int    u, lock;
{
   struct namlist_t *nlnode();
   Chix   str;
   int    success;

   ENTRY ("loadprint", "");

   str      = chxalloc (160L, THIN, "loadprin str");
   success  = 0;

   nlfree (*print);
   *print = nlnode (4);

   if (lock  &&  NOT unit_lock (u, READ, 0L, 0L, 0L, 0L, null.chx)) FAIL;

   if (NOT unit_view (u)) {
      if (lock)  unit_unlk (u);
      FAIL;
   }

   while (unit_read (u, str, 0L))  nlcat (*print, str, 0);

   unit_close (u);
   if (lock)  unit_unlk (u);
   SUCCEED;

 done:

   chxfree ( str );

   RETURN ( success );   
}
