/*** CHXINSIDE.   Find a pattern inside two boundary strings.
/
/    Search CHXA for the substring bounded by the one-character strings
/    LEFT and RITE.  Return the substring in MATCH.  If the boundaries
/    were found, return the position at which LEFT was found.  If the
/    boundaries were not found, return -1. */

/*** Copyright (C) 1992 Camber-Roth.  All rights reserved. */

/*: JX  5/19/92 13:28 Create function. */
/*: CL 12/11/92 13:47 Long Chxvalue N. */

#include "caucus.h"

FUNCTION chxinside (chxa, left, match, rite)
   Chix  chxa, left, match, rite;
{
   int    i, j, clen;
   long   leftval, riteval, charj;

   ENTRY ("chxinside", "");

   leftval = chxvalue (left, 0L);
   riteval = chxvalue (rite, 0L);
   clen    = chxlen (chxa);

   /*** Find the first occurence of LEFT. */
   for (i=0; chxvalue (chxa, L(i)) != leftval && i<clen; i++) ;
   if  (i >= clen)  RETURN (-1);

   chxclear (match);
   /*** Scan until RITE is found, copying into MATCH all the while. */
   for (j=i+1;  chxvalue (chxa, L(j)) != riteval && j<clen;   j++) {
      charj = chxvalue (chxa, L(j));
      chxcatval (match, jixwidth (charj), charj);
   }

   if    (j >= clen)  RETURN (-1)
   else               RETURN (i)
}
