/******************************************************************
*	FILE: cli_work_around.h
*
*   problem:  When executing a "system("x cli.pr"); an error will
*		occur when exiting cli.pr. This problem has been
*		str'd a few times.
*   WORKAROUND: The following program isues a ?proc system call that
*		can be used in place of the previous command.
*
*
*	Function description:
*
*	-->to execute a command-->   cli("command");
*		or
*	-->to execute a command-->   gets( command );
*				     cli( command );
*
*	-->to execute a cli    -->   cli(NULL);
*
*
*	RETURNS:	0 = no error;
*			-1 = error , SYSTEM CALL FAILED.
*
*
*******************************************************************/

/*: CP 11/30/93 13:19 1st carvmark. */

#include <stdio.h>
#include <sys_calls.h>
#include <paru.h>
#include <packets:process.h>

int  cli(char *mess);		/* proto-type */

P_ISEND isend;
P_PROC   procpkt;		/* proc PACKET */
P_IREC irec;

int ac0, ac1, ac2, *rac0, *rac1, *rac2, error;
int pid_num;
int *pktaddr;

/*****************************************************************
*   EXAMPLE of useage;
*
*	see do_cli.c for a example of the workaround
*
*
*	#include "cli_work_around.h"
*
*	#include <stdio.h>
*	void main(void);
*
*	void main()
*	{
*
*		char command[80];
*
*		if(cli("write hello"))
*			perror("cli error");
*		printf("Back in program after cli(command)\n");
*		if(error = cli(NULL)) {
*			perror("cli error");
*			exit(1);
*		}
*		printf("Back in program after cli(NULL)\n");
*	
*		gets( command );
*		if(cli( command ))
*			perror("cli error");
*
*	}
********************************************************************/

int  cli(char *mess)
{

	char mess1[256];
	char file[] = ":cli.pr";
	memset(mess1,0,256);
	if(mess != NULL) {
		strcat(mess1,"class(1,2) abort;");
		strcat(mess1,mess);
		strcat(mess1,";bye/l=@null");
	}
	ac2    =  &procpkt;
	isend.isfl = 0;
	isend.iufl = 040000;		/* was $RFCF; */
	isend.idph = 0;
	isend.iopn = 0;
	isend.ilth = strlen(mess1);
	isend.iptr = mess1;

	procpkt.pflg = $PFEX; 		/* !pfxp = no extension packet*/
					/* pfex = block father */
	procpkt.ppri = -1;		/* default priority */
	procpkt.psnm = file;		/* byte pointer to filename */
	procpkt.pipc = &isend;   	/* argument message to send */
	procpkt.pnm = -1;		/* process name */
	procpkt.pmem = -1;		/* -1 defa logical pages */
	procpkt.pdir = -1;		/* working directory */
	procpkt.pcon = -1;		/* @console		*/
	procpkt.pcal = -1;		/* max num system calls for son */
	procpkt.pwss = -1;		/* sons max working set size */
	procpkt.punm = -1;		/* sons username */
	procpkt.pprv = -1; 		/* sons privileges */
	procpkt.ppcr = -1;		/* max number of sons */
	procpkt.pwmi = -1;		/* min working set size */
	procpkt.pifp = -1;		/* @input */
	procpkt.plfp = -1;		/* @list */
	procpkt.pofp =  -1;      	/* @output  -1 for out to con */
	procpkt.pdfp =  -1;		/* @data */
	procpkt.smch = -1;		/* min cpu time allocated to son */
	rac1 = &pid_num;

	if(sys_proc(ac2,rac1) )
		return( 127 );		/* cli could not be inited */
	else {
		memset(mess1,0,256);
		irec.ilth = sizeof( mess1 );
		irec.iptr = mess1;
		irec.ioph = $SPTM;
		irec.isfl = $IFNBK;
		ac0 = ac1 = 0;
		ac2 = (int) &irec;
		if( sys($IREC,&ac0,&ac1,&ac2) == 0)
		   return( (irec.iufl & ($RFAB | $RFER | $RFWA)) ? 1: 0);
		else
			return( 2 );
	}
}

