
/*** ENTRYEX.H.  Entry and Exit macros used for doing our own
/    stack tracing. */
 
/*** Copyright (C) 1989 Camber-Roth.  All rights reserved.  */

/*: CR  7/01/91 21:25 New file. */
/*: CR  7/29/91 23:49 Add ENTRYCHECK stuff. */
/*: JV  9/08/93 09:57 Add ENTRYLOG. */

/*** ENTRY/EXIT test control.  If 1, entry_test() gets called on entry to
/    every function, and exit_test() on return from every function. */
#ifndef ENTRYEXIT
#define ENTRYEXIT    0
#define ENTRYCHECK   1    /* Use compiler to ensure ENTRY/RETURN pairs. */

/* ENTRYLOG logs entry/exit points to a file, does *not* print to screen. */
#define ENTRYLOG     0

#if ENTRYEXIT & ENTRYCHECK
#define ENTRY(x,y)       int entry_check;  entry_test(x,y)
#define RETURN(z)     {  exit_test();      entry_check;       return(z); }
#endif

#if ENTRYEXIT & (! ENTRYCHECK)
#define ENTRY(x,y)       entry_test(x,y)
#define RETURN(z)     {  exit_test();                         return(z); }
#endif

#if ! ENTRYEXIT
#define ENTRY(x,y)
#define RETURN(z)     {                      return(z); }
#endif

#endif
