
/*** LICENSE.H.   Definitions for Caucus "license" structure(s).
/
/    The Caucus license structure controls use and capabilities of
/    Caucus at run-time: system ids, expiration date, function_mask
/    capabilities, etc.
/ */

/*** Copyright (C) 1990 Camber-Roth.  All rights reserved. */

/*: CR  7/01/91 23:23 New file. */
/*: CR 11/20/92 13:42 Add FM_COPYR. */
/*: CR  1/26/93 15:14 Add include plain.h. */
/*: CR  2/03/93 13:47 Add FM_CRCOPY bit. */
/*: CK 10/13/93 17:23 Add confmax, itemmax, respmax. */

#ifndef LICENSE_H
#define LICENSE_H

#include "plain.h"

/*** Caucus license structure. */
struct liceblk_t {
   char   locator[8];
   long   expires;
   long   maxusers;
   long   function_mask;
   long   confmax;    /* Max # of conferences. */
   long   itemmax;    /* Max # of items / conference. */
   long   respmax;    /* Max # of resp's / item. */
   long   reserve1;
   long   reserve2;
   long   bulk[68];
};

struct license_t {
   char   locator[8];
   long   expires;
   long   maxusers;
   long   function_mask;
   long   confmax;
   long   itemmax;
   long   respmax;
   long   reserve1;
   long   reserve2;
   char   serial[16];
   char   sysid[16][16];
};

/*** Definitions of mask bits for license_t.function_mask. */
#define   FM_CMI    0x0001   /* Allow use of CMI features. */
#define   FM_DIST   0x0002   /* Write xaction files for CaucusNet. */
#define   FM_COPYR  0x0004   /* 1=>display copyright, 0=>don't. */
#define   FM_CRCOPY 0x0008   /* 1=>display credit copyright. */

#endif
