
/*** SYSINIT.H.   Definition of SYSINIT and SYSPUT macros.
/
/    The SYSINIT macro occurs at the very beginning of the Caucus
/    main program.  It is used to insert system-dependent declarations
/    and code that **must** come before anything else.
/
/    The SYSPUT macro displays text on the user's terminal, prior
/    to any initialization of the Caucus output display code.  It
/    is only used for debugging purposes early in the Caucus main
/    program.  */

/*: AA  7/29/88 17:47 Source code master starting point */
/*: JV  8/01/88 13:40 Added AOS code.*/
/*: CR 10/12/88 13:03 Add "CX" type to SYSINIT definition. */
/*: CR 11/09/88 15:20 Remove VM, add CA and CVM. */
/*: CR  4/21/89 16:04 CVM: add _staksize defn to go in main(). */
/*: CW  5/18/89 14:54 Add PX system type code. */
/*: CR  1/29/90 16:44 Add hangup (logout) detection for Primos. */
/*: CR  9/21/90 14:07 Add PS system type. */
/*: CR  9/25/90 15:38 Add SYSPUT macro definition. */

#if UNIX | IM | JM | PN | PR | VV | AOS | CX | CA | PX | PS
#define  SYSINIT
#define  SYSPUT(x)   sysputstr(x)
#endif
 
#if PR
/*** Detect interrupt (^P or break is QUIT) and logout (hangup). */
#define    INIT1   extern sysbrk2(), syshang();   fortran mkon$p()
#define    INIT2   short  quitlen=5, logolen=7
#define    INIT3   mkon$p ("QUIT$",   &quitlen, sysbrk2)
#define    INIT4   mkon$p ("LOGOUT$", &logolen, syshang)

#define SYSINIT    INIT1;   INIT2;   INIT3;   INIT4
#define SYSPUT(x)   sysputstr(x)
#endif

#if CVM
const int _staksize = (25 * 1024);
#define  SYSINIT
#define  SYSPUT(x)   _errdisp (x)
#endif
