
/*** VWIN.   Caucus VM Windows.  Definition of system-dependent window stuff. */

/*: CR  2/05/90 13:57 Definition of Caucus VM windows. */
/*: CR  3/27/90 10:32 CVM: add highbold to vwin_t. */
/*: CR  9/21/90 14:04 Add PS system type. */
/*: CR  9/26/90 11:14 Make Lint happy about 'screen'. */

#ifndef FUNCTION
#define FUNCTION
#endif

#ifndef NOT
#define NOT  !
#endif

/*** Values of window status. */
#define  VW_NONE    0
#define  VW_MADE    1
#define  VW_OPEN    2

#define  VW_OBSIZE  10   /* Max # windows a window may obscure. */

#if PS
/*** Sys V curses.h on the Sun does a typedef using an undefined
/    struct called 'screen'--which drives Lint crazy.  So we 
/    define one. */
struct screen {char junk;};
#endif

#if PX | PS
#include <curses.h>
#endif

#if CVM
#include <pnldattr.h>
#include <pnls.h>
#include <pnlw.h>
#include <pnlf.h>
#include <pfkeys.h>
#endif


/*** Definition of window_frame. */
struct frame_t {
   short  col0;
   short  row0;
   short  cols;
   short  rows;
};
typedef struct frame_t window_frame;

/*** Max size of window frames. */
#define  FRAME_ROW_MAX  24
#define  FRAME_COL_MAX  80

/*** Basic window structure: the VWIN. */
typedef struct vwin_t vwin;

struct vwin_t {
   char          status;  /* Status of window: open, made, etc. */
   window_frame  frame;   /* Window frame. */
#if PX | PS
   WINDOW  *win;      /* Pointer to curses window. */
   char   **text;     /* Array of ptrs to lines of text. */
   vwin    *obscures[VW_OBSIZE];  /* Array of windows this window obscures. */
   char     changed;  /* Has this window been changed since last refresh? */
#endif
#if CVM
   void    *win;      /* Actual panel window. */
   int      f0;       /* Number of first field used by window. */
   int      highbold; /* Number of highest bold row. */
#endif
   int      lines;    /* Number of lines stored in TEXT. */
   int      top;      /* Number of line displayable at top of window. */
   int      curline;  /* Current line to add text to. */
   int      curcol;   /* Current col. to add text to. */
   char     canedit;  /* This is an editable window. */
   char     name[20]; /* Ascii name for this window. */
};



/*** Nullptr is a struct of various null pointers to keep Lint happy. */
struct vwnull_t {
   vwin    *w;
#if PX | PS
   WINDOW  *win;
#endif
#if CVM
   void    *win;
#endif
};
typedef struct vwnull_t nullptr;

