
/*** SHOWLICENSE.   Display the Caucus license information. */

/*: XX 11/30/91 17:12 Change release date string to 30-NOV-91. */
/*: JV 12/20/91 17:38 Change release date string to 20-DEC-91. */
/*: CR  1/01/92 15:21 Change release date string to  1-JAN-92. */
/*: JV  1/20/92 17:45 Change release date string to 20-JAN-92. CauLink 1.1 */
/*: JX  5/27/92 16:41 Chixify. */
/*: JX  8/01/92 11:11 Change release date string to  1-AUG-92. */
/*: CI 10/05/92 15:54 Chix Integration. */
/*: CR 10/09/92 18:20 Change release date string to 31-OCT-92. */
/*: CR 11/24/92 11:44 Change release date string to 26-NOV-92. */
/*: CR 12/16/92 16:14 Change release date string to 25-DEC-92. */
/*: CR  1/26/93 15:49 Use PLAIN and strplain() to decrypt license info. */
/*: CR  2/01/93 15:33 Change release date string to  1-JAN-93. */
/*: CP  3/07/93 13:48 Change release date string to  1-MAR-93. */
/*: JV  6/01/93 14:16 Change release date string to  1-JUN-93. */
/*: CK 10/13/93 17:43 Add confmax, itemmax, respmax display. */
/*: CR 10/17/93 17:21 Change release date string to  1-NOV-93. */
/*: CR 12/22/93 15:14 Change release date string to  1-JAN-94. */
/*: CR  5/05/94 13:48 Change release date string to  1-MAY-94. */

#include <stdio.h>
#include "caucus.h"

extern struct license_t license;
extern union  null_t    null;

FUNCTION  showlicense (usedic)
   int    usedic;
{
   short  i, any;
   long   maxusers, systime();
   char   temp[100];
   Chix   str, mtu, format;
   Chix   day, time;
   char  *strplain();

   ENTRY ("showlicense", "");

   mtu    = chxalloc (80L, THIN, "showlice mtu");
   str    = chxalloc (20L, THIN, "showlice str");
   format = chxalloc (40L, THIN, "showlice format");
   day    = chxalloc (30L, THIN, "showlice day");
   time   = chxalloc (30L, THIN, "showlice time");

   sysversion (XWTX, usedic);
   if (usedic)       usedic = mdstr (mtu, "lic_Trelease", null.md);
   if (NOT usedic)   chxcpy         (mtu, CQ("Release date : "));
   unit_write (XWTX, mtu);
   unit_write (XWTX, CQ(" 1-MAY-94\n"));

   /*** Tell user which system this is. */
   if (NOT usedic  ||  NOT mdstr (format, "lic_Fsystem", null.md))
          chxcpy (format, CQ("This system  : %s\n"));
   systemid (str);
   chxclear   (mtu);
   chxformat  (mtu, format, 0L, 0L, str, nullchix);
   unit_write (XWTX, mtu);

   /*** Tell user which systems this Caucus is licensed for. */
   if (NOT usedic  ||  NOT mdstr (mtu, "lic_Tfor", null.md))
       chxcpy (mtu, CQ("Licensed for : "));
   unit_write (XWTX, mtu);
   for (any=1, i=0;    NOT NULLSTR (license.sysid[i]);   ++i) {
      unit_write (XWTX, CQ(strplain(license.sysid[i])));
      unit_write (XWTX, CQ("\n               "));
      any = 0;
   }
   if (any) {
      if (NOT usedic  ||  NOT mdstr (mtu, "lic_Tany", null.md))
         chxcpy (mtu, CQ("(any)"));
      unit_write (XWTX, mtu);
   }
   unit_write (XWTX, CQ("\n\n"));

   /*** Tell user serial code of this Caucus. */
   if (NOT usedic  ||  NOT mdstr (format, "lic_Fcode", null.md))
          chxcpy (format, CQ("Serial code  : %s\n"));
   chxclear   (mtu);
   chxformat  (mtu, format, 0L, 0L, CQ(strplain(license.serial)), nullchix);
   unit_write (XWTX, mtu);

   /*** Tell user max number of simultaneous users allowed. */
   if (NOT usedic  ||  NOT mdstr (format, "lic_Fmaxu", null.md))
          chxcpy (format, CQ("Max. users   : %d\n"));
   chxclear  (mtu);
   maxusers = PLAIN(license.maxusers);
   chxformat (mtu, format, maxusers ? maxusers : 9999L, 0L,
              nullchix, nullchix);
   unit_write (XWTX, mtu);

   /*** Tell user about Conf/Item/Resp maximums. */
   if (NOT usedic  ||  NOT mdstr (mtu, "lic_Tmaxcri", null.md))
       chxcpy (mtu, CQ("Max Cnf/It/Re: "));
   unit_write (XWTX, mtu);
   sprintf (temp, "%4ld %5ld %5ld\n", PLAIN(license.confmax), 
              PLAIN(license.itemmax), PLAIN(license.respmax));
   unit_write (XWTX, CQ(temp));

   /*** Tell user about function mask. */
   if (NOT usedic  ||  NOT mdstr (mtu, "lic_Tfuncmask", null.md))
       chxcpy (mtu, CQ("Function Mask: "));
   unit_write (XWTX, mtu);
   chxclear (mtu);
   chxformat    (mtu, CQ("%08x\n"), PLAIN(license.function_mask), 0L,
                 nullchix, nullchix);
   unit_write (XWTX, mtu);

   /*** Tell user current time... */
   if (NOT usedic  ||  NOT mdstr (mtu, "lic_Tnow", null.md))
      chxcpy (mtu, CQ("It is now    : "));
   unit_write (XWTX, mtu);
   sysdaytime(day, time, 0, systime());
   chxclear  (mtu);
   chxformat (mtu, CQ("%s %s"), 0L, 0L, day, time);
   unit_write (XWTX, mtu);

   /*** ... and when this license expires. */
   if (NOT usedic  ||  NOT mdstr (format, "lic_Texpire", null.md))
          chxcpy (format, CQ("\nExpires      : %s\n\n"));
   if      (PLAIN(license.expires))  {
      sysdaytime (day, time, 0, PLAIN(license.expires));
      chxclear   (str);
      chxformat  (str, CQ("%s %s"), 0L, 0L, day, time);
    }
   else if (usedic  &&  mdstr (str, "lic_Tnever", null.md));
   else   chxcpy  (str, CQ("(never)"));
   chxclear  (mtu);
   chxformat (mtu, format, 0L, 0L, str, nullchix);
   unit_write (XWTX, mtu);

   chxfree (mtu);
   chxfree (str);
   chxfree (format);
   chxfree (day);
   chxfree (time);

   RETURN (1);
}
