
/*** MESSDISP.  Dispose of message M as the user desires. 
/
/    MESSDISP asks the user what to do with the current message.
/    Choices are:
/       Forward a copy to another person
/       Delete  the message
/       Reply   to the sender
/       New     to mark the message as NEW
/       Stop    and return to AND NOW?
/       -1      to reread this message
/       n       to see message number n next.
/
/    MESSDISP returns:
/       -1      finished, return to AND NOW?
/       0       examine "next" message
/       n       examine message 'n' next. */

/*** Copyright (C) 1987 Camber-Roth.  All rights reserved. */

/*: AA  7/29/88 17:48 Source code master starting point */
/*: CR  9/02/88 15:10 Change call to getmline() to 4 arguments. */
/*: CW  5/18/89 15:07 Add XW unit codes. */
/*: CR  4/24/90 21:17 Add 3rd arg to mess_send() calls. */
/*: CR  7/16/91 12:05 Use address argument in mess_send(). */
/*: CR  7/24/91 21:46 Make Lint happier. */
/*: DE  3/26/92 14:39 Chixified */
/*: DE  4/21/92 15:56 Dereferenced Address type variables */
/*: JX  5/27/92 16:51 Declare make_address(). */
/*: JX  6/23/92 17:18 Allocate format. */
/*: CN  5/15/93 21:02 Make 'flags' short. */
/*: CK  9/20/93 13:56 Add run_prompt_macro() call. */

#include <stdio.h>
#include "caucus.h"

extern Userreg       thisuser;
extern Chix          confname;
extern union null_t  null;

FUNCTION  messdisp (m, highest, flags)
   int    m, highest;
   short  flags[];
{
   static  Chix mesdisptab;
   short   choice, promptok;
   long    num;
   int     success;
   Address address, make_address();
   Chix    answer, prompt, id, pass, format, newstr;
   Chix    getmline();

   ENTRY ("messdisp", "");

   id        = chxalloc (40L, THIN, "messdisp id");
   pass      = chxalloc (30L, THIN, "messdisp pass");
   newstr    = chxalloc (84L, THIN, "messdisp newstr");
   answer    = chxalloc (14L, THIN, "messdisp answer");
   format    = chxalloc (80L, THIN, "messdisp format");
   prompt    = chxalloc (80L, THIN, "messdisp prompt");
   address   = make_address();
   success   = 0;

   mdtable  ("mes_Adisp", &mesdisptab);
   chxtoken (pass, null.chx, 6, mesdisptab);

   promptok = 0;
   while (1) {

      /*** Handle prompts of ANY size efficiently. */
      if (promptok)  chxcpy (newstr, prompt);
      else {
         mdstr   (format, "mes_Fdisp", null.md);
         chxformat (newstr, format, L(m), 0L, null.chx, null.chx);
         if (chxlen (newstr) < 80) { chxcpy (prompt, newstr);   promptok = 1; }
      }

      run_prompt_macro ("mes_Fdisp", thisuser->dict, confname);
      choice = prompter (newstr, mesdisptab, 1, "mes_Hdisp", 10, answer, pass);
      switch (choice) {
         case (-4):
         case (-3):
         case ( 3):  DONE(-1);

         case ( 5):  FAIL;

         case (-1):
            chxnum (answer, &num);
            if (num == -1)  DONE(m);
            if (num>0  &&  num<=highest) {
               sysuserid (id);
               if (getmline (id, (int) num, 1, 1) != null.chx)
                  DONE((int) num);
            }
            mdwrite (XWER, "mes_Tnomess", null.md);
            break;

         case ( 0):  mess_send  (m, MFORWARD, address);    break;

         case ( 1): 
            mdwrite (XWAN, "mes_Tdeld", null.md);
            flags[m] |= MSG_DEL;
            FAIL;

         case ( 2):  mess_send  (m, MREPLY, address);      break;

         case ( 4):  flags[m] |= (MSG_MLN | MSG_NEW);       break;
      }
    }

   /*NOTREACHED*/
   SUCCEED;

 done:

   free_address (address);
   chxfree ( answer );
   chxfree ( prompt );
   chxfree ( id );
   chxfree ( pass );
   chxfree ( newstr );

   RETURN ( success );
}
