/* DO_PEOPLE: Print out the menu of things you can do to a person,
/      and then do the bidding of the manager.
/
/  void do_people ()
/
/  Purpose:
/    NetMaint handles various management tasks for the manager.  One of
/    these is managing people.  The manager can create, display, and
/    remove people.
/
/    This function prints out the menu of the actions that can be performed
/    on a person, and takes an appropriate action depending on the choice.
/
/  How it works:
/    Q.E.D.
/
/  Returns:
/    No return value.
/
/  Error conditions:
/    Each "action function" that do_people calls takes care of reporting
/    problems.
/
/  Related functions: do_naybor(), do_conf().
/
/  Called by: netmaint (main).
/
/  Home: netmaint/dopeople.c
/
/  Dictionary strings:
/    net_Fbadchoice:
       "You must choose a number from the menu.
        %d is not one of those choices."
*/

/*: JV 10/28/91 17:03 Creat (sic) this. */
/*: JV 11/19/91 16:35 Help user input. */
/*: CR 11/25/91 14:10 Fix mdwrite() calls. */
/*: DE  4/09/92 14:40 Chixified */
/*: JX  8/07/92 11:44 Add add_person(), fixify. */
/*: CR 10/11/92 13:12 Check return value from chxnum(). */

#include <stdio.h>
#include "handicap.h"
#include "netmaint.h"
#include "unitcode.h"
#include "caucus.h"

extern union null_t null;

FUNCTION do_people()
{
   long  choice;
   int   ok;
   short finished=0;
   Chix  str, str2, format;
   int   success;

   ENTRY ("do_people", "");

   str     = chxalloc (200L, THIN, "dopeople str");
   str2    = chxalloc (200L, THIN, "dopeople str2");
   format  = chxalloc (200L, THIN, "dopeople format");
   success = 0;

   while (NOT finished) {
      print_menu (NM_NAYBOR);
      ok = mdprompter ("net_Pchoose", nullchix, 0, "net_Hchoose", 60, str,
                        nullchix);
      if (ok < -2)  FAIL;
      if (ok == 0) {mdwrite (XWTX, "net_Hchoose", null.md); continue; }

      if (NOT chxnum (str, &choice))  choice = -1L;

      switch (choice) {
         case 0: finished=1;              break;
         case 1: if (add_person())    break; else continue;
/*       case 2: if (disp_person())   break; else continue;
         case 3: if (remove_person()) break; else continue;
*/    default:
         mdstr (format, "net_Fbadchoice", null.md);
         chxformat (str2, format, 0L, 0L, str, nullchix);
         unit_write (XWTX, str2);
      }
   }

   SUCCEED;

 done:

   chxfree ( str );
   chxfree ( str2 );
   chxfree ( format );

   RETURN ( success );
}

