/* PRINT_MENU: Print out a menu.
/
/  print_menu (menu_code)
/
/  Parameters:
/     short menu_code;
/
/  Purpose:
/    This function prints out a string of text depending on its input.
/    Symbols for MENU_CODE are defined in netmaint.h.
/
/  How it works:
/    Q.E.D.
/
/  Returns: 1.
/
/  Error conditions:
/    Nothing can go wrong...
/
/  Called by: do_conf, do_naybor, do_people, netmaint (main).
/
/  Home: netmaint/doconf.c
/
/  Dictionary strings:
/    net_Mmain:   the menu of choices for objects you can manage
/    net_Mnaybor: the menu of things you can do to a naybor
/    net_Mconf:   the menu of things you can do to a conference
/    net_Mpeople: the menu of things you can do to a person
*/

/*: JV 10/27/91 17:32 Creat (sic) this. */
/*: JX  5/15/92 11:50 Chixify. */

#include <stdio.h>
#include "handicap.h"
#include "netmaint.h"
#include "unitcode.h"
#include "chixuse.h"
#include "null.h"

extern union null_t null;

FUNCTION print_menu (menu_code)
   short menu_code;
{
   ENTRY ("print_menu", "");
      switch (menu_code) {
         case NM_MAIN:   mdwrite (XITT, "net_Mmain",   null.md); break;
         case NM_NAYBOR: mdwrite (XITT, "net_Mnaybor", null.md); break;
         case NM_CONF:   mdwrite (XITT, "net_Mconf",   null.md); break;
         case NM_PEOPLE: mdwrite (XITT, "net_Mpeople", null.md); break;
      }
   RETURN (1);
}
