
/*** MODDATE.   Modify a datemap namelist file entry.
/
/    moddate (action, ud, uf, cnum, item, date, time, value);
/
/    Parameters:
/       int       n;         (success?)
/       int       action;    (1=add entry, 0=delete entry)
/       int       ud, uf;    (namelist file unit numbers)
/       int       cnum;      (conference number)
/       long      item;      (item number, if relevant)
/       Chix      date;      (string form of date)
/       Chix      time;      (string form of time)
/       long      value;     ("value" part of namelist entry)
/
/    Purpose:
/       Add or delete an entry from a datemap namelist file.
/
/    How it works:
/
/    Returns: 1 on success
/             0 on error (modnames fails)
/
/    Error Conditions:
/  
/    Side effects:
/
/    Related functions:
/
/    Called by:  chgdresp(), chgditem()
/
/    Operating system dependencies: None.
/
/    Known bugs:
/
/    Home:  people/moddate.c
/ */

/*** Copyright (C) 1993 Camber-Roth.  All rights reserved. */

/*: CP  5/10/93 23:35 New function. */

#include <stdio.h>
#include "caucus.h"

FUNCTION  moddate (action, ud, uf, cnum, item, date, time, value)
   int    action, ud, uf, cnum;
   long   item;
   Chix   date;
   Chix   time;
   long   value;
{
   Namelist add, del, nlnode(), nlnames();
   Chix     abstime, entryval;
   char     temp[100];
   long     time_of_date(), time_of_hour();
   int      success;

   abstime  = chxalloc (20L, THIN, "moddate abstime");
   entryval = chxalloc (20L, THIN, "moddate entryval");

   sprintf (temp, "%010ld", time_of_date (date, nullchix) +
                            time_of_hour (time));
   chxcpy  (abstime, CQ(temp));

   sprintf (temp, "%04ld", value);
   chxcpy  (entryval,  CQ(temp));

   if (action) { add = nlnames (abstime, entryval);    del = nlnode (1); }
   else        { del = nlnames (abstime, entryval);    add = nlnode (1); }

   success = modnames (ud, uf, nullchix, cnum, item, add, del, NOPUNCT);

   nlfree  (add);
   nlfree  (del);
   chxfree (abstime);
   chxfree (entryval);

   return  (success);
}
