
/*** FREE_MASTER.   Deallocate a "master" structure made by make_master().
/
/    free_master (master);
/
/    Parameters:
/       struct master_template *master;     (ptr to master struct)
/
/    Purpose:
/       Deallocate the heap memory used by MASTER.
/
/    How it works:
/
/    Returns: 1 
/
/    Error Conditions:
/  
/    Side effects:
/
/    Related functions:  clear_master(), make_master().
/
/    Called by:
/
/    Operating system dependencies:
/
/    Known bugs:
/
/    Home:  resp/freemast.c
/ */

/*** Copyright (C) 1991 Camber-Roth.  All rights reserved.  */

/*: CR 11/14/91 11:08 New function. */
/*: CR 11/18/91 17:46 Cast sysfree arg. */
/*: JX  6/16/92 16:41 Free organizerid. */
/*: JV 11/17/92 17:32 Change orighost from Chix to short. */
 
#include <stdio.h>
#include "caucus.h"

FUNCTION  free_master (m)
   struct master_template *m;
{
   ENTRY ("free_master", "");

   sysfree ( (char *) m->responses);
   sysfree ( (char *) m->orighost);
   sysfree ( (char *) m->origitem);
   if (m->organizerid != nullchix) chxfree (m->organizerid);

   clear_master (m);

   RETURN  (1);
}
