
/*** STRSCAN.   Scan a string for an integer.
/
/    STRSCAN is handed S, a pointer to a pointer to a character string.
/    It scans through the string by incrementing *S, until it runs
/    out of digits.  The long integer equivalent to the digits it scanned
/    is RETURNed as the result.   STRSCAN will skip leading blanks. */

/*** Copyright (C) 1984 Camber-Roth.  All rights reserved.  */

/*: AA  7/29/88 17:53 Source code master starting point */
/*: CR 11/03/88 14:10 Change name on copyright. */
/*: JV  2/07/89 15:41 Added check for null pointer. */

#include "caucus.h"

FUNCTION  long  strscan (s)
   char **s;
{
   long  result;
   char *p;

   ENTRY ("strscan", "");

   /*** Skip over leading blanks.  If the first non-blank char is NOT
   /    a digit, restore S to its original value.  (The caller will know
   /    that this means ERROR. */
   if (NOT *s) RETURN (-1L);     /* Pointed to 0. Bad! */
   p = *s;
   while (**s == ' ')     ++*s;
   if (NOT cf_digit (**s))  {  *s = p;   RETURN (0); }

   result = 0;
   while  (cf_digit (**s))  result = 10L * result + cf_value (*(*s)++);

   RETURN (result);
}
