
/*** SYSCANCEL.   Tell user what key is <CANCEL>. */

/*** Copyright (C) 1985 Camber-Roth.  All rights reserved. */

/*: AA  7/29/88 17:44 Source code master starting point */
/*: CR  9/21/88 15:25 Add "HU" system type for HP/UX. */
/*: CR  9/23/88 13:00 Add "IX" system type. */
/*: CR 11/02/88 16:07 Add CX (server) to SX code. */
/*: JV 12/07/88 10:32 Added CA code. */
/*: CR  1/06/89 16:12 CVM changes only. */
/*: CR  1/09/89 14:21 Make CVM like rest, but use sys_Tcancms. */
/*: CR  6/09/89 12:16 Add "SV" system type code. */
/*: CW  5/08/89 15:17 Add PX system code. */
/*: JV 10/04/89 17:48 Stripped out AOS non-server code. */
/*: CR 10/12/89 15:35 Add DU system type code. */
/*: JV  7/06/90 20:33 Add MIPS RISC/os (RO). */
/*: CR  9/20/90 17:03 Add PS system type. */
/*: CR  9/27/90 12:19 Add U3, AU system types. */
/*: CJ 11/26/90 21:50 Add LA system type code. */
/*: CR 12/13/90 17:54 Detect ioctl failure. */
/*: SB 11/29/90 14:04 Add DY system code*/
/*: CR  3/11/91 14:15 Add AX and UL system type codes. */
/*: SB 12/03/91 18:27 Add DP code. */
/*: JV  7/16/92 15:25 Add U4, move include files. */
/*: CR  7/21/92 17:39 Remove DP (in favor of DYP). */
/*: CI 10/07/92 13:51 Chix Integration. */
/*: CR 10/21/92 15:15 Remove extra "}" in SYSV code. */
/*: CR 10/21/92 17:24 Use "NOT chxtype()..." */
/*: CR 10/22/92 16:24 Promote chxcatval last arg to long. */

#include <stdio.h>
#include "caucus.h"
#include "systype.h"

#define SYSV1  A3 | LA | SV | HU | MU | MV | PU | SX | IX | CX | DU | RO
#define SYSV2  U3 | AU | DY | AX | U4

#if SYSV1 | SYSV2
#include <termio.h>
#endif

#if FU | BU | TX | SU | UL
#include <sgtty.h>
#endif

extern union null_t null;

FUNCTION  Chix syscancel()
{
   static Chix cancel;

 /*------------------------------Data General-----------------------*/
#if CA
    if (NOT chxtype (cancel)) 
      cancel = chxalloc (30L, THIN, "syscance cancel");  /* STATIC */

    if (EMPTYCHX (cancel))
       mdstr (cancel, "sys_Tcanaos", null.md);
 
#endif

/*---------------------------------------FORTUNE-------------------------*/
#if FU | BU | TX | SU | UL
   struct tchars  a;
   Chix   control;
   Chix   chx_t_intrc;

   ENTRY ("syscancel", "");

   if (NOT chxtype(cancel))
      cancel = chxalloc (30L, THIN, "syscance cancel");  /* STATIC */

   control     = chxalloc (30L, THIN, "syscance control");
   chx_t_intrc = chxalloc (5L,  THIN, "syscance chx_t_intrc");

   if (EMPTYCHX (cancel)) {
      if (ioctl (0, TIOCGETC, &a) < 0)  a.t_intrc = 0;

      if      (a.t_intrc == 0177)   mdstr (cancel, "sys_Kdel", null.md);

      else if (a.t_intrc <   040) {
         mdstr   (control, "sys_Kctrl", null.md);
         chxcatval (chx_t_intrc, THIN, L(0100 + a.t_intrc));
         chxformat (cancel, CQ("%s%s"), 0L, 0L, control, chx_t_intrc);
      }

      else  {
         chxcatval (chx_t_intrc, THIN, L(0100 + a.t_intrc));
         chxformat (cancel, CQ("'%s'"), 0L, 0L, chx_t_intrc, nullchix);
      }
   }

   chxfree (control);
   chxfree (chx_t_intrc);
 
#endif

/*------------------------------MASSCOMP & A3----------------------------*/
#if SYSV1 | SYSV2
   struct termio a;
   Chix   control, chx_c_cc;

   ENTRY ("syscancel", "");

   if (NOT chxtype (cancel))
      cancel = chxalloc (30L, THIN, "syscance cancel");  /* STATIC */
 
   control     = chxalloc (30L, THIN, "syscance control");
   chx_c_cc    = chxalloc (5L,  THIN, "syscance chx_t_intrc");
 
   if (EMPTYCHX (cancel)) {
      if (ioctl (0, TCGETA, &a) < 0)  a.c_cc[0] = 0;

      if      (a.c_cc[0] == 0177)  mdstr (cancel, "sys_Kdel", null.md);

      else if (a.c_cc[0] <   040) {
         mdstr   (control, "sys_Kctrl", null.md);
         chxcatval (chx_c_cc, THIN, L(0100 + a.c_cc[0]));
         chxformat (cancel, CQ("%s%s"), 0L, 0L, control, chx_c_cc);
      }

      else {
         chxcatval (chx_c_cc, THIN, L(0100 + a.c_cc[0]));
         chxformat (cancel, CQ("'%s'"), 0L, 0L, chx_c_cc, nullchix);
       }
   }

   chxfree (control);
   chxfree (chx_c_cc);
#endif

/*----------------------------------Vax/VMS & IBM PC--------------------*/
#if IM | JM | PN | VV
   ENTRY ("syscancel", "");

   if (NOT chxtype(cancel))
      cancel = chxalloc (30L, THIN, "syscance cancel");  /* STATIC */
 
   if (EMPTYCHX (cancel))  mdstr (cancel, "sys_Tcanctlc", null.md);
#endif

/*---------------------------------------------VM/CMS--------------------*/
#if CVM | PX | PS
   ENTRY ("syscancel", "");
 
   if (NOT chxtype(cancel))
      cancel = chxalloc (30L, THIN, "syscance cancel");  /* STATIC */
 
   if (EMPTYCHX (cancel))  mdstr (cancel, "sys_Tcancms", null.md);
#endif

/*---------------------------------------PRIME---------------------------*/
#if PR
   ENTRY   ("syscancel", "");
      
   if (NOT chxtype(cancel))
      cancel = chxalloc (30L, THIN, "syscance cancel");  /* STATIC */
 
   if (EMPTYCHX (cancel))  mdstr (cancel, "sys_Tcanprime", null.md);
#endif

   RETURN (cancel);
}
