
/*** SYSCHECK.  Check if a file exists.
/
/    SYSCHECK returns 1 if FILE exists, otherwise 0.
/    
/    Note that for client/server code, syscheck should only be used
/    to check on the existence of a file local to the client. */

/*** Copyright (C) 1983 Camber-Roth.  All rights reserved.  */

/*: AA  7/29/88 17:44 Source code master starting point */
/*: CR  8/25/88 13:15 No longer requires file be writable. */
/*: CR 10/06/88 14:46 IM changed to use QuickC. */
/*: CR 11/02/88 16:21 Add CX to UNIX, remove VMU, change VMR -> CVM. */
/*: CR 11/17/88 14:34 Move PN from UNIX to IM. */
/*: JV 12/07/88 10:36 Added CA code.*/
/*: CR  7/03/89 14:24 UNIX: replace open() with sysopen(). */
/*: CW  5/08/89 15:17 Add PX system code. */
/*: JV 10/04/89 17:49 Stripped out AOS non-server code. */
/*: JV  3/23/90 11:49 Added REALID parameter and use of it. */
/*: CR  3/23/90 16:39 Removed REALID parameter. */
/*: CR  4/24/90 20:16 Remove unused UNIX variable 'ok'. */
/*: CR  9/20/90 17:03 Add PS system type. */

#include <stdio.h>
#include "caucus.h"
#include "systype.h"

FUNCTION  syscheck (file)
   char file[];
{

/*---------------------------------------Vax/VMS-------------------------*/
#if VV
#include <rmsdef>
#include <ssdef>
#include <descrip>

   struct dsc$descriptor_s f_desc, r_desc;
   char   result[255];
   long   context;
   int    found;

   ENTRY ("syscheck", "");

   f_desc.dsc$w_length  = strlen (file);
   f_desc.dsc$a_pointer = file;
   f_desc.dsc$b_class   = DSC$K_CLASS_S;
   f_desc.dsc$b_dtype   = DSC$K_DTYPE_T;

   r_desc.dsc$w_length  = 254;
   r_desc.dsc$a_pointer = result;
   r_desc.dsc$b_class   = DSC$K_CLASS_S;
   r_desc.dsc$b_dtype   = DSC$K_DTYPE_T;

   context = 0L;
   found   = lib$find_file (&f_desc, &r_desc, &context, 0, 0, 0, 0);
   lib$find_file_end (&context);
   RETURN (found == RMS$_NORMAL);

#endif

/*---------------------------------------VM/CMS--------------------------*/
#if CVM
#include <file.h>
   ENTRY  ("syscheck", "");
   RETURN (access (file, F_OK) == 0);
#endif

/*---------------------------------------UNIX----------------------------*/
#if UNIX | CX | PX | PS
   int  fd;
   extern int errno;

   ENTRY ("syscheck", "");

   if ( (fd = sysopen (file, 0, "syscheck")) >= 0)  close (fd);

   RETURN  (fd >= 0);
#endif
 
/*---------------------------------AOS/VS--------------------------*/
#if CA
#include <fcntl.h>
    int fd;
    
    ENTRY ("syscheck", "");
    RETURN (access (file, 6) ? 0 : 1); /* return 1 if access=0 (success) */
#endif

/*---------------------------------------PRIME---------------------------*/
#if PR
   ENTRY  ("syscheck", "");
   RETURN (fexists (file) > 0);
#endif

/*---------------------------------------IBM PC--------------------------*/
#if IM | PN
#include <io.h>
   ENTRY ("syscheck", "");

   RETURN (access (file, 0) == 0);
#endif
}
