/*** SYSGLOBALS.  Declaration of global text buffer structures
/    and other system-dependent global variables. */

/*: AA  7/29/88 17:44 Source code master starting point */
/*: CR 11/02/88 17:39 Remove VM, add CX, CA, CVM. */
/*: CR  1/06/89 16:12 CVM changes only. */
/*: JV  2/14/89 15:55 Added vcflag. */
/*: JV  4/04/89 12:35 Integrated JCaucus code. */
/*: CR  4/05/89 14:17 Move echo_input to globals(). */
/*: CR  4/18/89 17:50 Remove vcflag! */
/*: CW  5/08/89 15:17 Add PX system code. */
/*: CR  9/17/89 23:22 Add HANGUP. */
/*: JV 10/04/89 14:03 Remove other vc stuff. */
/*: JV 10/04/89 18:07 Stripped out AOS non-server code. */
/*: CR 12/14/89 13:47 Expand newuseropts[] to 200. */
/*: JV  3/13/90 12:35 Added under_ceo to AOS. */
/*: JV  3/23/90 12:04 Added realuid, caucusuid to Unix. */
/*: CR  3/23/90 13:34 Removed realuid, caucusuid to Unix. */
/*: CR  3/19/90 15:41 Put PX with CVM code. */
/*: CR  4/09/90 16:08 Add sysio and char_map, and code to init. char_map. */
/*: CR  9/20/90 17:03 Add PS system type. */
/*: JV 11/13/90 18:27 Moved terminal i/o data structure here. */
/*: JV  1/13/90 19:08 Initialized under_ceo to zero */
/*: CJ 11/21/90 14:27 Expand liceblk for license.function_mask. */
/*: CJ 11/22/90 20:55 Modify initialization and use of sysio. */
/*: CJ 11/26/90 17:00 Add new OS_ECHO systurn()/sysio stuff. */
/*: CR  2/01/91 16:16 Remove global hangup in favor of syshngtest(). */
/*: JV  2/06/91 17:54 Added alarmflag global. */
/*: CR  4/06/91 17:14 Integrate with recent changes. */
/*: CR  4/23/91 11:25 Add ultrix set-gid fixes. */
/*: CR  9/05/92 12:38 Make MV like UL. */
/*: JX  5/28/92 14:51 Begin Chixify. */
/*: CX  6/07/92 18:44 Remove collation stuff. */
/*: CR 10/09/92 18:12 Put alarm inside #if CA. */
/*: CR 10/30/92 11:56 Add sysio values for lineedit, is_afile. */
/*: CR  1/26/93 15:55 Initialize license block so it decrypts to 0's. */
/*: JV  2/25/93 10:02 Add att_ui_type for File Attachments. */
/*: JV  3/29/93 10:13 Add att_copydir for File Attachments. */
/*: CP  7/26/93 12:44 MV: remove use of 'usegid'. */
/*: CP  8/18/93 17:48 Change att_ui_type to Chix; add first_call. */
/*: CK 10/13/93 17:28 Extend initialization of license. */

#include <stdio.h>
#include "caucus.h"
#include "systype.h"
#include "sys.h"

#if CA
#include <termio.h>
#endif

extern struct flag_template flag;

/*** System-dependent i/o control:
/    OS_Echo, Caucus_echo, cooked, 8bit; intr, erase, eof. */
#if UNIX | CA | PX | CVM | PS
struct sysio_t sysio = { {ON, ON, ON, OFF, ON, OFF}, -1, -1, -1 };
#endif
#if IM | PN
struct sysio_t sysio = { {ON, ON, ON, OFF, ON, OFF},  03, 010, 032 };
#endif
#if VV
struct sysio_t sysio = { {ON, ON, ON, OFF, ON, OFF},  03, 0177, 032 };
#endif
#if PR
struct sysio_t sysio = { {ON, ON, ON, OFF, ON, OFF},  0220, 0210, 0203 };
#endif

#if UL
int    usegid = 1;
#endif

#if CA
/*** Alarm timer went off if alarmflag == 1. */
char   alarmflag = 0;
#endif

/*** License block.  Note overlay of liceblk_t and license_t. */
struct liceblk_t license = {
   { 0x11, 0x22, 0x33, 0x44, 0xAA, 0xBB, 0xCC, 0xDD },
   PLAIN_ENC_LONG, PLAIN_ENC_LONG, 0xFFFF ^ PLAIN_ENC_LONG,
   PLAIN_ENC_LONG, PLAIN_ENC_LONG, PLAIN_ENC_LONG, PLAIN_ENC_LONG, 
   PLAIN_ENC_LONG, 
#if PR
   1L, 2L, 3L, 4L, 5L, 6L, 7L, 8L, 9L, 10L,
   1L, 2L, 3L, 4L, 5L, 6L, 7L, 8L, 9L, 10L,
   1L, 2L, 3L, 4L, 5L, 6L, 7L, 8L, 9L, 10L,
   1L, 2L, 3L, 4L, 5L, 6L, 7L, 8L, 9L, 10L,
   1L, 2L, 3L, 4L, 5L, 6L, 7L, 8L, 9L, 10L,
   1L, 2L, 3L, 4L, 5L, 6L, 7L, 8L, 9L, 10L,
   1L, 2L, 3L, 4L, 5L, 6L, 7L, 8L,
#endif
};

#if CA
short under_ceo=0;    /* Are we running under CEO? */
struct termio termbuf, oldbuf;   /* We need these here so sysexit() */
#endif                           /* and vcsyscmd() can get to them.   */

/* Terminal type for use by File Attachment software */
Chix att_ui_type = nullchix;

/* Where to store temporary copy of a file attachment. */
Chix att_copydir = nullchix;

/*** New user SET options.  Most systems default screensize to 23, VM
/    defaults to 0 because of the weird way VM terminals work. */
Chix newuseropts = nullchix;

FUNCTION  sysglobals()
{
   extern union null_t  null;
   static short first_call = 1;

   ENTRY ("sysglobals", "");

   if (first_call) {
      newuseropts = chxalloc (100L, THIN, "sysglob newuseropts");
      att_copydir = chxalloc ( 40L, THIN, "sysglob att_copydir");
      att_ui_type = chxalloc ( 40L, THIN, "sysglob att_ui_type");
      first_call  = 0;
   }

#if UNIX | IM | PN | PR | VV | CX | CA
   mdstr (newuseropts, "sys_Tset0", null.md);
#endif

   /*** Set the default for the temporary directory. */
#if UNIX
   chxofascii (att_copydir, "/tmp");
#endif

#if CVM | PX | PS
   mdstr (newuseropts, "sys_Tset0cms", null.md);
#endif

   RETURN (1);
}
