/*** SYSHOMEDIR.  Construct the pathname of the "home" directory for a user.
/
/   ok = syshomedir (dir);
/
/   Parameters:
/     int   ok;     (Return value)
/     Chix  dir;    (Place to put result)
/
/   Purpose:
/      Some files, e.g. temporary files, might be best placed in the user's
/      'home' directory.
/
/   How it works:
/
/   Returns: 1 on success, 0 otherwise
/
/   Errors:
/
/   Related functions:  systmpfile
/
/   Called by:
/
/   Operating System Dependencies:
/
/   Home: sys/syshomed.c
/ */

/*** Copyright (C) 1993 Camber-Roth.  All rights reserved. */

/*: JV  4/14/93 14:43 Create this. */
/*: CP  7/15/93 15:18 Add MV, compiler complaint if not implemented. */
/*: CK 10/13/93 16:50 Extend to all Unix, check return val from getenv(). */

#include <stdio.h>
#include "handicap.h"
#include "systype.h"
#include "chixuse.h"

#if SN
#include <stdlib.h>
#endif

FUNCTION  syshomedir (dir)
   Chix  dir;
{
#if UNIX
   char *getenv();
   char *homedir;

   if ( (homedir = getenv ("HOME")) == NULL)  homedir = ".";
   chxofascii (dir, homedir);

#else
   /*** Force compiler to complain; this means this function has not
   /    been implemented. */
   5 = ;
#endif

   return (1);
}
