
/*** SYSMEM.  Allocate a block of B bytes of memory.
/
/    SYSMEM allocates the requested block, aligned for any data type,
/    and RETURNs a pointer to the block.  SYSMEM will almost certainly
/    always be just a call to MALLOC, but just in case... */

/*: AA  7/29/88 17:45 Source code master starting point */
/*: CR 11/02/88 17:49 Insert system dependencies... */
/*: CR  1/06/89 16:12 CVM changes only. */
/*: CW  5/08/89 15:17 Add PX system code. */
/*: JV 10/04/89 18:13 Stripped out AOS non-server code. */
/*: CR 10/30/89 12:26 Cast B to unsigned. */
/*: CR  9/20/90 17:03 Add PS system type. */
/*: JX  6/15/92 12:24 Reduce padding from 100 to 2 bytes. */
/*: JX  7/01/92 15:17 Allocate max of 32K bytes for PC's. */
/*: JX  9/14/92 14:17 Use calloc() so memory is zeroed. */
/*: CR 11/13/92 17:45 Fix 32K limit so it will compile on SX. */
/*: CR 12/11/92 15:43 Make arg long; use SMALL_MEMORY. */
/*: CL 12/11/92 15:52 Long sysmem arg. */

#include <stdio.h>
#include "caucus.h"
#include "systype.h"

FUNCTION  char *sysmem (b)
   long   b;
{
#if UNIX | PR | VV | CA | CVM | PS
   char   *calloc();

   ENTRY ("sysmem", "");

#if SMALL_MEMORY
   b = (b > 32760 ? 32760 : b);
#endif

   RETURN (calloc (1, (unsigned) (b + 2) ) );
#endif
}
