
/*** SYSMKCONF.  Make (create) a conference directory.
/
/    Make the conference directory for conference number N.  */

/*** Copyright (C) 1988 Camber-Roth.  All rights reserved. */

/*: AA  7/29/88 17:45 Source code master starting point */
/*: CR 11/03/88 15:03 New function to ease server/client work. */
/*: CR 11/09/88 15:07 Fix SRV bugs. */
/*: CR  3/21/89 15:15 Add use of servername to #if SRV code. */
/*: CW  5/08/89 15:17 Add PX system code. */
/*: JV 10/04/89 18:14 Stripped out AOS non-server code. */
/*: JV 10/05/89 11:03 SRV now exits if vcsend() fails. */
/*: CR  9/20/90 17:03 Add PS system type. */
/*: CR  9/26/90 10:40 Tell Lint not to worry about argument usage. */
/*: CR  4/08/91 19:18 Use new confnum argument to unit_name(). */
/*: UL 12/11/91 20:12 Make unit_name args 3-6 long.*/
/*: DE  5/29/92 10:26 Chixified */

#include "caucus.h"
#include "systype.h"
#include <stdio.h>

/*ARGSUSED*/

extern union null_t null;

FUNCTION  sysmkconf (n)
   int    n;
{

#if UNIX | PR | VV | IM | PN | PX | PS
   char   name[80];

   ENTRY ("sysmkcon", "");

   unit_name (name, XCDD, L(n), 0L, 0L, 0L, null.chx);
   sysmkdir  (name, 1);
   RETURN (1);
#endif

/*------------------------------Server/client code-----------------------*/
#if SRV
#include "actions.h"
#include "errchk.h"
   extern int   vcernum;
   extern char *vcernam;
   extern Chix  confid;
   extern Chix  servername;
   Flag   result;

   ENTRY ("sysmkcon", "");

   if (NOT vcsend (servername, AMKCN, (char *) &n, sizeof(n), &result, 1)) {
      ERRCHK("sysmkcon");
      unit_write (XWTX, CQ("Caucus Server has terminated.\n"));
      unit_write (XWTX, CQ("Caucus is now aborting.\n"));
      sysexit (0);
   }

   RETURN ( (int) result);
#endif

}
