
/*** SYSOPEN.   Open a file, low level.
/
/    SYSOPEN replaces the Unix-ish 'open()' function.  It returns
/    a file descriptor if the open succeeds, -1 if it fails for 
/    "normal" reasons (trying to open for read a file that does 
/    not exist).  If any other strange conditions apply, SYSOPEN 
/    exits via sysexit() after an appropriate number of retries.  */

/*** Copyright (C) 1983 Camber-Roth.  All rights reserved.  */

/*: AA  7/29/88 17:44 Source code master starting point */
/*: CR  9/12/89 16:54 Declare bugtell(). */
/*: JV  3/21/90 16:05 Fixed ENTRY, reduced wait time, fixed error detection. */
/*: CR  3/20/90 12:07 Add PX to UNIX. */
/*: CR  9/20/90 17:03 Add PS system type. */

#include <stdio.h>
#include "caucus.h"
#include "systype.h"
#if UNIX | CX | PX | PS
#include <errno.h>
#endif

FUNCTION  sysopen (file, code, caller)
   char file[], caller[];
   int  code;
{
   char *bugtell();

/*---------------------------------------UNIX----------------------------*/
#if UNIX | CX | PX | PS
   int  fd, i, open();
   char bug[100];

   ENTRY ("sysopen", "");

   for (i=0;   i<15;   ++i) {
      if ((fd = open (file, code)) >= 0)  RETURN (fd);
      if (errno == ENOENT || errno == EPERM  || errno == EACCES ||
          errno == EXDEV  || errno == ENODEV || 
          errno == ENFILE || errno == EMFILE || errno == EMLINK ||
          errno == EDEADLK)     RETURN (-1);
/*    if (errno == ENOTDIR) break; */
      sleep (2);
      sysbrkclear();
      if (i > 2)  bugtell ("Waiting for an open file", errno, 0L, file);
   }
   sprintf (bug, "Sysopen failed: %s", caller);
   bugtell (bug, errno, 0L, file);
   sysexit (1);
#endif
   RETURN  (-1);
}
