
/*** SYSPASS.   Change the user's password.  */

/*** Copyright (C) 1985 Camber-Roth.  All rights reserved. */

/*: AA  7/29/88 17:45 Source code master starting point */
/*: CR  8/03/88 17:02 #if VMR --> #if VM */
/*: CR  9/21/88 15:25 Add "HU" system type for HP/UX. */
/*: CR  9/23/88 13:00 Add "IX" system type. */
/*: CR 11/03/88 16:05 Add CX, CA, CVM types. */
/*: CR  6/09/89 12:16 Add "SV" system type code. */
/*: CW  5/08/89 15:17 Add PX system code. */
/*: CW  5/19/89 10:54 Add XW unit codes. */
/*: JV 10/04/89 18:18 Stripped out AOS non-server code. */
/*: CR 10/12/89 15:35 Add DU system type code. */
/*: CR  3/22/90 14:46 Use vmi start/stop in PX code. */
/*: CR  6/05/90 13:19 PX: Check flag.fullscreen. */
/*: JV  7/06/90 20:32 Add MIPS RISC/os (RO). */
/*: JV  7/22/90 16:29 Add getuid decl for Sys V. */
/*: CR  9/20/90 17:03 Add PS system type. */
/*: CR  9/27/90 12:19 Add U3, AU system types. */
/*: CJ 11/22/90 22:16 Save/restore terminal state around password command. */
/*: CJ 11/26/90 21:50 Add LA system type code. */
/*: CR  1/28/91 20:40 Detect hangups during wait for child. */
/*: CR  2/01/91 16:43 Replace global hangup with syshngtest(). */
/*: CR  2/09/91 21:44 Split long #if line in two (SYSV1, SYSV2). */
/*: SB 11/29/90 14:05 Add DY system code*/
/*: CR  3/11/91 16:43 Add AX & UL system type codes. */
/*: JV  1/06/92 17:25 Update return from syscmd(). */
/*: CR  1/06/92 19:19 Add DP system type. */
/*: JV  7/16/92 15:30 Add U4. */
/*: CR  7/21/92 17:39 Remove DP (in favor of DYP). */
/*: JV  3/18/93 12:40 Add WAIT arg to syscmd. */

#include <stdio.h>
#include "caucus.h"
#include "sys.h"
#include "systype.h"

extern struct flag_template flag;
extern struct termstate_t   term_in_caucus, term_original;

FUNCTION  syspass()
{

/*-------------------------------VM/CMS-------------------------*/
#if CVM
   ENTRY ("syspass", "");
   mdwrite (XWER, "sys_Tcmsnopas", NULL);
   RETURN  (0);
#endif
 
/*-------------------------AOS/VS & AOS/RT32 & MV/UX-----------*/
#if CA
   ENTRY ("syspass", "");
   mdwrite (XWER, "sys_Taosnopas", NULL);
   RETURN (0);
#endif

/*-------------------------------FORTUNE & MASSCOMP & A3-----------------*/
#define SYSV1  A3 | LA | SV | HU | FU | MU | MV | PU | SX | TX | IX
#define SYSV2  CX | PX | DU | RO | PS | U3 | AU | DY | AX | U4
#if SYSV1 | SYSV2
   int   status, child;
   unsigned short getuid();

   ENTRY ("syspass", "");

   /*** Spawn off a task which sets the effective id to the real id,
   /    exec /etc/passwd. */
#if PX | PS
   if (flag.fullscreen)  vmistop();
#endif
   systurn (&term_in_caucus, GET_TERM, 0);
   systurn (&term_original,  SET_TERM, 0);
   child  = fork();
   if      (child == -1)  {
      systurn (&term_in_caucus, SET_TERM, 0);
      RETURN  (0);
   }

   /*** The parent task waits for the child to terminate. */
   else if (child >   0)
      while (wait (&status) != child)  { if (syshngtest()) break; }

   else {
      setuid (getuid());
      execl  ("/bin/passwd", "passwd", NULL);
      exit  (0);
   }

   systurn (&term_in_caucus, SET_TERM, 0);
#if PX | PS
   if (flag.fullscreen)  vmistart();
#endif

   RETURN ( (status & 0xFF00) ? 0 : 1);
#endif

/*-------------------------Berkeley Unix-------------------------*/
#if BU | SU | UL
   int   status, child;

   ENTRY ("syspass", "");

   /*** Spawn off a task which sets the effective id to the real id,
   /    exec /etc/passwd. */
   systurn (&term_in_caucus, GET_TERM, 0);
   systurn (&term_original,  SET_TERM, 0);
   child  = vfork();
   if      (child == -1)  {
      systurn (&term_in_caucus, SET_TERM, 0);
      RETURN  (0);
   }

   /*** The parent task waits for the child to terminate. */
   else if (child >   0)
      while (wait (&status) != child)  { if (syshngtest()) break; }

   else {
      setreuid (getuid(), getuid());
      execl  ("/bin/passwd", "passwd", NULL);
      exit  (0);
   }

   systurn (&term_in_caucus, SET_TERM, 0);
   RETURN ( (status & 0xFF00) ? 0 : 1);
#endif

/*---------------------------------------VAX-----------------------------*/
#if VV
   ENTRY ("syspass", "");
   RETURN ( syscmd ("set password", SYS_WAIT) >0);
#endif

/*---------------------------------------PRIME---------------------------*/
#if PR
   ENTRY  ("syspass", "");
   syscmd ("change_password -prompt", SYS_WAIT);
   RETURN (0);
#endif
}
