
/*** SYSRENAME.  Renames file A to file B.
/
/    Returns 1 if successful, and 0 otherwise.
/
/    For server/client programs, SYSRENAME must be (is) used only
/    to rename local files. */

/*** Copyright (C) 1986 Camber-Roth.  All rights reserved. */

/*: AA  7/29/88 17:45 Source code master starting point */
/*: JV  9/02/88 11:55 Added Debug code to AOS.*/
/*: JV  9/02/88 14:09 Added even more AOS debug code.*/
/*: JV  9/02/88 15:29 Changed amove to syscopy and unlink.*/
/*: CR 10/06/88 16:05 Change IM to use QuickC. */
/*: CR 11/03/88 16:22 Add CX, CA, CVM; remove VM. */
/*: JV 12/06/88 10:55 Optimized AOS code.*/
/*: JV  2/16/89 10:09 Changed CA code.*/
/*: JV  7/11/89 16:20 Changed CA code. Now it works. */
/*: CR  7/27/89 17:07 Changed VV include syntax. */
/*: CW  5/08/89 15:17 Add PX system code. */
/*: JV 10/04/89 18:24 Stripped out AOS non-server code. */
/*: CR  9/20/90 17:03 Add PS system type. */
/*: CJ 11/26/90 21:50 Add LA system type code. */

#include <stdio.h>
#include "caucus.h"
#include "systype.h"

extern int debug;

FUNCTION  sysrename (a, b)
   char   a[], b[];
{

/*---------------------------------------VAX-----------------------------*/
#if VV
#include <ssdef>
#include <descrip>

   struct dsc$descriptor_s a_desc, b_desc;

   ENTRY ("sysrename", "");
   a_desc.dsc$w_length  = strlen (a);
   a_desc.dsc$a_pointer = a;
   a_desc.dsc$b_class   = DSC$K_CLASS_S;
   a_desc.dsc$b_dtype   = DSC$K_DTYPE_T;

   b_desc.dsc$w_length  = strlen (b);
   b_desc.dsc$a_pointer = b;
   b_desc.dsc$b_class   = DSC$K_CLASS_S;
   b_desc.dsc$b_dtype   = DSC$K_DTYPE_T;

   if (lib$rename_file (&a_desc, &b_desc) == SS$_NORMAL)   RETURN (1);
   syscopy (a, b);
   delete  (a);
   RETURN  (1);
#endif

/*-------------------------------FORTUNE & MASSCOMP & A3 | LA-----------------*/
#if UNIX | CX | PX | PS
   ENTRY  ("sysrename", "");
   if (link (a, b) < 0)  syscopy (a, b);
   unlink (a);
   RETURN (1);
#endif
 
/*--------------------------------------AOS------------------------------*/
#if CA
    int err;
    ENTRY   ("sysrename", "");
    err = amove (a, b);
    RETURN (err == 0);
#endif

/*---------------------------------------PRIME---------------------------*/
#if PR
   ENTRY  ("sysrename", "");
   move   (a, b);
   RETURN (1);
#endif

/*-------------------------------IBM PC----------------------------------*/
#if IM | PN
   ENTRY ("sysrename", "");

   /*** Try simply renaming file A.  If that fails, copy A -> B,
   /    then delete A. */
   if (rename (a, b) < 0) {
      syscopy (a, b);
      unlink  (a);
   }

   RETURN (1);
#endif

/*---------------------------------------VM/CMS--------------------------*/
#if CVM
   ENTRY  ("sysrename", "");
   RETURN (rename (a, b) == 0);
#endif
}
