/*** SYSRMCONF.  Remove (delete) a conference directory.
/
/    Delete the conference directory for conference number N,
/    and all the files under it. */

/*** Copyright (C) 1988 Camber-Roth.  All rights reserved. */

/*: AA  7/29/88 17:45 Source code master starting point */
/*: CR 11/03/88 15:03 New function to ease server/client work. */
/*: CR 11/09/88 15:30 Fix SRV bugs. */
/*: CR 12/16/88 14:54 PN code: unit_wipe before removing directory. */
/*: CR  3/21/89 15:15 Add use of servername to #if SRV code. */
/*: JV  6/20/89 17:11 Cast'd n in vcsend call. */
/*: CW  5/08/89 15:17 Add PX system code. */
/*: JV 10/04/89 18:24 Stripped out AOS non-server code. */
/*: JV 10/05/89 11:04 SRV now exits if vcsend() fails. */
/*: CR  6/21/90 12:38 Add LCNF arg to unit_wipe() call. */
/*: CR  9/20/90 17:03 Add PS system type. */
/*: CR  9/26/90 10:50 Make Lint happy about argument usage. */
/*: CR  4/02/91 23:50 HU must wipe conf first. */
/*: CR  4/08/91 19:18 Use new confnum argument to unit_name(). */
/*: CR  7/02/91  0:00 Include "unitwipe.h". */
/*: UL 12/11/91 20:12 Make unit_name args 3-6 long.*/
/*: DE  5/29/92 14:22 Chixified */

#include <stdio.h>
#include "caucus.h"
#include "systype.h"
#include "unitwipe.h"

/*ARGSUSED*/

FUNCTION  sysrmconf (n)
   int    n;
{

#if UNIX | PR | VV | IM | PN | PX | PS
   char   name[80];

   ENTRY ("sysrmcon", "");

   unit_name (name, XCDD, L(n), 0L, 0L, 0L, nullchix);
#if PN | HU
   unit_wipe (LCNF);
#endif
   sysrmdir  (name);
   RETURN (1);
#endif


/*------------------------------Server/client code-----------------------*/
#if SRV
#include "actions.h"
#include "errchk.h"
   extern int   vcernum;
   extern char *vcernam;
   extern Chix  servername;
   extern Chix  confid;

   ENTRY ("sysrmconf", "");

   if (NOT vcsend (servername, ARMCN, (char *) &n, sizeof(n), NULL, 0)) {
      ERRCHK("sysrmconf");
      unit_write (XITT, CQ("Caucus Server has terminated.\n"));
      unit_write (XITT, CQ("Caucus is now aborting.\n"));
      sysexit (0);
   }

   RETURN (1);
#endif
}
