
/*** SYSRMDIR.  Completely remove directory PATH and all it's files. */

/*: AA  7/29/88 17:45 Source code master starting point */
/*: JV  8/02/88  9:11 Added AOS code.*/
/*: CR  8/03/88 17:12 Move <stdio> to top */
/*: CR  8/26/88 14:28 Change Vax/VMS code to use lib$find_file. */
/*: CR 10/06/88 16:07 Change IM to use QuickC. */
/*: CR 11/04/88 16:14 AOS code must not change the PATH argument! */
/*: JV  3/07/89 11:35 Changed AOS code. */
/*: CW  5/08/89 15:17 Add PX system code. */
/*: JV 10/04/89 18:24 Stripped out AOS non-server code. */
/*: CR  9/20/90 17:03 Add PS system type. */
/*: CJ 11/26/90 17:27 Fix VV include syntax. */
/*: DE  5/29/92 14:34 Chixified */
/*: JV  8/25/93 14:28 Add -f "force" flag to Unix rm command. */

#include <stdio.h>
#include "caucus.h"
#include "systype.h"

extern Chix confid;

FUNCTION  sysrmdir (path)
   char   path[];
{

/*-------------------------Unixes----------------------------------*/
#if UNIX | PX | PS
   char   com[100];

   ENTRY   ("sysrmdir", "");

   strconc (com, "rm -rf ", path);
   system  (com);
#endif


/*-------------------------IBM PC----------------------------------*/
#if IM | PN
#include "sysdir.h"

   struct node_template *head, *ptr, *userhead, *userptr, *sysdir();
   char   dir[80], file[80];

   ENTRY   ("sysrmdir", "");

   /*** DIR is the full name of the directory that contains the to-be-
   /    deleted conference.  Get the list of all of the files in that
   /    directory. */
   sprintf (dir, "%s\\*.*", path);
   head = sysdir (dir);

   /*** Delete all of the files in DIR, one by one. */
   for (ptr=head;   ptr != NULL;   ptr = ptr->next) {
      sprintf (file, "%s\\%s", path, ptr->name);
      unlink  (file);
   }
   sysdirfree (head);

   /*** Now actually delete the (empty) directory. */
   rmdir (path);
#endif

/*-------------------------Vax/VMS---------------------------------*/
#if VV
#include <rmsdef>
#include <ssdef>
#include <descrip>

   struct dsc$descriptor_s f_desc, r_desc;
   char   result[255], pattern[80], *s;
   long   context;
   int    blank;

   ENTRY   ("sysrmdir", "");

   /*** Initialize directory search. */
   strconc (pattern, path, "]*.*;*");
   f_desc.dsc$w_length  = strlen (pattern);
   f_desc.dsc$a_pointer = pattern;
   f_desc.dsc$b_class   = DSC$K_CLASS_S;
   f_desc.dsc$b_dtype   = DSC$K_DTYPE_T;

   r_desc.dsc$w_length  = 254;
   r_desc.dsc$a_pointer = result;
   r_desc.dsc$b_class   = DSC$K_CLASS_S;
   r_desc.dsc$b_dtype   = DSC$K_DTYPE_T;

   /*** Find each matching file and delete it. */
   context = 0L;
   while (lib$find_file (&f_desc, &r_desc, &context, 0, 0, 0, 0)
          == RMS$_NORMAL) {
      result[254] = '\0';
      if ( (blank = strindex (result, " ")) > 0)  result[blank] = '\0';
      delete (result);
   }
   lib$find_file_end (&context);

   /*** Make up the file name for the directory and delete it. */
   strcpy (pattern, path);
   s = pattern + strlen (pattern) - 1;
   while  (*s != '.')  --s;
   *s = ']';
   strcat (pattern, ".dir;1");
   chmod  (pattern, 0700);
   delete (pattern);
#endif

/*-------------------------PRIME-----------------------------------*/
#if PR
   int    fd;
   char   file[80];
   char  *ptr, *lsdir();

   ENTRY ("sysrmdir", "");

   if ( (fd = open (path, 0)) < 0)  RETURN (0);

   /*** Delete all the files in PATH. */
   while ( (ptr = lsdir (fd)) != NULL) {
      sprintf (file, "%s>%s", path, ptr);
      delete  (file);
   }
   close  (fd);

   delete (path);
#endif

   RETURN (1);
}
