/*** SYSSCRIPT.  Execute an operating system command script.
/
/    ok = sysscript (line);
/
/    Parameters:
/       int    ok;          (Success?)
/       char  *line;        (text of ?)
/
/    Purpose:
/       Execute an operating system script, with arguments.
/
/    How it works:
/       The name of the script file, followed by its arguments, is
/       in LINE.  Sysscript() prepends any operating-system dependent
/       stuff needed to say "execute this script", and passes the whole
/       thing off to syscmd() to execute.
/
/    Returns: 1 on success, 0 on failure.
/
/    Error Conditions:
/  
/    Side effects:
/
/    Related functions:
/
/    Called by: application
/
/    Operating system dependencies: extreme
/
/    Known bugs:
/
/    Home:  sys/sysscrip.c
/
/ */

/*** Copyright (C) 1991 Camber-Roth.  All rights reserved. */

/*: CR  8/01/91 14:24 New function. */
/*: CR 12/12/91 17:00 Use 'exec' for Unix scripts. */
/*: JV  1/06/91 17:30 Update return from syscmd(). */
/*: JV  3/18/93 12:40 Add WAIT arg to syscmd. */

#include <stdio.h>
#include "caucus.h"
#include "sys.h"
#include "systype.h"

FUNCTION  sysscript (line)
   char  *line;
{

#if UNIX
   char    temp[300];
   ENTRY   ("sysscript", "");
   strconc (temp, "exec ", line);
   RETURN  (syscmd (temp, SYS_WAIT) > 0);
#endif

#if IM | PN | CVM
   ENTRY  ("sysscript", "");
   RETURN (syscmd (line, SYS_WAIT) > 0);
#endif

#if AOS
#endif

#if VV
   char    temp[300];
   ENTRY   ("sysscript", "");
   strconc (temp, "@", line);
   RETURN  (syscmd  (temp, SYS_WAIT) > 0);
#endif

#if PR
   char    temp[300];
   ENTRY   ("sysscript", "");
   strconc (temp, "r ", line);
   RETURN  (syscmd  (temp, SYS_WAIT) > 0);
#endif

}
