
/*** SYSSTATUS.   Display one line of conference status information on OUT.
/
/    Most systems just write out one line of info. 
/    DG systems put it at the top of the screen in reverse video.
/    (If output is not to screen, writes text normally.)
/ */

/*** Copyright (C) 1989 Camber-Roth.  All rights reserved. */

/*: CR  3/20/90 15:51 New function. */
/*: CR  3/27/90 11:53 Output must be 79 chars max. */
/*: CR  4/12/90 13:55 CVM,PX: output extra blank line after status. */
/*: CR  6/05/90 13:51 CVM, PX: Check flag.fullscreen. */
/*: JV  9/10/90 14:26 Added CEO code to CA. */
/*: CR  9/20/90 17:03 Add PS system type. */
/*: CJ 11/22/90 16:54 Add new argument "out". */
/*: DE  5/29/92 17:36 IN PROCESS OF BEING CHIXIFIED */
/*: JX  6/04/92 13:19 Finished chixification. */
/*: CL 12/11/92 11:18 Long Chxcatsub args. */

#include <stdio.h>
#include "caucus.h"
#include "systype.h"

extern struct flag_template  flag;
extern Chix                  confname;

#if CA
extern int    menu_level;
extern short  confnum, under_ceo;
extern struct master_template master;
extern struct partic_t thisconf;
extern union  null_t null;
#endif

FUNCTION  sysstatus (out)
   int    out;
{
   Chix   newstr, format1, format2;
#if CA
   short mess=-1, new, urg, rej, rem, ceo=0;         /* CEO mail. */
   short i, screen;
   Chix  s_format, userid;
   static Chix s_statmsg, s_statitem, s_statresp, s_staturg,
               s_stathead,  s_stattail;
#endif

#if CVM | PX | PS
#include "vwin.h"
   extern vwin w_text;
#endif

   static Chix *s_oneline1;
   static Chix *s_oneline2;
   int    newitems, totalresp, actitems, newmess;
   Chix   truncname, daytime, day, time;
   long   systime();

   ENTRY ("sysstatus", "");

   newstr     = chxalloc (160L, THIN, "sysstat newstr");
   format1    = chxalloc (160L, THIN, "sysstat format1");
   format2    = chxalloc (160L, THIN, "sysstat format2");
   truncname  = chxalloc (60L,  THIN, "sysstat truncname");
   day        = chxalloc (30L, THIN,  "sysstat day");
   time       = chxalloc (30L, THIN,  "sysstat time");
   daytime    = chxalloc (60L,  THIN, "sysstat daytime");

   calcstatus (&newitems, &totalresp, &actitems, &newmess);

#if UNIX | PX | IM | PN | PR | VV | CVM | PS
   mdstr     (format1, "sys_Foneline1", s_oneline1);
   mdstr     (format2, "sys_Foneline2", s_oneline2);
   chxclear  (truncname);
   chxcatsub (truncname, confname, 0L, L(16));
   chxupper  (truncname);
   sysdaytime  (day, time, 0, systime());
   chxformat   (daytime, CQ("%s %s"), 0L, 0L, day, time);

/* Old: sys_Foneline: New in %-16s %3d Items %3d Resp (%3d items) %3d Msgs %s */
/* New: sys_Foneline1: New in %-16s %3d Items %3d Resp $
        sys_Foneline2: (%3d items) %3d Msgs %s */
   chxformat (newstr, format1, L(newitems), L(totalresp), truncname, nullchix);
   chxformat (newstr, format2, L(actitems), L(newmess), daytime, nullchix);

#if UNIX | IM | PN | PR | VV
   unit_write (out, newstr);
#endif

#if CVM | PX | PS
   if (flag.fullscreen  &&  (out==XWTX)) {
      vwinadd (&w_text, ascquick (newstr),  1);
      vwinadd (&w_text, "\n", 0);
   }
   else unit_write (out, newstr);
#endif

#endif

#if CA                            /* If we're in menus, put a Status Line */

   s_format   = chxalloc (40L, THIN, "sysstat s_format");
   userid     = chxalloc (40L, THIN, "sysstat userid");

   screen = (out == XWTX);
   if (menu_level) {                         /* at the top of the screen. */
      if (menu_level && under_ceo) {         /* Should check CEO? */
         IT2_CEO_MAIL (&new, &urg, &rej, &rem); }
         
      if (screen) sysputstr ("\036\104");    /* Turn Rev Vid On. */
      mdwrite (out, "sys_Tstathead", &s_stathead);
      if (under_ceo)                   /* Write out CEO msg status. */
         if (urg) {
            if (screen) sysputstr ("\036\105");
            mdwrite (out, "sys_Tstaturg", &s_staturg);
            if (screen) sysputstr ("\036\104");  }      /* Normal Vid */
         else {
            mdstr (s_format, "sys_Fstatmsg", &s_statmsg);
            chxclear  (newstr);
            chxformat (newstr, s_format, L(new), 0L, nullchix, nullchix);
            unit_write (out, newstr);
         }
      else {                               /* Display Caucus msg status. */
         mdstr   (s_format, "sys_Fstatmsg", &s_statmsg);
         chxclear  (newstr);
         chxformat (newstr, s_format, L(newmess), 0L, nullchix, nullchix);
         unit_write (out, newstr);
      }
      mdstr (s_format, "sys_Fstatitem", &s_statitem);
      chxclear  (newstr);
      chxformat (newstr, s_format, L(newitems), 0L, nullchix, nullchix);
      unit_write (out, newstr);
      mdstr (s_format, "sys_Fstatresp", &s_statresp);
      chxclear  (newstr);
      chxformat (newstr, s_format, L(totalresp), 0L, nullchix, nullchix);
      unit_write (out, newstr);

      sysdaytime (day, time, 0, systime());
      chxclear  (s_format);
      chxformat (s_format, CQ("%s %s"), 0L, 0L, day, time);
      unit_write (out, s_format);
      mdwrite    (out, "sys_Tstattail", s_stattail);
      if (screen) sysputstr ("\036\105\n\n");
   }

   chxfree ( s_format );
   chxfree ( userid );
   chxfree ( day );
   chxfree ( time );
#endif

   RETURN (1);
}



