
/*** SYSTEMID.  Return system id in STR.  */

/*** Copyright (C) 1988 Camber-Roth..  All rights reserved.  */

/*: AA  7/29/88 17:45 Source code master starting point */
/*: CR  9/21/88 15:25 Add "HU" system type for HP/UX. */
/*: CR  9/23/88 13:00 Add "IX" system type. */
/*: CR 11/04/88 13:50 Remove VM, add CX, CA, CVM. */
/*: JV 11/22/88 14:15 Changed AOS code to use lcpid().*/
/*: JV 11/22/88 16:57 Fixed bug.*/
/*: CR  6/09/89 12:16 Add "SV" system type code. */
/*: CR  7/25/89 15:38 Make A3 use system name, not machine name. */
/*: CW  5/08/89 15:17 Add PX system code. */
/*: JV 10/04/89 18:24 Stripped out AOS non-server code. */
/*: CR 10/12/89 15:35 Add DU system type code. */
/*: CR 10/13/89 13:42 Make DU use nodename. */
/*: CR  3/05/90 13:37 HU: new code using idnumber. */
/*: JV  7/06/90 21:08 Add MIPS RISC/os (RO), integrate PU & IX with A3. */
/*: CR  9/20/90 17:03 Add PS system type. */
/*: CR  9/27/90 12:19 Add U3, AU system types. */
/*: CR 10/01/90 21:51 SV uses nodename. */
/*: CJ 11/26/90 21:50 Add LA system type code. */
/*: CR  2/11/91 19:04 Comment/note about DY. */
/*: SB 11/29/90 14:05 Add DY system code*/
/*: CR  3/11/91 16:44 Add AX & UL system type codes. */
/*: CR  3/20/91 17:32 Use MAXSYSID. */
/*: CR  5/02/91 17:28 Modify SX code to work with U3-like systems. */
/*: SB  5/16/91 10:49 Add DP system type.*/
/*: JV  7/17/92 10:02 Add U4, move include files. */
/*: CR  7/21/92 17:39 Remove DP (in favor of DYP). */
/*: CR  8/21/92 15:56 Make MV like A3. */
/*: DE  6/01/92 11:03 Chixified */
/*: CI 10/07/92 15:58 Chix Integration. */
/*: CR 10/09/92 17:44 mtu->hostnamer; chxclear str in VV. */
/*: CR 11/15/92 17:15 Fix chxformat() call in SX code. */
/*: CL 12/11/92 11:18 Long Chxcatsub args. */
/*: CI  3/11/93 16:20 Make SCO serial # always 9 digits. */
/*: CV  4/07/93 16:59 VV: change null.chx to nullchix. */

#include <stdio.h>
#include "caucus.h"
#include "systype.h"

#define SYSVPC SX | CX | PX | AU
#define SYSV   A3 | LA | SV | DU | RO | PU | IX | U3 | DY | AX | U4 | MV

#if SYSV | SYSVPC | HU
#include <sys/utsname.h>
#endif

FUNCTION  systemid (str)
   Chix   str;
{

/*------------------------------AOS--------------------------------------*/
#if CA
   int model;
/*   char *machine;  */
   unsigned long cpu_id;

   ENTRY ("systemid", "");
   cpu_id = lcpid();
   model = (cpu_id >> 16) & ~1;
   chxformat (str, CQ("%04ld"), L(model), 0L, null.chx, null.chx);
#endif

/*------------------------SCO Xenix--------------------------------------*/
#if SYSVPC
   struct  utsname u;

   ENTRY    ("systemid", "");
   u.sysserial = -1L;
   uname    (&u);
   stralter (u.machine, "i80", "");
   stralter (u.machine, "i",   "");

   /*** Regular SX systems have a system serial id. */
   if (u.sysserial > 0)  chxformat (str, chxquick("%09d %s",0), L(u.sysserial),
                                         0L, chxquick(u.machine,1), NULL);

   /*** Other systems compatible with SX have a sysname.  Pad that to have
   /    the same format as the SX serial id. */
   else {
      chxcpy (str, CQ(u.sysname));
      while  (chxlen (str) < 9)  chxconc (str, CQ("0"), str);
      chxcat (str, CQ(" "));
      chxcat (str, CQ(u.machine));
   }
#endif


/*-----------------------BERKELEY Unix------------------------------*/
#if BU | SU | PS | UL
   char   hostname[120];

   ENTRY ("systemid", "");

   gethostname (hostname, 100);
   chxclear  (str);
   chxcatsub (str, CQ(hostname), 0L, L(MAXSYSID));
   jixreduce (str);
#endif


/*---------------------------------------AT&T 3B------------------------*/
#if SYSV
   char   hostname[120];
   struct utsname name;

   ENTRY ("systemid", "");

   uname    (&name);
#if A3 | DY3 | AX | MV
   strcpy   (hostname, name.sysname);
#endif
#if DU | RO | PU | IX | U3 | LA | SV | DYP | U4
   strcpy   (hostname, name.nodename);
#endif

   chxclear  (str);
   chxcatsub (str, CQ(hostname), 0L, L(MAXSYSID));
   jixreduce (str);
#endif

/*---------------------------------------HP/UX--------------------------*/
#if HU
   char   hostname[120];
   struct utsname name;

   ENTRY ("systemid", "");

   uname    (&name);

   strcpy (hostname, name.idnumber);
   if (NULLSTR(hostname))  strcpy (hostname, name.nodename);
   chxclear  (str);
   chxcatsub (str, CQ(hostname), 0L, L(MAXSYSID));
   jixreduce (str);
#endif


/*---------------------------------------VAX-----------------------------*/
#if VV
#include <ssdef>
#include <descrip>
#include <iodef>

#define  SYI$_SID   4097
#define  EFN           0
#define  CSIDADR       0
#define  NODENAME      0
#define  IOSB          0
#define  ASTADR        0
#define  ASTPRM        0

   struct {
      short buffer_length;
      short item_code;
      long *buffer_ptr;
      long *return_ptr;
      long  zero;
   } itemlist;

   long   buffer, return_length;
   long   vaxtrim();

   ENTRY ("systemid", "");

   /*** Get system id number. */
   itemlist.buffer_length = 4;
   itemlist.item_code     = SYI$_SID;
   itemlist.buffer_ptr    = &buffer;
   itemlist.return_ptr    = &return_length;
   itemlist.zero          = 0L;
   sys$getsyiw (EFN, CSIDADR, NODENAME, &itemlist, IOSB, ASTADR, ASTPRM);

   chxclear  (str);
   chxformat (str, CQ("%08x"), vaxtrim(buffer), 0L, nullchix, nullchix);
   jixreduce (str);
#endif


/*---------------------IBM PC----------------------------------------*/
#if IM | JM | PN
   ENTRY  ("systemid", "");
   chxcpy (str, CQ("ibmpc"));
#endif


/*---------------------PRIME-----------------------------------------*/
#if PR
   ENTRY  ("systemid", "");
   chxcpy (str, CQ("prime"));
#endif


/*---------------------VM/CMS----------------------------------------*/
#if CVM
   ENTRY  ("systemid", "");
   chxcpy (str, CQ("vm/cms"));
#endif


/*---------------------Machines without unique system identifiers------*/
#if FU | MU | TX
   ENTRY  ("systemid", "");
   chxcpy (str, CQ("unix"));
#endif

   RETURN (1);
}
