
/*** SYSTIME.  Returns absolute system time (in some constant units,
/    presumably seconds since some fixed date.) as a LONG int. */

/*** Copyright (C) 1983 Camber-Roth.  All rights reserved.  */

/*: AA  7/29/88 17:45 Source code master starting point */
/*: CR  9/29/88 15:21 Add "CX" system type. */
/*: CR 10/07/88 16:33 Make IM same as UNIX. */
/*: CR 11/04/88 13:51 Remove VM, add CA, CVM. */
/*: CR  1/09/89 12:32 Make CVM same as everyone else. */
/*: CW  5/08/89 15:17 Add PX system code. */
/*: JV 10/04/89 18:24 Stripped out AOS non-server code. */
/*: JV 10/09/89 11:04 Changed AOS code to direct system calls. */
/*: JV 10/31/89 12:46 Changed AOS back to time() */
/*: CR  9/20/90 17:03 Add PS system type. */
/*: CJ 11/26/90 21:50 Add LA system type code. */
/*: CR 10/21/92 15:26 Add missing AOS comment end, #endif. */

#include <stdio.h>
#include "caucus.h"
#include "systype.h"

FUNCTION  long systime()
{

/*----------------------------------FORTUNE & VAX & MASSCOMP & A3 | LA--------*/
#if UNIX | VV | PR | IM | PN | CX | CVM | PX | CA | PS
   long time();

   ENTRY ("systime", "");
   RETURN (time ( (long *) 0) );
#endif

/*--------------------------------AOS/VS (Client/Server)---------------*/
#if CA
   int sec, bisec, min, hour, day, month, year, totaldays;
   long  todaysec;

   ENTRY ("systime", "");
   sys_gday (&day, &month, &year);                /* Compute number of days 
   sys_fday (day, month, year, &totaldays);       /* since 1-JAN-68 
   todaysec = totaldays * 86400;

   sys_gtod (&sec, &min, &hour);              /* Compute number of
   sys_ftod (sec, min, hour, &bisec);         /* biseconds since midnight. 
   RETURN (todaysec + bisec*2); */
#endif
}
