
/*** SYSVMEDIT.   Access to VM/CMS full-screen editing. 
/
/    ok = sysvmedit (file, context);
/
/    Parameters:
/       int   file;       (unit number of file to append text to)
/       int   context;    (is there already text to be left on screen?)
/
/    Purpose:
/       Open a full-screen editing window (with wordwrap) for VM/CMS
/       systems.
/
/       For all other systems, this is a no-op.
/
/    How it works:
/
/    Returns: 1 on success
/             0 otherwise
/
/    Error Conditions:
/  
/    Side effects:
/
/    Related functions: vmiedit()
/
/    Called by:  textenter()
/
/    Operating system dependencies: VM/CMS
/
/    Known bugs:
/
/    Home:  sys/sysvmedi.c
/ */

/*** Copyright (C) 1990 by Camber-Roth.  All rights reserved. */

/*: CX  6/04/92 17:46 New function. */

#include <stdio.h>
#include "caucus.h"
#include "handicap.h"
#include "systype.h"

FUNCTION  sysvmedit (file, context)
   int    file, context;
{

#if UNIX | IM | PN | PR | VV | CA | CX
   return (0);
#endif

#if CVM | PX | PS
   extern struct flag_template flag;

   ENTRY  ("systextinput", "");
   RETURN (flag.fullscreen ? vmiedit (file, context) : 0);
#endif

}
