
/*** UNIT_CHECK.  Does a file exist?
/
/    Assumes that the caller has already locked the file of type N.
/    Returns 1 if that file exists, and 0 otherwise. */

/*** Copyright (C) 1983 Camber-Roth.  All rights reserved.  */

/*: AA  7/29/88 17:54 Source code master starting point */
/*: CR  9/30/88 15:50 Add server code in "#if SRV" section. */
/*: CR 11/09/88 15:43 Add #include "errchk.h" to SRV code. */
/*: JV  2/10/89 15:46 Casted vcsend parms in SRV.*/
/*: CR  3/21/89 15:26 Add use of servername to #if SRV code. */
/*: JV  4/05/89 21:34 Added code to stop client if server is dead. */
/*: CW  5/08/89 14:56 Add PX system code. */
/*: CW  5/19/89 12:51 Add XW unit codes. */
/*: JV  3/23/90 12:12 Surround syscheck() call with sysprv(0/1). */
/*: CR  9/20/90 16:55 Add PS system type. */
/*: DE  4/09/92 13:18 Chixified */
/*: JX 10/08/92 11:00 Fixify. */

#include <stdio.h>
#include "caucus.h"
#include "systype.h"
#include "units.h"

#if SRV
#include "actions.h"
extern int   vcernum;
extern char *vcernam;
extern Flag  localfile[];
extern Chix  confid;
extern Chix  servername;
#endif
 
extern struct unit_template units[];

FUNCTION  unit_check (n)
   int  n;
{

#if UNIX | IM | JM | VV | PR | PN | AOS | PX | PS
   int  exists;

   ENTRY  ("unitcheck", "");
   if (n < XURG)  sysprv(0);
   exists = syscheck (units[n].nameis);
   if (n < XURG)  sysprv(1);
   RETURN (exists);
#endif


#if SRV
#include "errchk.h"
   extern int   vcernum;
   extern char *vcernam;

   short  class;
   char   stat;

   ENTRY  ("unitcheck", "");

   if (localfile[n])  RETURN (syscheck (units[n].nameis));

   class = ACHEK + n;
   if (NOT vcsend (servername, class, NULL, 0, (char *) &stat, 1)) {
      ERRCHK("unitcheck");
      unit_write (XWER, CQ("Caucus Server has terminated.\n"));
      unit_write (XWER, CQ("Caucus is now aborting.\n"));
      sysexit (0);
   }
   RETURN (stat);
#endif

}
