/*** UNITGLOBALS.  Definition of data structures global to the UNIT
/    i/o routines. */

/*: AA  7/29/88 17:54 Source code master starting point */
/*: CR  8/04/88 12:38 VM changes only */
/*: CR  9/21/88 15:42 Add "HU" system type for HP/UX. */
/*: CR  9/23/88 12:59 Add "IX" system type. */
/*: CR  9/30/88 16:19 Replace VM code with SRV server code. */
/*: CR 10/07/88 16:31 Remove IM definition of _stack. */
/*: CR 11/15/88 16:09 XUOU is not local for CA & CX. */
/*: CR 11/22/88 17:42 Add PN code. */
/*: CR  1/31/89 14:48 Add XCLG to shouldlock[] and localfile[]. */
/*: CR  4/29/89 14:10 Break SU into SS (lockf) and SN (guardian files). */
/*: CR  6/09/89 12:21 Add "SV" system type code. */
/*: CR  8/09/89 15:17 Add XSMK to tables. */
/*: CW  5/07/89 14:23 Add XSPV file. */
/*: CW  5/08/89 14:56 Add PX system code. */
/*: CR 10/12/89 15:43 Add DU system type code. */
/*: CR 11/14/89 17:25 Add XSMO file. */
/*: CR  1/26/90 23:44 Master.opt should not be locked. */
/*: JV  2/26/90 15:58 CA: XSMD is a localfile. SRV:  XSMO gets locked. */
/*: JV  7/80/90 18:23 Add MIPS RISC/os (RO). */
/*: CR  7/16/90  7:58 Add values for XSUG. */
/*: CR  9/20/90 16:55 Add PS system type. */
/*: CR  9/27/90 12:23 Add U3, AU system types. */
/*: CJ 11/26/90 21:46 Add LA system type. */
/*: CR  3/02/91 19:06 Add XIBB bit bucket. */
/*: SB 11/30/90 11:07 Add DY system code*/
/*: CR  3/11/91 14:10 Add AX and UL system type codes. */
/*: JV  2/08/91 21:42 CA: made XSMO a localfile (to agree with the code). */
/*: JV  2/08/91 21:45 Removed non-server machine codes from localfile. */
/*: JV  3/06/91 22:15 Add unittag[][] for debugging. */
/*: CR  4/06/91 17:34 Integrate recent changes. */
/*: JV  4/11/91 15:38 Add CaucusNet units. !!!Inserted some #'s! */
/*: JV  4/12/91 11:07 Add Unix, etc to localfile[XUOU]. */
/*: JV  5/23/91 17:44 Add CaucusNet XCTC, chg XHST->XHI1, XHI2. */
/*: JV  6/14/91 16:25 Fix Net codes. */
/*: JV  7/15/91 18:59 Add XSRP, remove XRRP. */
/*: JV  7/19/91 10:12 Fix unittag. */
/*: CR  8/08/91 16:42 Shouldlock XHSV, XHSL. */
/*: CR  8/19/91 23:53 Add XRCC, XRCH, XRRL. */
/*: CR  9/04/91 16:23 Use LZZZ in defining size of locktype[]. */
/*: CR  9/05/91 15:47 Remove XPXF, XPXC, XPXR, XRXF: make XPXJ 0. */
/*: CR  9/06/91 13:50 Include unitwipe.h. */
/*: JV 10/08/91 12:00 Add XSRD/XSRN to unittag. */
/*: JV 10/14/91 12:08 Add XSR2, 2nd XSRP file. */
/*: JV 10/17/91 13:00 Add Audit files: XAxxx. */
/*: JV 12/10/91 18:12 Add XHDD. */
/*: CR  1/06/92 18:25 Add DP system type. */
/*: JV  1/20/92 11:30 Add XCUX. */
/*: CR  6/09/92 14:12 Add XIMF. */
/*: CR  9/04/92 14:21 Add XULG stuff. */
/*: CX  6/05/92 11:45 Add XISF. */
/*: JX  8/05/92 09:52 Add XSUP, renumber everything after 89. */
/*: CI 10/07/92 23:20 Chix Integration. */
/*: TP 10/14/92 17:34 Add XIAL, renumber XURG -> XULG. */
/*: CR 10/30/92 14:44 Add XIOF. */
/*: JV 10/26/92 14:32 Add XHRV, cleanup renumbering. */
/*: CR 11/15/92 21:58 Locktype initialization must use longs. */
/*: CR  2/24/93 13:00 Add U4. */
/*: JV  2/26/93 23:09 Add File Attachment units XACD, XAUD, XARF, XAMF. */
/*: JV  3/03/93 17:15 Add XSAM. */
/*: JV  3/26/93 15:45 Add XUDD. */
/*: JV  5/24/93 14:32 Add XART, XAMT. */
/*: CN  5/16/93 18:24 Add XCED,XCEN, XCFD, XCFN. */
/*: CP  7/08/93 15:57 Integrate 2.5 changes. */

#include <stdio.h>
#include "caucus.h"
#include "systype.h"
#include "units.h"
#include "unitcode.h"
#include "unitwipe.h"

#if PR
char   primepass[10];
char   primekey[] = {"WBIRCH"};
struct buf_template bufhead = {NULL, NULL, 0, 0, 0};
#endif

#define SYSV1  A3 | LA | SV | HU | FU | MU | MV | PU | SX | SS | TX | PN
#define SYSV2  IX | PN | PX | DU | RO | PS | U3 | AU | DY | AX | DP | U4
#if SYSV1 | SYSV2
struct locktype_t locktype[LZZZ+1] =
  { { -1, 0L, "", ""},  { -1, 0L, "", ""},  { -1, 0L, "", ""},
    { -1, 0L, "", ""},  { -1, 0L, "", ""},  { -1, 0L, "", ""} };
#endif

struct unit_template units[XLAST+1];

char shouldlock [XLAST+1] = {
   0,   /* XIRE  0   redirection */
   0,   /* XIPT  1   print */
   0,   /* XITX  2   misc text 1 */
   0,   /* XITY  3   misc text 2 */
   0,   /* XICE  4   caucus ed file */
   0,   /* XILM  5   last message sent */
   0,   /* XICF  6   Input Command File */
   0,   /* XISF  7   Input Session File */
   0,   /* XIMF  8   Input Menu File. */
   0,   /* XIBB  9   Output Bit Bucket. */
   0,   /* XIAL 10   "all" input. */
   0,   /* XIOF 11   FILEOUTPUT file. */
   0,   /* 12 */

   1,   /* XURG 13   user registration */
   1,   /* XUMD 14   user mess dir */
   1,   /* XUMF 15   user mess file  */
   1,   /* XUND 16   user sub name dir   */
   1,   /* XUNN 17   user sub names  */
   1,   /* XUSD 18   user subject dir  */
   1,   /* XUSF 19   user subjects  */
   1,   /* XUOD 20   user ordered subs dir  */
   1,   /* XUON 21   user ordered subs  */
   1,   /* XUPA 22   user participation, per conference  */
   1,   /* XUOU 23   only one user  */
   1,   /* XUXF 24   user xaction file */
   0,   /* XUXT 25   user xaction tempfile */
   1,   /* XULG 26   user logfeature file */
   0,   /* XUDD 27   user directory */
   0, 0,  /* 28-29 */

   1,   /* XCRD 30   conference response directory  */
   1,   /* XCRF 31   conference response files  */
   1,   /* XCMD 32   membership directory  */
   1,   /* XCMN 33   membership names  */
   1,   /* XCTD 34   item title dir  */
   1,   /* XCTN 35   item title names  */
   1,   /* XCAD 36   author dir  */
   1,   /* XCAN 37   author names  */
   1,   /* XCND 38   sub names dir  */
   1,   /* XCNN 39   sub names  */
   1,   /* XCSD 40   subject dir  */
   1,   /* XCSF 41   subjects  */
   1,   /* XCOD 42   ordered sub names dir  */
   1,   /* XCON 43   ordered sub names  */
   1,   /* XCMA 44   master resp records  */
   1,   /* XCIN 45   introduction to conf  */
   1,   /* XCGR 46   greeting to conf  */
   1,   /* XCUS 47   userlist  */
   0,   /* XCDD 48   conference name */
   1,   /* XCLG 49   by-conference user log file */
   0,   /* XCXT 50   conference xaction file (temp) */
   1,   /* XCNB 51   conference neighbors */
   1,   /* XCTC 52   conference trueconf name */
   0,   /* XCUX 53   conference temp user xactions */
   1,   /* XCED 54   conference item-entry directory. */
   1,   /* XCEN 55   conference item-entry namelist. */
   1,   /* XCFD 56   conference resp-entry directory. */
   1,   /* XCFN 57   conference resp-entry namelist. */
   0, 0,             /* 58-59 */

   0,   /* XSMD 60   master dictionary */
   1,   /* XSND 61   system user names dir  */
   1,   /* XSNN 62   system user names  */
   1,   /* XSPC 63   system print codes  */
   1,   /* XSMU 64   max users enforcement  */
   1,   /* XSPD 65   password dir  */
   1,   /* XSPN 66   passwords  */
   1,   /* XSBG 67   bug list  */
   1,   /* XSLG 68   log file  */
   1,   /* XSCD 69   conference names dir  */
   1,   /* XSCN 70   conference names  */
   1,   /* XSCK 71   clock check  */
   1,   /* XSMK 72   make-directory locking. */
   1,   /* XSPV 73   server maintenance PriViledges */
#if CX | CVM
   1,   /* XSMO 74   master.opt options file */
   1,   /* XSUG 75   user groups. */
#endif
#if CA
   0,   /* XSMO 74   master.opt options file */
   1,   /* XSUG 75   user groups. */
#endif
#if UNIX | IM | JM | PN | PR | VV
   0,   /* XSMO 74   master.opt options file */
   0,   /* XSUG 75   user groups. */
#endif
   1,   /* XSPB 76   parsebay files */
   1,   /* XSHD 77   host names dir */
   1,   /* XSHN 78   host names partfile */
   1,   /* XSNF 79   system info */
   1,   /* XSSM 80   shipping methods */
   1,   /* XSSS 81   shipping scripts */
   1,   /* XSRM 82   receiving methods */
   1,   /* XSRS 83   receiving scripts */
   1,   /* XSPL 84   XFP is running */
   1,   /* XSPU 85   XPU is running */
   1,   /* XSRP 86   ReParseBay files */
   1,   /* XSRD 87   Routing Partfile Dir */
   1,   /* XSRN 88   Routing Partfiles */
   1,   /* XSR2 89   2nd ReParseBay file */
   1,   /* XSUP 90   User Pre-Registration file */
   0,   /* XSAM 91   File Attachment Map File */
   0, 0, 0, 0, 0, 0, 0, 0, /* 92-99 */
   1,   /* XHI1 100   host info */
   1,   /* XHML 101   outbound mail */
   1,   /* XHXA 102   xactions passing thru */
   1,   /* XHI2 103   2nd Host Info */
   1,   /* XHSV 104   host's shipping method variables */
   1,   /* XHSL 105   shipper lock -- only one shipper at a time! */
   0,   /* XHDD 106   host directory */
   1,   /* XHRV 107   host's receiving method variables */
   0,   /* 108 */
   1,   /* XNET 109   "The XFP is running" */
   0, 0, 0,  /* 110, 111, 112, */
   1,   /* XPAK 120  xport files of acks */
   1,   /* XPXH 121  xport header file */
   1,   /* XPXT 122  xport text-file */
   0,   /* XPXJ 123  xport joined-file: only used by one program. */
   1,   /* XPRH 124  xport reship header-file */
   1,   /* XPRT 125  xport text-file */
   1,   /* XPNH 126  cantship header */
   1,   /* XPNT 127  cantship text */
   0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, /* 128-140 */
   1,   /* XRXC 141  xport file chunks (receive) */
   1,   /* XRRX 142  rereceive (seq# too high) */
   1,   /* XRCC 143  chunk counter */
   1,   /* XRCH 144  chunk history record */
   1,   /* XRRL 145  only one receiver per method at a time! */
   0, 0, 0, 0, 0, /* 146-149 */
   1,  /* XAHMI 150  Audit: Incoming Mail, by Host. */
   1,  /* XAHMO 151  Audit: Outgoing Mail, by Host. */
   1,  /* XAHCI 152  Audit: Incoming Conference material, by Host. */
   1,  /* XAHCO 153  Audit: Outgoing Conference material, by Host. */
   1,  /* XAHPI 154  Audit: Incoming People info, by Host. */
   1,  /* XAHPO 155  Audit: Outgoing People info, by Host. */
   1,  /* XAUCO 156  Audit: Outgoing Conference material, by Userid. */
   1,  /* XAUMI 157  Audit: Incoming Mail, by recipient Userid.. */
   1,  /* XAUMO 158  Audit: Outgoing Mail, by sending Userid. */
   1,  /* XACCI 159  Audit: Incoming Conference material, by Conference. */
   1,  /* XACCO 160  Audit: Outgoing Conferecne material, by Conference. */
   0, 0, 0, 0, 0, 0, 0, 0, 0, /* 161-169 */
   1,  /* XACD  170  Conf directory of File Attachments. */
   1,  /* XAUD  171  User directory of F-A's. */
   1,  /* XARF  172  Response-Type F-A's. */
   1,  /* XAMF  173  Message-Type F-A's. */
};

/*** List of "local" files on server-based systems. */
#if SRV
char localfile[XLAST+1] = {
   1,   /* XIRE  0   redirection */
   1,   /* XIPT  1   print */
   1,   /* XITX  2   misc text 1 */
   1,   /* XITY  3   misc text 2 */
   1,   /* XICE  4   caucus ed file */
   1,   /* XILM  5   last message sent */
   1,   /* XICF  6   Input Command File */
   1,   /* XISF  7   Input Session File */
   1,   /* XIMF  8   Input Menu File. */
   1,   /* XIBB  9   Output Bit Bucket. */
   1,   /* XIAL 10   "all" input. */
   1,   /* XIOF 11   FILEOUTPUT file. */
   0,   /* 12 */

   0,   /* XURG 13   user registration */
   0,   /* XUMD 14   user mess dir */
   0,   /* XUMF 15   user mess file  */
   0,   /* XUND 16   user sub name dir   */
   0,   /* XUNN 17   user sub names  */
   0,   /* XUSD 18   user subject dir  */
   0,   /* XUSF 19   user subjects  */
   0,   /* XUOD 20   user ordered subs dir  */
   0,   /* XUON 21   user ordered subs  */
   0,   /* XUPA 22   user participation, per conference  */
#if CX | CA | UNIX | IM | JM | PN | PR | VV
   0,   /* XUOU 23   only one user  */
#endif
#if CVM
   1,   /* XUOU 23   only one user  */
#endif
   0,   /* XUXF 24   user xactions */
   0,   /* XUXT 25   user xactions (temp) */
   0,   /* XULG 26   user logfeature file */
   0,   /* XUDD 27   user logfeature file */
   0, 0, /* 28-29 */

   0,   /* XCRD 30   conference response directory  */
   0,   /* XCRF 31   conference response files  */
   0,   /* XCMD 32   membership directory  */
   0,   /* XCMN 33   membership names  */
   0,   /* XCTD 34   item title dir  */
   0,   /* XCTN 35   item title names  */
   0,   /* XCAD 36   author dir  */
   0,   /* XCAN 37   author names  */
   0,   /* XCND 38   sub names dir  */
   0,   /* XCNN 39   sub names  */
   0,   /* XCSD 40   subject dir  */
   0,   /* XCSF 41   subjects  */
   0,   /* XCOD 42   ordered sub names dir  */
   0,   /* XCON 43   ordered sub names  */
   0,   /* XCMA 44   master resp records  */
   0,   /* XCIN 45   introduction to conf  */
   0,   /* XCGR 46   greeting to conf  */
   0,   /* XCUS 47   userlist  */
   0,   /* XCDD 48   conference name */
   0,   /* XCLG 49   by-conference user log */
   0,   /* XCXT 50   conf xaction (temp) file */
   0,   /* XCNB 51   conference neighbors */
   0,   /* XCTC 52   conference trueconf name */
   0,   /* XCUX 53   conference temp user xactions */
   0,   /* XCED 54   conference item-entry directory. */
   0,   /* XCEN 55   conference item-entry namelist. */
   0,   /* XCFD 56   conference resp-entry directory. */
   0,   /* XCFN 57   conference resp-entry namelist. */
   0, 0,             /* 58-59 */
#if CA
   1,   /* XSMD 60   master dictionary */
#endif
#if UNIX | IM | JM | PN | PR | VV | CVM | CX
   0,   /* XSMD 60   master dictionary */
#endif
   0,   /* XSND 61   system user names dir  */
   0,   /* XSNN 62   system user names  */
   0,   /* XSPC 63   system print codes  */
   0,   /* XSMU 64   max users enforcement  */
   0,   /* XSPD 65   password dir  */
   0,   /* XSPN 66   passwords  */
   0,   /* XSBG 67   bug list  */
   0,   /* XSLG 68   log file  */
   0,   /* XSCD 69   conference names dir  */
   0,   /* XSCN 70   conference names  */
   0,   /* XSCK 71   clock check  */
   0,   /* XSMK 72   make-directory locking. */
   0,   /* XSPV 73   server maintenance priviledge */
#if CA
   1,   /* XSMO 74   master.opt options file */
#endif
#if UNIX | IM | JM | PN | PR | VV | CVM | CX
   0,   /* XSMO 74   master.opt options file */
#endif
   0,   /* XSUG 75   user groups. */
   0,   /* XSPB 76   parsebay files */
   0,   /* XSHD 77   host names dir */
   0,   /* XSHN 78   host names pfile */
   0,   /* XSNF 79   system info */
   0,   /* XSSM 80   shipping method list */
   0,   /* XSSS 81   shipping scripts */
   0,   /* XSRM 82   receiving method list */
   0,   /* XSRS 83   receiving scripts */
   0,   /* XSPL 84   XFP is running */
   0,   /* XSPU 85   XFU is running */
   0,   /* XSRP 86   ReParseBay files */
   0,   /* XSRD 87   Routing Partfile Dir */
   0,   /* XSRN 88   Routing Partfiles */
   0,   /* XSR2 89   2nd ReParseBay file */
   0,   /* XSUP 90   User Pre-Registration File */
   0,   /* XSAM 91   File Attachment Map File */
   0, 0, 0, 0, 0, 0, 0, 0,  /* 92-99 */
   0,   /* XHI1 100   hostinfo */
   0,   /* XHML 101   outbound mail */
   0,   /* XHXA 102   xactions passing thru */
   0,   /* XHI2 103   2nd hostinfo */
   0,   /* XHSV 104   Shipping info variables */
   0,   /* XHSL 105   Shipper lock */
   0,   /* XHDD 106   Host directory */
   0,   /* XHRV 107   Receiving info variables */
   0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  /* 108-119 */
   0,   /* XPAK 120  ack xport files */
   0,   /* XPXH 121  xport header file */
   0,   /* XPXT 122  xport text-file */
   0,   /* XPXJ 123  xport joined-file */
   0,   /* XPRH 124  xport reship header-file */
   0,   /* XPRT 125  xport text-file */
   0,   /* XPNH 126  cantship */
   0,   /* XPNT 127  cantship text file */
   0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, /* 128-140 */
   0,   /* XRXC 141  xport file chunks (receive) */
   0,   /* XRRX 142  rereceive (seq# too high) */
   0,   /* XRCC 143  receive chunk counter */
   0,   /* XRCH 144  received chunk history record */
   0,   /* XRRL 145  only 1 receiver per ship method at a time */
   0, 0, 0, 0, /* 146-149 */
   0,   /* XAHMI 150  Audit: Incoming Mail, by Host. */
   0,   /* XAHMO 151  Audit: Outgoing Mail, by Host. */
   0,   /* XAHCI 152  Audit: Incoming Conference material, by Host. */
   0,   /* XAHCO 153  Audit: Outgoing Conference material, by Host. */
   0,   /* XAHPI 154  Audit: Incoming People info, by Host. */
   0,   /* XAHPO 155  Audit: Outgoing People info, by Host. */
   0,   /* XAUCO 156  Audit: Outgoing Conference material, by Userid. */
   0,   /* XAUMI 157  Audit: Incoming Mail, by recipient Userid.. */
   0,   /* XAUMO 158  Audit: Outgoing Mail, by sending Userid. */
   0,   /* XACCI 159  Audit: Incoming Conference material, by Conference. */
   0,   /* XACCO 160  Audit: Outgoing Conferecne material, by Conference. */
   0, 0, 0, 0, 0, 0, 0, 0, 0, /* 161-169 */
   0,   /* XACD  170  /* Conf directory of File Attachments. */
   0,   /* XAUD  171  /* User directory of F-A's. */
   0,   /* XARF  172  /* Response-Type F-A's. */
   0,   /* XAMF  173  /* Message-Type  F-A's. */
   0,   /* XART  174  /* Response-Type F-A's, temporary file. */
   0,   /* XAMT  175  /* Message-Type  F-A's, temporary file. */
};
#endif

/*** Unittag: an array of names of the units, only for debugging porpoises. */
char *unittag [XLAST+1] = {
   "XIRE",     /*   redirection */
   "XIPT",     /*   print */
   "XITX",     /*   misc text 1 */
   "XITY",     /*   misc text 2 */
   "XICE",     /*   caucus ed file */
   "XILM",     /*   last message sent */
   "XICF",     /*   Input Command File */
   "XISF",     /*   Input Session File */
   "XIMF",     /*   Input Menu File */
   "XIBB",     /*   Output bit bucket. */
   "XIAL",     /*   "all" input. */
   "XIOF",     /*   FILEOUTPUT file. */
   NULL, /* 12 */

   "XURG",     /*   user registration */
   "XUMD",     /*   user mess dir */
   "XUMF",     /*   user mess file  */
   "XUND",     /*   user sub name dir   */
   "XUNN",     /*   user sub names  */
   "XUSD",     /*   user subject dir  */
   "XUSF",     /*   user subjects  */
   "XUOD",     /*   user ordered subs dir  */
   "XUON",     /*   user ordered subs  */
   "XUPA",     /*   user participation, per conference  */
   "XUOU",     /*   only one user  */
   "XUXF",     /*   user xaction file */
   "XUXT",     /*   user xaction file (temp) */
   "XULG",     /*   user logfeature file */
   "XUDD",     /*   user directory */
    NULL, NULL,            /* 28-29 */

   "XCRD",     /*   conference response directory  */
   "XCRF",     /*   conference response files  */
   "XCMD",     /*   membership directory  */
   "XCMN",     /*   membership names  */
   "XCTD",     /*   item title dir  */
   "XCTN",     /*   item title names  */
   "XCAD",     /*   author dir  */
   "XCAN",     /*   author names  */
   "XCND",     /*   sub names dir  */
   "XCNN",     /*   sub names  */
   "XCSD",     /*   subject dir  */
   "XCSF",     /*   subjects  */
   "XCOD",     /*   ordered sub names dir  */
   "XCON",     /*   ordered sub names  */
   "XCMA",     /*   master resp records  */
   "XCIN",     /*   introduction to conf  */
   "XCGR",     /*   greeting to conf  */
   "XCUS",     /*   userlist  */
   "XCDD",     /*   conference name */
   "XCLG",     /*   49 by-conference user log file. */
   "XCXT",     /*   conf xaction (temp) file */
   "XCNB",     /*   51 conf neighbors */
   "XCTC",     /*   52 trueconf name */
   "XCUX",     /*   53 conference temp user xactions */
   "XCED",     /*   54 conference item-entry directory. */
   "XCEN",     /*   55 conference item-entry namelist. */
   "XCFD",     /*   56 conference resp-entry directory. */
   "XCFN",     /*   57 conference resp-entry namelist. */
   NULL, NULL,    /* 58-59 */

   "XSMD",     /*   60 master dictionary */
   "XSND",     /*   system user names dir  */
   "XSNN",     /*   system user names  */
   "XSPC",     /*   system print codes  */
   "XSMU",     /*   max users enforcement  */
   "XSPD",     /*   password dir  */
   "XSPN",     /*   passwords  */
   "XSBG",     /*   bug list  */
   "XSLG",     /*   log file  */
   "XSCD",     /*   conference names dir  */
   "XSCN",     /*   conference names  */
   "XSCK",     /*   clock check  */
   "XSMK",     /*   make-directory locking. */
   "XSPV",     /*   server maintenance PriViledges */
   "XSMO",     /*   master.opt options file */
   "XSUG",     /*   user groups. */
   "XSPB",     /*   parsebay */
   "XSHD",     /*   host names dir */
   "XSHN",     /*   host name pfiles */
   "XSNF",     /*   system info */
   "XSSM",     /*   shipping methods list */
   "XSSS",     /*   shipping scripts */
   "XSRM",     /*   receiving methods */
   "XSRS",     /*   receiving scripts */
   "XSPL",     /*   XFP is running */
   "XSUL",     /*   XFU is running */
   "XSRP",     /*   ReParseBay files */
   "XSRD",     /*   routing table dir */
   "XSRN",     /*   routing table pfiles */
   "XSR2",     /*   2nd ReParseBay file */
   "XSUP",     /*   User Pre-registration file. */
   "XSAM",     /*   File Attachment Map File. */
   NULL, NULL, NULL, NULL,  /* 92-95 */
   NULL, NULL, NULL, NULL,        /* 96-99 */
   "XHI1",     /*   host info */
   "XHML",     /*   outbound mail */
   "XHXA",     /*   xactions passing thru */
   "XHI2",     /*   2nd host info */
   "XHSV",     /*   Shipping variables */
   "XHSL",     /*   Shipper Lock */
   "XHDD",     /*   Host Directory */
   "XHRV",     /*   Receiving variables */
   NULL,       /* 108 */
   "XNET",     /*   XFP is running */
   NULL, NULL, NULL, NULL, NULL, /* 110-114 */
   NULL, NULL, NULL, NULL, NULL, /* 115-119 */
   "XPAK",     /*   xport ack */
   "XPXH",     /*   121 xport header-file */
   "XPXT",     /*   122 xport text-file */
   "XPXJ",     /*   xport joined-file */
   "XPRH",     /*   reship header-file */
   "XPRT",     /*   reship text-file */
   "XPNH",     /*   cantship header */
   "XPNT",     /*   127 cantship text */
   NULL, NULL, NULL, NULL, NULL, NULL,       /* 128-133 */
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, /* 134-140 */
   "XRXC",     /*   receive chunk */
   "XRRX",     /*   ReReceive (seq# too high) */
   "XRCC",     /*   Receive Chunk Counter. */
   "XRCH",     /*   Received Chunk History record. */
   "XRRL",     /*   only one receiver per ship method at a time. */
   NULL, NULL, NULL, NULL,    /* 146-149 */
   "XAHMI",    /* Audit: Incoming Mail, by Host. */
   "XAHMO",    /* Audit: Outgoing Mail, by Host. */
   "XAHCI",    /* Audit: Incoming Conference material, by Host. */
   "XAHCO",    /* Audit: Outgoing Conference material, by Host. */
   "XAHPI",    /* Audit: Incoming People info, by Host. */
   "XAHPO",    /* Audit: Outgoing People info, by Host. */
   "XAUCO",    /* Audit: Outgoing Conference material, by Userid. */
   "XAUMI",    /* Audit: Incoming Mail, by recipient Userid.. */
   "XAUMO",    /* Audit: Outgoing Mail, by sending Userid. */
   "XACCI",    /* Audit: Incoming Conference material, by Conference. */
   "XACCO",    /* Audit: Outgoing Conferecne material, by Conference. */
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, /* 161-169 */
   "XACD",     /* Conf directory of File Attachments. */
   "XAUD",     /* User directory of F-A's. */
   "XARF",     /* Response-Type F-A's. */
   "XAMF",     /* Message-Type  F-A's. */
   "XART",     /* Response-Type F-A's, temporary file. */
   "XAMT",     /* Message-Type  F-A's, temporary file. */
};

FUNCTION unitglobals()
{
   ENTRY  ("unitglobals", "");
   RETURN (1);
}
