
/*** UNIT_MOVE.  Moves (renames) file number A to file number B. 
/
/    Both files A and B must have been locked by UNIT_LOCK.
/    Returns 1 if successful, and 0 otherwise. */

/*** Copyright (C) 1984 Camber-Roth.  All rights reserved. */

/*: AA  7/29/88 17:55 Source code master starting point */
/*: CR  9/30/88 16:29 Replace VM code with SRV server code. */
/*: CW  5/08/89 14:56 Add PX system code. */
/*: CR  9/12/89 17:00 Declare bugtell(). */
/*: WC  3/23/90 16:14 Surround sysrename() call with sysprv(0/1). */
/*: CR  8/12/90 18:56 Fix bugtell() call for lint. */
/*: CR  9/20/90 16:55 Add PS system type. */

#include "caucus.h"
#include <stdio.h>
#include "systype.h"
#include "units.h"

extern struct unit_template units[];
extern int                  debug;

FUNCTION  unit_move (a, b)
   int    a, b;
{
   char  *bugtell();

#if SRV
   extern char localfile[];
   char   buf[80];

   ENTRY  ("unitmove", "");

   if (NOT localfile[a]  ||  NOT localfile[b]) {
      sprintf (buf, "Error in Unit_move: non local files %d %d", a, b);
      buglist (buf);
      RETURN  (0);
   }
   RETURN (sysrename (units[a].nameis, units[b].nameis));
#endif

#if UNIX | IM | JM | PN | PR | VV | AOS | PX | PS
   int   success, local;

   ENTRY  ("unitmove", "");
   local = (a < XURG  &&  b < XURG);
   if (local)  sysprv(0);
   success = sysrename (units[a].nameis, units[b].nameis);
   if (local)  sysprv(1);
   if (debug) {
      char  both[120];
      sprintf (both, "%s -> %s", units[a].nameis, units[b].nameis);
      bugtell ("MOVE", success, (long) (a*1000L + b), both);
   }
   RETURN (success);
#endif
}
