
/*** DICRENAME.  Renames file A to file B.
/
/    Returns 1 if successful, and 0 otherwise.
/
/  */

/*** Copyright (C) 1986 Camber-Roth.  All rights reserved. */

/*: JV  2/16/89 10:09 Needed because SRV can't use syscopy. */
/*: CR  4/17/89 14:51 Remove CX from "UNIX | CX". */
/*: CR  7/05/89 15:42 Modify VV #include syntax to pass other compilers. */
/*: JV 10/31/89 12:30 Change CA code to warn if couldn't rename proplerly.*/
/*: CR  4/25/91 13:32 Ultrix code resets file permissions. */
/*: CR  9/05/92 12:35 Make MV like UL. */

#include <stdio.h>
#include "caucus.h"
#include "systype.h"
#if CA
#include <fcntl.h>
#endif

extern int debug;

FUNCTION  dicrename (a, b)
   char   a[], b[];
{

/*------------------------------------VAX-----------------------------*/
#if VV
#include <ssdef>
#include <descrip>

   struct dsc$descriptor_s a_desc, b_desc;

   ENTRY ("dicrename", "");
   a_desc.dsc$w_length  = strlen (a);
   a_desc.dsc$a_pointer = a;
   a_desc.dsc$b_class   = DSC$K_CLASS_S;
   a_desc.dsc$b_dtype   = DSC$K_DTYPE_T;

   b_desc.dsc$w_length  = strlen (b);
   b_desc.dsc$a_pointer = b;
   b_desc.dsc$b_class   = DSC$K_CLASS_S;
   b_desc.dsc$b_dtype   = DSC$K_DTYPE_T;

   if (lib$rename_file (&a_desc, &b_desc) == SS$_NORMAL)   RETURN (1);
   syscopy (a, b);
   delete  (a);
   RETURN  (1);
#endif

/*----------------------------FORTUNE & MASSCOMP & A3-----------------*/
#if UNIX
   ENTRY  ("dicrename", "");
   if (link (a, b) < 0)  syscopy (a, b);
   unlink (a);
#if UL | MV
   chmod  (b, 0770);
#endif
   RETURN (1);
#endif

/*---------------------------Client Xenix--------------------------*/
#if CX
   int fda, fdb, len;
   char buf[1024];
   ENTRY ("dicrename", "");
   if (link (a, b) < 0) {
      fda = open  (a,    0);
      fdb = creat (b, 0600);
      for (len=1024; (len = read (fda, buf, len)) > 0;)
         write (fdb, buf, len);
   }
   unlink (a);
   RETURN (1);
#endif

/*---------------------------Client  AOS------------------------------*/
#if CA
   int err, fda, fdb, len, ret;
   char buf[1024];
   ENTRY   ("dicrename", "");
   err = amove (a, b);
   if (err) {
      fda = open  (a, O_RDONLY, 0);
      fdb = creat (b, 0700);
      for (len=1024; (len = read (fda, buf, len)) > 0;)
         if ((ret = write (fdb, buf, len)) < len) {
	    printf ("Error: MAKEMD could not write out the dictionary file.\n");
            printf ("       Try again, after checking the disk space left\n");
            printf ("       on this account.\n"); 
            break;}
      sys_delete (a);
   }
   RETURN (1);
#endif

/*------------------------------------PRIME---------------------------*/
#if PR
   ENTRY  ("dicrename", "");
   move   (a, b);
   RETURN (1);
#endif

/*-------------------------------IBM PC----------------------------------*/
#if IM | PN
   ENTRY ("dicrename", "");

   /*** Try simply renaming file A.  If that fails, copy A -> B,
   /    then delete A. */
   if (rename (a, b) < 0) {
      syscopy (a, b);
      unlink  (a);
   }

   RETURN (1);
#endif

/*---------------------------------------VM/CMS--------------------------*/
#if CVM
   ENTRY  ("sysrename", "");
   RETURN (rename (a, b) == 0);
#endif
}
