/*** mailxp_ship.   Put mail xactions into a transport file in a shipping
/         bay.
/
/   int n = mailxp_ship (hostptr);
/
/   Parameters:
/      HOSTPTR hostptr;
/
/   Purpose:
/      Whenever a user sends mail to a user on another host, Caucus will
/      turn the request into a transaction and append it to XHML.  Here
/      we take XHML, turn it into a xport file, and put it in the right
/      shipping bay.
/
/   How it works:
/      I'm not telling.
/
/      Assumes XHI1 for this neighbor is locked for WRITE.
/
/   Returns:
/      1 on success (which may be "there wasn't any mail").
/      0 on failure.  In this case it logs the error in the bugfile.
/
/   Error Conditions:
/
/   Related Functions:
/      nextneighbor()
/
/   Called by: xfp (main)
/
/   Home: xfp/mailxpsh.c
/ */

/*: JV  4/10/91 11:51 Create this. */
/*: JV  6/28/91 13:28 Pre-Integration CARVMark*/
/*: JV  7/24/91 07:06 Kill XHML after copying it. */
/*: UL 12/11/91 18:45 Make unit_lock args 3-6 long.*/
/*: DE  6/09/92 11:28 Chixified */
/*: CP  3/04/93 23:16 Remove nested comment. */

#include <stdio.h>
#include "chixuse.h"
#include "handicap.h"
#include "xaction.h"
#include "unitcode.h"
#include "xfp.h"

FUNCTION mailxp_ship (hostptr)
   HOSTPTR hostptr;
{
   ENTRY ("mailxp_ship", "");
   if (NOT unit_lock (XHML, READ, L(hostptr->lhnumber), 0L, 0L, 0L, 
                      nullchix)) {
      bug ("MAILXP_SHIP: can't lock XHML.", hostptr->lhnumber); RETURN (0); }
   if (unit_check (XHML))  {
      unit_view (XHML);
      crexport (hostptr->lhnumber, XHML, NEWHEADER, 0, (XPORTHDR *) NULL);
      unit_close (XHML);
      unit_kill  (XHML);
   }
   unit_unlk (XHML);
   RETURN (1);
}   
