/*** MESS_FORWARD.  Forward an e-mail message on to a neighboring host.
/
/  int n = mess_forward (xptr)
/
/  Parameters:
/     XACTIONPTR xptr;
/
/  Purpose:
/     All e-mail that arrives at this host can be divided into two
/     categories: mail intended for users on this host, and mail intended
/     for users on other hosts.  This function forwards the latter type
/     of mail on to a neighboring host for delivery or further forwarding.
/
/  How it works:
/     I don't know yet.
/
/  Returns:
/     1 on success
/     0 on failure.  In this case it logs the error in the bugfile.    
/
/   Error Conditions:
/
/   Related Functions:
/
/   Called by: mess_parse()
/
/   Home: xfu/messpars.c
/ */

/*: JV  7/11/91 16:27 Create this. */
/*: JV  7/15/91 21:45 Add multiple fields. */
/*: JV  7/27/91 16:56 Change call to reparse. */
/*: CR  7/28/91 15:48 chxalloc() first argument is long. */
/*: CR  7/30/91  0:14 Add missing ENTRY! */
/*: JV 11/22/91 17:13 Fix call to addxmess. */
/*: JV 12/07/91 20:36 Deallocate Chixes. */
/*: DE  6/10/92 14:26 Chixified */
/*: CP  3/04/93 23:16 Remove nested comment. */

#include "handicap.h"
#include "derr.h"
#include "chixuse.h"
#include "null.h"
#include "xaction.h"
#include "done.h"

extern union null_t null;

FUNCTION  mess_forward (xptr)
XACTIONPTR xptr;
{
   Chix ochix, chxalloc();
   Chix date, time;
   int  error, success;

   ENTRY ("mess_forward", "");

   date    = chxalloc (20L, THIN, "messforw date");
   time    = chxalloc (20L, THIN, "messforw time");
   success = 0;

   if (xptr->m_oparts) {
      ochix = chxalloc (xptr->datasize[1], THIN, "messforw ochix");
      chxcpy (ochix, xptr->data[1]);
   }
   else ochix = null.chx;

   chxbreak (xptr->date, date, time, CQ(" "));
   addxmessage (xptr->uname, xptr->uid, xptr->title, xptr->mtypenum, ochix,
       xptr->m_oparts, xptr->rrlength, 0, xptr->recname, xptr->recid,
       xptr->rechost, xptr->data[0], date, time, &error);
   chxfree (ochix);
   switch (error) {
      case DBADXACT:
         logx ("Couldn't forward to another host via addxmessage:", xptr);
         FAIL;
      case DLOCK:
      case DFILE:     tellmgr (xptr, error);
      case DMISC:     tellmgr (xptr, error);
      case DNOCHN:    reparse (xptr);
      case NOERR:     SUCCEED;
      default:        FAIL;
   }
done:
   chxfree ( date );
   chxfree ( time );

   RETURN ( success );
}
