/*** STR.C.   Collection of miscellaneous 'C's string handling functions. */

/*: CR  1/24/93 12:03 1st carvmark */
/*: JZ 10/18/93 11:00 Declare strpy() */

#include <stdio.h>
#include "lice2.h"


/*** STRALTER.  Alter 1st occurence of OLD in SSS to NEW. */

FUNCTION stralter (sss, old, new)
   char  sss[], old[], new[];
{
   int   ssslen, oldlen, newlen, pos, delta;
   register int i;
   int   strlen(), strindex();

   ssslen = strlen (sss);   oldlen = strlen (old);   newlen = strlen (new);
   if (ssslen==0 || oldlen==0)         return (0);

   if ((pos = strindex (sss, old)) < 0)  return (0);

   delta = newlen - oldlen;
   if (delta > 0) {
      for (i=ssslen;  i>= pos+oldlen;  --i)  sss[i+delta] = sss[i]; }
   if (delta < 0) {
      for (i=pos+oldlen;  i<=ssslen;   ++i)  sss[i+delta] = sss[i]; }

   for (i=0;  i<newlen;  ++i)  sss[i+pos] = new[i];

   return (1);
}


/*** STRINDEX.  Return starting position in string S of string T. */

FUNCTION  strindex (s, t)
   char  s[], t[];
{
   register int  i, j, k;

   for (i=0;  s[i] != '\0';  i++) {
      for (j=i, k=0;  t[k] != '\0' && s[j]==t[k];  j++, k++) ;
      if (t[k] == '\0')  return (i);
   }
   return (-1);
}


/*** STRLOWER.  Convert string S to all lower case letters. */

strlower (s)
   char  *s;
{
   for (;   *s;   ++s)    if (*s>='A'  &&  *s<='Z')    *s += ('a' - 'A');

   return (1);
}


/*** STRSIMPLIFY.  Simplify a string by removing all unnecessary blanks.
/
/    Specifically, replace all multiple blanks with one blank,
/    and remove all leading and trailing blanks. */

strsimplify (str)
   char  str[];
{
   int   len;

   for (len=strlen(str);   len>0  &&  str[len-1]==' ';)  --len;
   str[len] = '\0';

   while (str[0] == ' ')  stralter (str, " ", "");

   while (stralter (str, "  ", " ")) ;
   return (1);
}

/*** STRTOKEN.  Find the POS'th token in a string.
/
/    STRTOKEN finds the POS'th token in the string LINE, and returns it
/    in WORD.  A token is a sequence of nonblank characters.  The first
/    token in a string is number 1.
/
/    STRTOKEN returns a pointer to the beginning of the found token in 
/    LINE.  If no such token was found, STRTOKEN returns NULL, and
/    sets WORD to the empty string. */

#define FALSE 0
#define TRUE  1

FUNCTION  char *strtoken (word, pos, line)
   char    word[], line[];
   int     pos;
{
   int   between, i, len;
   char  buf[100];
   char  *w, *start, *strcpy();

   /*** BETWEEN means we are between tokens (in the white space).  */
   between  = TRUE;
   len = strlen (line);

   for (i=0;   i<=len;   i++) {

      if (line[i]==' '  ||  line[i]=='\0') {
         if (NOT between) {
            *w = '\0';
            if ((--pos) <= 0) { strcpy (word, buf);    return (start); }
         }
         between = TRUE;
      }

      else {
         if (between)  {
            w       = buf;
            start   = line + i;
            between = FALSE;
         }
         *w++ = line[i];
      }
   }

   word[0] = '\0';
   return (NULL);
}
