/*** SYSIDFORM.  Format user-supplied system id properly. 
/
/    SYSIDFORM is handed a system id typed by a person in STR.  It
/    reformats it according to the standard in routine SYSTEMID and
/    places it back in STR.  */

/*** Copyright (C) 1988 Camber-Roth..  All rights reserved.  */

/*: CR  1/24/93 12:03 1st carvmark */
/*: CR  2/04/93 17:51 Add MV to node-name system list. */

#include <stdio.h>
#include "lice2.h"
#include "systype.h"

FUNCTION  sysidform (str)
   char   str[];
{

/*-----------------------Unixes with host/node-names---------------------*/
#if BU | SU | A3 | PU | IX | HU | LA | UL | AX | MV
   strsimplify (str);
#endif

/*-----------------------Unixes w/o system id's--------------------------*/
#if FU | MU | TX
   strcpy (str, "unix");
#endif

/*------------------------SCO Xenix--------------------------------------*/
#if SX | PX
   char  word1[40], word2[40], old[40];

   strtoken (word1, 1, str);
   strtoken (word2, 2, str);
   if (NULLSTR (word2))  strcpy (word2, "386");

   while (strlen (word1) < 9) {
      strcpy (old, word1);
      strcpy (word1, "0");
      strcat (word1, old);
   }
   sprintf (str, "%s %s", word1, word2);
#endif

/*---------------------------------------VAX-----------------------------*/
#if VV
   long  n, vaxtrim();

   sscanf    (str, "%x", &n);
   sprintf   (str, "%08x", vaxtrim(n));
   strlower  (str);
#endif


/*---------------------IBM PC----------------------------------------*/
#if IM | JM | PN
   strcpy (str, "ibmpc");
#endif


/*---------------------PRIME-----------------------------------------*/
#if PR
   strcpy (str, "prime");
#endif


/*---------------------VM/CMS----------------------------------------*/
#if VM
   strcpy (str, "vm/cms");
#endif

   return (1);
}
