/*** CKILL.  Kill off a Caucus user.  CV2.  */

/*** Copyright (C) 1988 Camber-Roth.  All rights reserved. */

/*: AA  7/29/88 17:58 Source code master starting point */
/*: JV  9/06/89 13:49 Number the list of multiple users, prompt for choice. */
/*: CW  7/20/89 15:26 Add XW unit codes. */
/*: CR 10/10/89 16:40 Move nlfree(users) after nlunique(). */
/*: CR 10/11/89  9:59 Use matchnames() instead of nluserid(). */
/*: CR  3/21/90 13:17 Remove unused variables. */
/*: CR  4/04/90 22:47 Allow "=" as a prefix to indicate userid, not name. */
/*: CR  8/12/90 18:44 New calling sequence for tomember(). */
/*: JV  7/22/90 17:02 Add strtoken decl. */
/*: CR  3/29/91 17:32 Use AND/OR codes for matchnames() call. */
/*: CR  4/02/91 23:02 Wipe user lock stuff before syskill'ing user. */
/*: CR  7/02/91  0:00 Include "unitwipe.h". */
/*: CR  7/30/91 13:59 Call chgxperson to remove dead user from network. */
/*: CR  7/30/91 18:14 Add 3rd arg to loadreg(). */
/*: CR  8/02/91 12:44 Add NOPUNCT as new last arg to modnames() call. */
/*: CR  8/02/91 14:00 Add punctuation argument to matchnames() call. */
/*: CR  8/07/91 14:25 Add 'confnum' arg to syspdir() call. */
/*: CR 11/07/91 14:19 Add confnum arg to matchnames() call. */
/*: CR 11/18/91 17:20 Add CNUM argument to modnames() call. */
/*: DE  6/08/92 13:45 Chixified*/
/*: JX  7/08/92 14:15 Fixify. */
/*: CI 10/06/92 17:40 Chix Integration. */
/*: CL 12/10/92 14:52 Long chxalter args. */
/*: CL 12/10/92 15:22 Long chxindex args. */
/*: CP  5/06/92 12:41 Add 0L as 'item' arg to modnames() call. */

#include <stdio.h>
#include "caucus.h"
#include "unitwipe.h"

extern struct screen_template  used, screen;
extern struct pdir_t           pdir;
extern Chix                    confid, confname;
extern Chix                    yesnotable;
extern Chix                    ss_cmiesc;
extern short                   confnum;
extern union  null_t           null;

FUNCTION  ckill()
{
   struct namlist_t *users, *this, *add, *del, *nlexact, *nlunique(),
                    *nlnode(), *nluserid(), *nlnames();
   Userreg  who, make_userreg();
   Chix   name, answer, no, member;
   Chix   format, newstr;
   int    error;
   short  size, c, i;

   ENTRY ("ckill", "");

   name    = chxalloc (80L,  THIN, "ckill name");
   answer  = chxalloc (20L,  THIN, "ckill answer");
   no      = chxalloc (20L,  THIN, "ckill no");
   member  = chxalloc (80L,  THIN, "ckill member");
   format  = chxalloc (80L,  THIN, "ckill format");
   newstr  = chxalloc (120L, THIN, "ckill newstr");
   who = make_userreg();

   /*** Tell the Killer what we're about. */
   unit_write (XWTX, chxquick(NEWPAGE,0));
   mdwrite    (XWTX, "kil_Tintro", null.md);

   /*** Prompt for the name of a person to be killed. */
   while (1) {
      if (mdprompter ("kil_Pwho", nullchix, 0, "kil_Hwho", 80, name, nullchix)
          < -1)  break;

      /*** If the name starts with the userid prefix ("="), take the userid
      /    directly.  Otherwise, assume we have part of a name and try to
      /    find the matching userid. */
      if (chxindex (name, 0L, ss_cmiesc) == 0) {
         chxalter  (name, 0L, ss_cmiesc, CQ("x "));
         users = nlnode(1);
         nladd (users, name, 0);
      }
      else {
         this = nlnames (name, null.chx);
         matchnames (XSND, XSNN, (int) confnum, nullchix, this, AND, &users,
                     NOPUNCT);
         nlfree (this);
      }
      size = nlsize  (users);

      /*** No names matched, complain and try again. */
      if      (size <= 0) {
         mdwrite (XWER, "kil_Enopers", null.md);
         nlfree  (users);
         continue;
      }

      /*** Multiple people matched, ask user to choose more specifically. */
      if (size > 1) {
         sysbrkclear();
         nlexact = nlunique (name, users, "kil_Tselect");
         nlfree  (users);

         /*** If we got a unique victim, use him/her.  Otherwise,
         /    keep prompting. */
         if (nlexact != null.nl) {
            users   = nlexact;
            nlexact = null.nl;     /* Empty temporary namelist. */
         }
         else continue;
      }

      /*** Display the full information about the selected person, and
      /    prompt for confirmation to be killed. */
      chxtoken  (name, null.chx, 2, (users->next)->str);
      nlfree    (users);
      if (NOT person_is (XWTX, name, 1, null.par, 0)) {
         mdstr   (format, "kil_Fnouid", null.md);
         chxformat (newstr, format, 0L, 0L, name, null.chx);
         unit_write (XWTX, newstr);
         continue;
      }
      chxtoken (no, null.chx, 1, yesnotable);

      c = mdprompter ("kil_Pconfirm", yesnotable, 2, "kil_Hconfirm",
                        10, answer, no);
      if (c  < 0)  break;
      if (c == 0)  continue;

      /*** Remove the person's name from the master name files. */
      loadreg (name, who, NULLSITE);
      add = nlnode  (1);
      del = nlnames (who->name, who->id);
      c = modnames (XSND, XSNN, null.chx, (int) confnum, 0L, add, del, NOPUNCT);
      nlfree (del);
      if (NOT c)  { mdwrite (XWER, "kil_Error", null.md);   continue; }
  
      /*** Let the network know we removed this person. */
      chgxperson (null.chx, who->name, who->id, null.chx, &error);

      /*** Remove the person's name from the membership list of every
      /    conference s/he belongs to. */
      tomember (member, who->lastname, who->name, who->id);
      del = nlnode(1);   nladd (del, member, 0);
      syspdir (&pdir, XUPA, 0, 0, who->id);
      for (i=0;   i<pdir.parts;   ++i) {
         confnum = pdir.resp[i];
         modnames (XCMD, XCMN, null.chx, (int) confnum, 0L, add, del, NOPUNCT);
      }
      nlfree (del);

      /*** Remove the person from the captive-user password file, if there. */
      del = nlnode(1);
      nladd (del, who->id, 0);
      c = matchnames (XSPD, XSPN, (int) confnum, null.chx, del, AND, &users,
                      NOPUNCT);
      nlfree (del);
      if (c) {
         if (nlsize (users) == 1)
            modnames (XSPD, XSPN, null.chx, (int) confnum, 0L, add, users, NOPUNCT);
         nlfree (users);
      }
      nlfree (add);

      /*** Remove the user's USER and TEXT directories and contents. */
      unit_wipe (LUSR);
      syskill (who->id);

      unit_write (XWTX, CQ("\n"));
      unit_write (XWTX, who->name);
      mdwrite    (XWTX, "kil_Tgone", null.md);
   }

   chxfree (name);
   chxfree (answer);
   chxfree (no);
   chxfree (member);
   chxfree (format);
   chxfree (newstr);
   free_userreg (who);

   RETURN (1);
}
