/*** CREMOVE.  Remove a Caucus conference.  CV2. */

/*** Copyright (C) 1988 Camber-Roth.  All rights reserved. */

/*: AA  7/29/88 17:59 Source code master starting point */
/*: CR 11/03/88 16:26 Replace unit_name/sysrmdir with sysrmconf(). */
/*: CR 12/05/88 12:51 Remove unused path[]. */
/*: JV  8/21/89 20:07 Added code to report ambiguous confnames. */
/*: CW  7/20/89 15:26 Add XW unit codes. */
/*: CR 10/09/89 11:36 Use XW unit codes. */
/*: CR 10/09/89 15:04 Add 2nd arg to listconfs(). */
/*: CR  3/29/91 17:32 Use AND/OR codes for matchnames() call. */
/*: CR  4/08/91 18:49 Add new unit_lock argument. */
/*: JV  5/15/91 17:51 Add new loadnpart arg. */
/*: CR  8/02/91 12:44 Add NOPUNCT as new last arg to modnames() call. */
/*: CR  8/02/91 14:00 Add punctuation argument to matchnames() call. */
/*: JV 10/28/91 14:50 Added 2nd arg to cnumber().*/
/*: JV 11/01/91 16:48 Deal with LocalConfname vs TrueConfname. */
/*: CR 11/07/91 14:19 Add confnum arg to matchnames() call. */
/*: CR 11/18/91 17:20 Add CNUM argument to modnames() call. */
/*: WC 11/29/91 21:14 Add 3rd arg to cnumber(). */
/*: WC 11/30/91 15:21 Remove true/local name from XSCN properly. */
/*: CR 11/30/91 17:16 Create cremove_name(). */
/*: WC 12/01/91 12:00 Fix cremove_name for loop. */
/*: UL 12/11/91 18:45 Make unit_lock args 3-6 long.*/
/*: CR 12/11/91 23:55 Fix cnumber() call, make v int. */
/*: JV 12/16/91 16:46 Remove pdir def. */
/*: JV  1/01/92 11:37 Remove DB extraction, call rmconf() instead. */
/*: JX  6/08/92 18:19 Chixify. */
/*: CI 10/07/92 11:18 Chix Integration. */
/*: CR 10/13/92 12:03 Unit_write must take chix as args. */
/*: CR 10/13/92 12:37 Remove unused stuff, display confname on success. */

#include <stdio.h>
#include "caucus.h"

extern Chix                    confid, confname;
extern Chix                    yesnotable;
extern short                   confnum;
extern union  null_t           null;

FUNCTION  cremove()
{
   Chix   id, answer, no, lname, tname, orig_host;
   Chix   format, newstr;
   short  ok, c;
   int    open;

   ENTRY ("cremove", "");

   id     = chxalloc (40L,  THIN, "cremove id");
   no     = chxalloc (20L,  THIN, "cremove no");
   lname  = chxalloc (20L,  THIN, "cremove lname");
   tname  = chxalloc (20L,  THIN, "cremove tname");
   answer = chxalloc (20L,  THIN, "cremove answer");
   format = chxalloc (80L,  THIN, "cremove format");
   newstr = chxalloc (120L, THIN, "cremove newstr");
   orig_host = chxalloc (120L, THIN, "cremove orig_host");

   /*** Tell the user what we're about. */
   unit_write (XWTX, chxquick(NEWPAGE,0));
   mdwrite    (XWTX, "rem_Tintro", null.md);

   /*** List the existing (public?) conferences. */
   listconfs (XWTX, 1);
   mdwrite   (XWTX, "rem_Tborder", null.md);

   while (1) {
      if (mdprompter ("rem_Pwhat", null.chx, 0, "rem_Hwhat", 80, confname,
                      null.chx)
            < -1)  break;
      confnum = cnumber (confname, LOCALCONF, &open);

      /*** No conferences matched, complain and try again. */
      if (confnum < 0) {
         mdwrite (XWER, "rem_Enoconf", null.md);
         continue;
      } else if (confnum == 0) {
         mdwrite (XWER, "rem_Eambconf", null.md);
         continue;
      }

      /*** Request confirmation before removing conference. */
      chxtoken (no, nullchix, 1, yesnotable);
      mdstr    (format, "rem_Fconfirm", null.md);
      chxclear  (newstr);
      chxformat (newstr, format, 0L, 0L, confname, null.chx);
      c = prompter (newstr, yesnotable, 2, "rem_Hconfirm", 20, answer, no);
      if (c <  0)  break;
      if (c == 0)  continue;

      /*** Get the full conf name, disallow removing shared confs. */
      get_trueconf (confnum, lname, tname, orig_host);

      if (NOT EMPTYCHX(tname)) {
         chxupper   (confname);
         unit_write (XWTX, CQ("\n"));
         mdwrite (XWER, "rem_Eshared", null.md);
         continue;
      }

      ok = rmconf (confnum);
  
      unit_write (XWTX, CQ("\n"));
      chxupper   (confname);
      unit_write (XWTX, confname);
      mdwrite    (XWTX, ok ? "rem_Tdone" : "rem_Tbad", null.md);
   }

done:
   chxfree (id);
   chxfree (no);
   chxfree (lname);
   chxfree (tname);
   chxfree (answer);
   chxfree (format);
   chxfree (newstr);

   RETURN (1);
}
