/*** FREE_TRANS.   Deallocate a Trans linked list.
/
/    free_trans (head);
/
/    Parameters:
/       Trans     head;     (Trans linked list to be deallocated)
/
/    Purpose:
/       Deallocate a Trans linked list, returning all elements to the heap.
/
/    How it works:
/
/    Returns: 1
/
/    Error Conditions
/  
/    Side effects:
/
/    Related functions: make_trans()
/
/    Called by: 
/
/    Operating system dependencies:
/
/    Known bugs:
/
/    Home:  xrec/freetran.c
/ */

/*** Copyright (C) 1991 Camber-Roth.  All rights reserved. */

/*: CR  8/20/91 13:05 New function. */

#include <stdio.h>
#include "entryex.h"
#include "handicap.h"
#include "recv.h"

FUNCTION  free_trans (head)
   Trans  head;
{
   Trans  p, q;

   ENTRY ("free_trans", "");

   for (p=head;   p!=NULL;  ) {
      if (p->xnums != NULL)  sysfree ( (char *) p->xnums);
      q = p;
      p = p->next;
      sysfree ( (char *) q);
   }

   RETURN (1);
}
