
/*** MAKE_TRANS.   Allocate a node for a "Trans" linked list.
/
/    node = make_trans();
/
/    Parameters:
/       Trans     node;        (returned empty node in a Trans list)
/
/    Purpose:
/       Allocate a "Trans" node from the heap.
/
/    How it works:
/
/    Returns: the allocated node
/
/    Error Conditions
/  
/    Side effects:
/
/    Related functions:
/
/    Called by: 
/
/    Operating system dependencies:
/
/    Known bugs:
/
/    Home:  xrec/maketran.c
/ */

/*** Copyright (C) 1991 Camber-Roth.  All rights reserved. */

/*: CR  8/14/91 18:33 New function. */
/*: CR 12/14/92 16:00 Sysmem arg is long. */

#include <stdio.h>
#include "entryex.h"
#include "handicap.h"
#include "chixuse.h"
#include "recv.h"

FUNCTION Trans make_trans()
{
   Trans  a;
   char  *sysmem();

   ENTRY ("make_trans", "");

   a = (Trans) sysmem (L(sizeof (struct trans_t)));
   a->seq           = EMPTYTRANS;
   a->chn           = chxalloc (40L, THIN, "maketran chn");
   a->first_receipt = -1L;
   a->highchunk     = -1;
   a->gotlast       =  0;
   a->acktype       = NOTACK;
   a->xsize         = -1;
   a->xnums         =  NULL;
   a->next          =  (Trans) NULL;

   RETURN (a);
}
