
/*** PRINT_TRANS.   Print a Trans list for debugging purposes.
/
/    print_trans (p);
/
/    Parameters:
/       Trans     p;        (Trans list to be displayed)
/
/    Purpose:
/       Print the contents of a Trans list.
/
/    How it works:
/
/    Returns: 1 on success, 0 on error.
/
/    Error Conditions
/  
/    Side effects:
/
/    Related functions:
/
/    Called by: 
/
/    Operating system dependencies:
/
/    Known bugs:
/
/    Home:  xrec/printtra.c
/ */

/*** Copyright (C) 1991 Camber-Roth.  All rights reserved. */

/*: CR  8/15/91 18:33 New function. */
/*: CP  2/09/94 13:51 Use ascquick(p->chn). */

#include <stdio.h>
#include "entryex.h"
#include "handicap.h"
#include "recv.h"

FUNCTION print_trans (p)
   Trans p;
{
   int   i, m;

   ENTRY ("print_trans", "");

   if  (p->seq == EMPTYTRANS)   p = p->next;
   for (;   p != NULL;   p = p->next) {
      printf ("\n=== %7ld '%s' %ld\n", p->seq, ascquick(p->chn), 
                                       p->first_receipt);
      printf ("    high=%d, gotlast=%d, acktype=%d, ackseq=%ld\n", 
                 p->highchunk, p->gotlast, p->acktype, p->ackseq);
      printf ("    ");
      for (i=1, m=0;   i<=p->highchunk;   ++i) {
         if (p->xnums[i] >= 0)   printf ("  X%07ld",  p->xnums[i]);
         else                    printf ("    (%4d)", i);
         if (++m >= 8)         { printf ("\n   ");   m = 0; }
      }
      printf ("\n");
   }

   RETURN (1);
}
