
/*** DELITEM.   Delete a range of items. */

/*** Copyright (C) 1987 Camber-Roth.  All rights reserved.  */

/*: AA  7/29/88 17:38 Source code master starting point*/
/*: CW  5/17/89 16:22 Use XW unitcodes in place of XITT.*/
/*: CR  9/15/89 17:12 Check thisuser->read_only. */
/*: CR  7/14/90 11:38 Use thisuser->is_organizer. */
/*: CR  6/20/91 17:18 Use new equal_id() function. */
/*: CR  6/27/91 16:04 Use new chg_ditem() to actually delete an item. */
/*: CR  7/23/91 15:00 Add 3rd argument to equal_id() call. */
/*: CR  7/28/91 14:43 Replace NULL with null.str. */
/*: CR  7/30/91 13:51 Replace license check with is_distributed(). */
/*: CX 11/12/91 14:46 Chixify. */
/*: CR 10/29/91 11:45 Add confnum arg to getline() call. */
/*: JV 10/31/91 15:09 Add dest_chn arg to chgxitem() call. */
/*: JX  7/31/92 14:36 CHN's are chixen. */
/*: CR 10/11/92 21:45 Remove CQ from equal_id() call. */
/*: CR  2/08/93 14:26 Do not allocate header & title! */
/*: CN  5/15/93 15:20 Replace parse_range with new_parse(). */
/*: CT  5/28/93 13:47 Replace SELECT with Rlist. */
/*: CP  6/23/93 23:43 Use new form of new_parse(). */

#include <stdio.h>
#include "caucus.h"
#include "xaction.h"
#include "derr.h"
#include "api.h"
#define   RLNULL   ( (Rlist) NULL )

extern struct license_t       license;
extern struct master_template master;
extern struct this_template   thisitem;
extern Textbuf                tbuf;
extern Userreg                thisuser;
extern union  null_t          null;
extern Chix                   yesnotable;
extern short                  confnum;

FUNCTION  delitem (command)
   Chix   command;
{
   int    success;
   int    error1, error2, i, oitem;
   short  am_author;
   char   modifier[20];
   Chix   header, title;     /* Do *not* allocate! */
   Chix   range, author, no, answer, ohost;
   Chix   getline();
   Rlist  rptr, result, dlist, dptr, add_to_rlist();

   ENTRY ("delitem", "");

   if (thisuser->read_only) {
      mdwrite (XWER, "ent_Ereadonly", null.md);
      RETURN  (0);
   }


   range  = chxalloc (80L, THIN, "delitem range");
   author = chxalloc (80L, THIN, "delitem author");
   answer = chxalloc (80L, THIN, "delitem answer");
   ohost  = chxalloc (80L, THIN, "delitem ohost");
   no     = chxalloc (80L, THIN, "delitem no");
   dlist  = RLNULL;
   result = RLNULL;

   /*** Pluck RANGE of items off command line, or else prompt user. */
   if (chxtoken (null.chx, range, 3, command) < 0) {
      if (mdprompter ("del_Pitem", null.chx, 0, "del_Hitem", 80, range, CQ(""))
                       < -1)  FAIL;
   }
   
   new_parse (range, &result, modifier, confnum, thisitem.number);

   /*** For each item in the selected RANGE, make sure it belongs to
   /    the user (or the user is the organizer).  Display the header
   /    of each such item.  */
   unit_write (XWTX, NEWCPAGE);
   dlist = dptr = a_mak_rlist();
   for (rptr=result->next;   rptr!=RLNULL;   rptr=rptr->next) {
      for (i=rptr->i0;   i<=rptr->i1;   ++i) {
         header = getline (XCRD, XCRF, confnum, null.chx, i, 0, 0, tbuf);
         title  = getline (XCRD, XCRF, confnum, null.chx, i, 0, 1, tbuf);
         if (header==null.chx  ||  title==null.chx)           continue;
   
         chxtoken (author, null.chx, 2, header);
         am_author = equal_id (author, thisuser->id, nullchix);
         if (NOT am_author  &&  NOT thisuser->is_organizer)   continue;
         show_header (XWTX, i, header, title, 1);
         dptr = add_to_rlist (dptr, i, 0, -1);
      }
   }

   /*** If no items belonging to the user were selected, complain. */
   if (dlist->next == RLNULL) {
      mdwrite (XWER, "del_Tnysel", null.md);
      FAIL;
   }

   /*** Confirm deletion of the remaining items. */
   chxtoken (no, null.chx, 1, yesnotable);
   if (mdprompter ("del_PitemD", yesnotable, 2, "del_HitemD", 10, answer, no)
          < 1)  SUCCEED;

   /*** Delete the selected items.  Test for <CANCEL> before each delete. */
   sysbrkclear();
   for (dptr=dlist->next;   dptr!=RLNULL;   dptr=dptr->next) {
      for (i=dptr->i0;   i<=dptr->i1;   ++i) {
         if (sysbrktest())  break;
         if (is_distributed (confnum)) {
            getoitem (&oitem, ohost, i, &master);
            chgxitem (XT_DELETE, confnum, oitem, ohost, null.chx, null.chx,
                  null.chx, nullchix, null.chx, null.chx, nullchix, &error2);
         }
         chg_ditem (XT_DELETE, confnum, -1, &i, null.chx, null.chx, null.chx,
                     nullchix, null.chx, null.chx, null.chx, &error1);
      }
   }
   SUCCEED;

done:
   a_fre_rlist (result);
   a_fre_rlist (dlist);
   chxfree (no);
   chxfree (ohost);
   chxfree (answer);
   chxfree (author);
   chxfree (range);
   RETURN  (success);
}
