
/*** DESCITEM.   Describe items/responses selected in COMMAND. */

/*** Copyright (C) 1987 Camber-Roth.  All rights reserved. */

/*: AA  7/29/88 17:38 Source code master starting point*/
/*: JV  8/23/89 11:46 Changed error message on invalid item range. */
/*: CW  5/17/89 16:22 Use XW unitcodes in place of XITT.*/
/*: CR 10/11/89 16:11 Revert to "no items selected" if parserange fails. */
/*: CX 11/12/91 17:41 Chixify. */
/*: CR  1/20/92 16:45 Add cnum arg to load_header() call. */
/*: JX  5/13/92 11:49 Add cnum arg to descitem() (never defined on 1/20/92). */
/*: CR 10/06/92 15:15 Do not clear used.lines. */
/*: CN  5/15/93 13:41 Replace parse_range with newparse(). */
/*: CT  5/28/93 13:47 Replace SELECT with Rlist. */
/*: CP  6/23/93 23:43 Use new form of new_parse(). */
/*: CP  6/24/93 15:39 Simplify, using new Rlists. */

#include <stdio.h>
#include "caucus.h"
#include "modifier.h"
#include "api.h"
#define   RLNULL   ( (Rlist) NULL )

extern struct master_template  master;
extern struct this_template    thisitem;
extern union  null_t           null;

FUNCTION  descitem (cnum, out, range)
   int    cnum, out;
   Chix   range;
{
   int    success, last, i;
   Chix   str, title, itemform, respform, output;
   char   modifier[20];
   Rlist  rptr, result;

   ENTRY ("descitem", "");

   str      = chxalloc (80L, THIN, "descitem str");
   title    = chxalloc (80L, THIN, "descitem title");
   itemform = chxalloc (80L, THIN, "descitem itemform");
   respform = chxalloc (80L, THIN, "descitem respform");
   output   = chxalloc (80L, THIN, "descitem format");
   result   = RLNULL;

   if (NOT new_parse (range, &result, modifier, cnum, thisitem.number)) {
      mdwrite (XWER, "chg_Enoitem", null.md);
      SUCCEED;
   }

   if (modifier[M_BRIEF]) {
      mdstr (itemform, "res_Fshowhead3", null.md);
      mdstr (respform, "res_Fshowhead4", null.md);
   }
   else {
      mdstr (itemform, "res_Fshowhead5", null.md);
      mdstr (respform, "res_Fshowhead6", null.md);
   }

   sysbrkclear();
   unit_write (out, NEWCPAGE);
   for (rptr=result->next;   rptr!=RLNULL;   rptr=rptr->next) {
      for (i=rptr->i0;   i<=rptr->i1;   ++i) {
         if (i == 0)         continue;
         if (sysbrktest())   break;
   
         if (NOT load_header (cnum, i, str, title))        continue;
         if (EMPTYCHX(str))                                continue;

         if (modifier[M_ITEMS]  &&  rptr->r0 == 0) {
            show_format (XWTX, itemform, i, 0, 0, 0, title, str);
         }
         else {
            last = rptr->r1;
            if (last == -1)  last = master.responses[i];
            show_format (XWTX, respform, i, rptr->r0, last, 0, title, str);
         }
      }
   }
   SUCCEED;

done:
   a_fre_rlist (result);
   chxfree (output);
   chxfree (itemform);
   chxfree (respform);
   chxfree (title);
   chxfree (str);
   RETURN  (success);
}
