/*** INTHISCONF.  Remove people from WHO that are not IN THIS CONFerence.
/
/    inthisconf (who)
/
/  Parameters:
/     struct namlist_t **who;
/
/  Purpose:
/    INTHISCONF is handed a pointer to WHO, a namelist of people (with
/    userid's as the second word in each entry).  It removes those 
/    entries that are not members of the current conference.
/
/  How it works:
/
/  Returns: 1.
/
/  Error Conditions:
/
/  Side Effects:
/
/  Related to:
/
/  Called by: whosaidit()
/
/  Home: cmd2/inthisco.c
*/

/*** Copyright (C) 1987-1992 Camber-Roth.  All rights reserved. */

/*: AA  7/29/88 17:40 Source code master starting point */
/*: CR  4/08/91 18:49 Add new unit_lock argument. */
/*: UL 12/11/91 18:42 Make unit_lock args 3-6 long.*/
/*: JX  2/25/92 14:00 Chixify, add header. */
/*: DE  5/26/92 16:45 Fix chxalloc constant */

#include <stdio.h>
#include "caucus.h"
#include "chixuse.h"
#include "done.h"

extern union null_t null;

FUNCTION  inthisconf (who)
   struct namlist_t **who;
{
   struct namlist_t *members, *p, *nlnode();
   Chix   id;
   int    success;

   ENTRY ("inthisconf", "");

   id = chxalloc (40L, THIN, "id");

   /*** INTHISCONF actually creates a new list MEMBERS, and adds those entries
   /    in WHO that have a XURG file for this conference to MEMBERS.  It
   /    finally frees WHO, and replaces it with MEMBERS. */
   members = nlnode(1);

   for (p=(*who)->next;   p!=null.nl;   p = p->next) {
      chxtoken (id, nullchix, 2, p->str);
      unit_lock (XURG, READ, 0L, 0L, 0L, 0L, id);
      if (unit_check (XURG))  nladd (members, p->str, 0);
      unit_unlk (XURG);
   }

   nlfree (*who);
   *who = members;
   SUCCEED;

done:
   chxfree (id);
   RETURN(success);
}
