/*** JIS.H  Macros for use by double-byte handling string functions. */

/*: AM  2/07/89 10:45 Created for Jcaucus*/
#if JAPAN

#define UJIS_SHIFT_OUT  0x8E

#define IS_NM_SW_KANA(c)      ((c)>=0xA4 && (c)<=0xDF)

#define IS_SJIS_DBC_BYTE_1(c) ((0x81<=(c)&&(c)<=0x9F)||(0xE0<=(c)&&(c)<=0xFC))
#define IS_UJIS_DBC_BYTE_1(c) ((0x8E==(c))||(0xA1<=(c)&&(c)<=0xFE))

#define IS_SJIS_DBC_SPACE(db) ((db)==0x0140)
#define IS_SJIS_DBC_SPECIAL(db) (0x0141<=(db)&&(db)<=0x01FC)
#define IS_SJIS_DBC_ALPHA(db) (0x0240<=(db)&&(db)<=0x029E)
#define IS_SJIS_DBC_KANJI(db) ((0x089F<=(db)&&(db)<=0x6FFC)||\
                               (0x029F<=(db)&&(db)<=0x039E))

#define IS_SJIS_DBC_SW_KANA(db) (0)

#define IS_UJIS_DBC_SPACE(db) ((db)==0x21A1)
#define IS_UJIS_DBC_SPECIAL(db) (0x21A2<=(db)&&(db)<=0x22FE)
#define IS_UJIS_DBC_ALPHA(db) (0x23A1<=(db)&&(db)<=0x23FE)
#define IS_UJIS_DBC_KANJI(db) ((0x30A1<=(db)&&(db)<=0x7EFE)||\
                               (0x24A1<=(db)&&(db)<=0x25FE))
#define IS_UJIS_DBC_SW_KANA(db) (0x0EA0<=(db)&&(db)<=0x0EDF)

#if SHIFT_JIS

#define IS_DBC_BYTE_1(b)       IS_SJIS_DBC_BYTE_1(b)
#define IS_DBC_SPACE(db)       IS_SJIS_DBC_SPACE(db)
#define IS_DBC_SPECIAL(db)     IS_SJIS_DBC_SPECIAL(db)
#define IS_DBC_ALPHA(db)       IS_SJIS_DBC_ALPHA(db)
#define IS_DBC_KANJI(db)       IS_SJIS_DBC_KANJI(db)
#define IS_DBC_SW_KANA(db)     IS_SJIS_DBC_SW_KANA(db)

#else

#if UNIX_JIS
#define IS_DBC_BYTE_1(b)       IS_UJIS_DBC_BYTE_1(b)
#define IS_DBC_SPACE(db)       IS_UJIS_DBC_SPACE(db)
#define IS_DBC_SPECIAL(db)     IS_UJIS_DBC_SPECIAL(db)
#define IS_DBC_ALPHA(db)       IS_UJIS_DBC_ALPHA(db)
#define IS_DBC_KANJI(db)       IS_UJIS_DBC_KANJI(db)
#define IS_DBC_SW_KANA(db)     IS_UJIS_DBC_SW_KANA(db)

#endif
#endif

#endif
