
/*** SYSDATE.  Convert time in seconds to "dd-MMM-yy hh:mm". */

/*** Copyright (C) 1983 Camber-Roth.  All rights reserved.  */

/*: AA  7/29/88 17:44 Source code master starting point */
/*: CR  8/03/88 16:49 Add VM to UNIX list */
/*: JV  8/02/88 10:15 Added AOS code. */
/*: CR  9/21/88 15:25 Add "HU" system type for HP/UX. */
/*: CR  9/23/88 13:00 Add "IX" system type. */
/*: CR 10/06/88 15:13 Change IM to use QuickC; now like UNIX! */
/*: CR 11/02/88 17:08 Remove VM, add CX and CA. */
/*: JV 11/22/88 16:52 Changed preproc conditional on time.h*/
/*: CR  1/09/89 12:34 Add CVM. */
/*: CR  1/09/89 14:21 Need CAST for VM. */
/*: CR  6/09/89 12:16 Add "SV" system type code. */
/*: CW  5/08/89 15:17 Add PX system code. */
/*: JV 10/04/89 17:58 Stripped out AOS non-server code. */
/*: CR 10/12/89 15:35 Add DU system type code. */
/*: CR 12/21/89 17:52 PR code: remove defn of localtime(). */
/*: CR  1/09/90 10:45 If PR19, define localtime(). */
/*: JV  7/06/90 20:27 Add MIPS RISC/os (RO). */
/*: CR  9/20/90 17:03 Add PS system type. */
/*: CR  9/27/90 12:19 Add U3, AU system types. */
/*: CJ 11/26/90 21:50 Add LA system type code. */
/*: CR  2/09/91 21:44 Split long #if line in two (SYSV1, SYSV2). */
/*: SB 11/29/90 14:04 Add DY system code*/
/*: CR  3/11/91 16:20 Add AX & UL system type codes. */
/*: SB  5/16/91 10:35 Add DP system type. */

#include <stdio.h>
#include "caucus.h"
#include "systype.h"

static char         months[100], *m;
extern union null_t null;

FUNCTION  sysdate (str, seconds)
   char   str[];
   long   seconds;
{

/*--------------------------FORTUNE & VAX & MASSCOMP & A3 & PRIME--------*/
#if UNIX | VV | PR | IM | PN | CX | CA | CVM | PX | PS

#define SYSV1    A3 | LA | HU | FU | MU | MV | PU | SX | TX | IX | SV
#define SYSV2    SV | PX | DU | RO | U3 | AU | DY | AX | DP

#if SYSV1 | SYSV2 | VV | IM | PN | CX | CA
#include <time.h>
#define  CAST
struct tm *localtime();
#endif

#if PR
#include <time.h>
#define  CAST
#if PR19
struct tm *localtime();
#endif
#endif

#if BU | SU | PS | UL
#include <sys/time.h>
#define  CAST
struct tm *localtime();
#endif

#if CVM
#include <time.h>
#define  CAST   (time_t *)
#endif

   struct tm *now;
   char   mon[20];
   char  *strtoken();

   ENTRY ("sysdate", "");

   if (NULLSTR (months)) {
      if (mdstr (CQ(months), "sys_Tmonth", null.md))  m = months;
      else  m = "JAN FEB MAR APR MAY JUN JUL AUG SEP OCT NOV DEC";
   }

   now = localtime (CAST &seconds);
   strtoken (mon, now->tm_mon+1, m);
   sprintf  (str, "%02d-%s-%2d %2d:%02d", now->tm_mday, mon,
            now->tm_year, now->tm_hour, now->tm_min);
#endif

   RETURN (1);
}
