
/*** WHICHITEM.   Which (one) item does the user want to deal with?
/
/    If RANGE is empty, WHICHITEM prompts the user for a RANGE i
/    with PROMPT.   HELP is the accompanying help text for PROMPT.
/    DEF_ITEM is the default answer if the user is prompted.
/
/    WHICHITEM proceeds to parse RANGE, and finds the lowest numbered
/    item in RANGE and returns that number.  If no items are selected
/    by RANGE, WHICHITEM returns 0.  */

/*: AA  7/29/88 17:34 Source code master starting point */
/*: DE  3/17/92 17:56 Chixified */
/*: JX  5/19/92 12:11 Fix Chix. */
/*: CN  5/15/93 15:20 Replace parse_range with new_parse(). */
/*: CT  5/28/93 13:47 Replace SELECT with Rlist. */
/*: CP  6/25/93 13:56 Add new args to newparse() call. */
/*: CP  8/09/93 11:47 Add null 'attach' arg to new_parse() call. */

#include <stdio.h>
#include "caucus.h"
#include "api.h"
#include "modifier.h"
#define   RLNULL   ( (Rlist) NULL )

extern struct master_template master;
extern struct this_template   thisitem;
extern short                  confnum;
extern union  null_t          null;

FUNCTION  whichitem (range, prompt, help, def_item)
   Chix   range;
   char  *prompt, *help;
   int    def_item;
{
   Chix   def, str;
   int    success;
   char   modifier[MODIFIERS+5];
   Rlist  result;

   ENTRY ("whichitem", "");

   def     = chxalloc (10L, THIN, "whichite def");
   str     = chxalloc (80L, THIN, "whichite str");
   result  = RLNULL;
   success = 0;

   if (range==null.chx  ||  EMPTYCHX (range)) {
      chxclear( def );
      if (def_item > 0)  
         chxformat (def, CQ("%d"), L(def_item), 0L, null.chx, null.chx );
      if (mdprompter (prompt, nullchix, 0, help, 80, str, def) < -1)     FAIL;
   }
   else  chxcpy (str, range);

   if (NOT new_parse (str, &result, modifier, nullchix, confnum, 
                      thisitem.number)) FAIL;

   if (result->next != RLNULL)  DONE(result->next->i0);
   FAIL;

 done:
   a_fre_rlist (result);
   chxfree ( def );
   chxfree ( str );
   RETURN  ( success );
}
