/*** File of all LICENSE include files. */

/*: JV  9/24/92 13:32 Concatentate all of the license include files together. */
#include <stdio.h>

/*** UNITCODE.H.   Caucus unit i/o code numbers. */

/*** Copyright (C) 1984 Camber-Roth.  All rights reserved.  */

/*: AA  7/29/88 17:46 Source code master starting point */
/*: CR  1/31/89 14:34 Add XCLG for by-conference user logging. */
/*: CR  8/09/89 15:15 Add XSMK for sysmkdir() locking. */
/*: CW  5/05/89 16:13 Add XSPV for VM. */
/*: CW  5/17/89 15:35 Add new window unit code numbers. */
/*: CR 10/20/89 14:14 Add XWTY for output w/o <CANCEL>ing! */
/*: CR 11/14/89 17:17 Add XSMO. */
/*: CR  2/22/90 15:55 Add XWPT. */
/*: CR  3/22/90 16:11 Add XWTZ. */
/*: CR  7/16/90  7:56 Add XSUG unit. */

/*** I/O related unit numbers (specific to each user). */
#define  XKEY -100  /* Keyboard! */
#define  XWTZ -11   /* Same as XWTX, but does NOT go to XITT! */
#define  XWPT -10   /* Real prompt line for VM. */
#define  XWTY  -9   /* Same as XWTX, but <CANCEL> does not interrupt! */
#define  XWAN  -8   /* Window for announcements. */
#define  XWDB  -7   /* Window for debugging. */
#define  XWER  -6   /* Window for errors/announcements. */
#define  XWPM  -5   /* Window for prompt. */
#define  XWPF  -4   /* Window for pfKeys. */
#define  XWHL  -3   /* Window for help. */
#define  XWTX  -2   /* Window for text. */

#define  XITT  -1   /* Terminal. */
#define  XIRE   0   /* Redirection (> >> <) file */
#define  XIPT   1   /* accumulated PRINT file */
#define  XITX   2   /* temporary TeXt file #1 */
#define  XITY   3   /* temporary Text file #2 */
#define  XICE   4   /* Caucus Editor file. */
#define  XILM   5   /* Last Message sent */
#define  XICF   6   /* Input Command File: AND NOW? <comfile */

/*** User file unit numbers. */
#define  XURG  10   /* Registration file. */
#define  XUMD  11   /* User's mail directory. */
#define  XUMF  12   /* User's mail partfile. */
#define  XUND  13   /* subject Names directory. */
#define  XUNN  14   /* subject Names. */
#define  XUSD  15   /* Subject definitions directory. */
#define  XUSF  16   /* Subject definitions. */
#define  XUOD  17   /* Ordered (alphabetized) subject namelist directory. */
#define  XUON  18   /* Ordered subject namelist. */
#define  XUPA  19   /* PArticipation file for each conference for this user. */
#define  XUOU  20   /* One user per userid per conference. */

/*** Conference file unit numbers. */
#define  XCRD  30   /* Response Directory. */
#define  XCRF  31   /* Response partFile. */
#define  XCMD  32   /* Membership partfile directory. */
#define  XCMN  33   /* Membership partfile. */
#define  XCTD  34   /* Title partfile directory. */
#define  XCTN  35   /* Title partfile. */
#define  XCAD  36   /* Author of items partfile directory. */
#define  XCAN  37   /* Author of items partfiles. */
#define  XCND  38   /* subject Names directory. */
#define  XCNN  39   /* subject Names. */
#define  XCSD  40   /* Subject directory. */
#define  XCSF  41   /* Subject textfile(s). */
#define  XCOD  42   /* Ordered (alphabetized) subject names directory. */
#define  XCON  43   /* Ordered subject names. */
#define  XCMA  44   /* MAster list of responses to items. */
#define  XCIN  45   /* Introduction */
#define  XCGR  46   /* Greeting. */
#define  XCUS  47   /* Userlist */
#define  XCDD  48   /* Conference directory. */
#define  XCLG  49   /* Conference log file. */

/*** System-wide file unit numbers. */
#define  XSMD  50   /* master Dictionary. */
#define  XSND  51   /* Name Directory */
#define  XSNN  52   /* Name File. */
#define  XSPC  53   /* Printcodes. */
#define  XSMU  54   /* Maximum Users control */
#define  XSPD  55   /* Password Directory */
#define  XSPN  56   /* Password partFiles */
#define  XSBG  57   /* Buglist file. */
#define  XSLG  58   /* LoG     file. */
#define  XSCD  59   /* Conference names directory. */
#define  XSCN  60   /* Conference names partfile. */
#define  XSCK  61   /* Clock Check */
#define  XSMK  62   /* Make-directory lock. */
#define  XSPV  63   /* VM Privilege file */
#define  XSMO  64   /* Master.opt options file. */
#define  XSUG  65   /* User groups--for '<'ing in XCUS. */

#define  XLAST 66   /* Always the last Unit number. */

/*** COMMON.H.  Definitions of structure common to both
/    server and client programs in Caucus server/client model. */

/*: CR 11/16/88  0:17 Initial release of server code. */
/*: CR  3/22/89 12:18 Reduce MAXITEMS to 950 to accomodate DG server. */
/*: CR  4/27/89 15:47 Add lock-consistency check code. */
/*: CR 10/11/89 17:29 Raise HASHSIZE to 4507, mdrec_t.name to DICNAMELEN. */

/*** Access and lock types: */
#define UNLKED   0
#define READ     1
#define WRITE    2
#define TLOCK    3     /* Test, lock if possible, don't wait. */
#define LOCKED   4

/*** Max sizes of various things. */
#define  MAXITEMS  950        /* Max # of items/conference. */
#define  PDIRMAX   300        /* Max # of partfiles returned by syspdir(). */
#define  MEMBUF   2000        /* Max size of server/client transfer buffers. */

/*** MASTER file information: */
struct master_template {
   short items;               /* # of items on conference */
   short nochange;            /* Let users change their responses? */
   short noenter;             /* Let users enter their own items? */
   char  organizerid[40];     /* userid of organizer. */
   short responses[MAXITEMS]; /* # of responses on each item */
}; 
 
/*** Lock requests from the server send a "namecode" that contains
/    the arguments that SRVNAME needs to make up a filename. */
struct namecode_t {
   short item;     /* Item number. */
   short resp;     /* response number. */
   short lnum;     /* line number. */
   short confnum;  /* conference number. */
   short readwrit; /* read/write type of lock. */
   char  word[60]; /* userid or other "word" required in name. */
};

/*** Requests from syspdir->apdir are passed through a pinfo_t. 
/    (Results come back in a pdir_t.) */
struct pinfo_t {
   short item;         /* Item (or message) number. */
   short confnum;      /* Conference number. */
   char  userid[20];   /* owning userid of file if any. */
};

/*** Structure for item and response partfile directory listings. */
struct pdir_t {
   short type;
   short parts;
   short resp[PDIRMAX+3];
   short lnum[PDIRMAX+3];
};

/*** Master Dictionary Stuff. */
#define  DICNAMELEN  23
struct mdrec_t {
   long   start;
   short  status;
   short  length;
   char   name[DICNAMELEN+1];
};
#define  HASHSIZE  4507
#define  MDRES        1
#define  MDTABLE      2

/*** Include file HANDICAP.H for Caucus source code.  Defines
/    easy-to-read keywords. */
 
/*** Copyright (C) 1989 Camber-Roth.  All rights reserved.  */

/*: JV  9/18/89 15:08 Officically added this file. */
/*: CR 10/06/89 12:37 Adjust header, FIRE_AFM interpret() call. */
/*: CR 11/13/89 16:46 FIRE_AFM now returns value of interpret(). */
/*: JV  2/23/90 05:00 Added ON and OFF. */
/*: CR  4/09/90 16:04 Added ECHO_INPUT, COOK_INPUT, EIGHT_BIT. */
/*: CR  6/21/90 11:37 Move LSYS, LUSR, LCNF in from units.h. */
/*: CR  7/02/90 12:44 EIGHT_BIT got removed somehow, put back. */
/*: CR  9/11/90 15:26 Add MAXPASS. */

#define  FUNCTION
#define  NOT               !
#define  UNTIL(x)          while(!(x))
#define  NULLSTR(s)        (!(s[0]))
#define  EMPTY             -1
#define  HANDI             1     /* "These things have been def'd..." */
#define  FIRE_AFM(x,y,z) (strcpy(afm_name, x), interpret (afm_name, y, z, ""))
#define  ON                1
#define  OFF               0
#define  MAXPASS          20     /* Maximum size of "captive" password. */
#define  ECHO_INPUT        5
#define  COOK_INPUT        6
#define  EIGHT_BIT         7

/*** Types of I/O for unit_wipe(). */
#define  LSYS  0
#define  LUSR  1
#define  LCNF  2

/*** Include file CAUCUS.H for CAUCUS source code.  Defines
/    structure templates, macros, and maximum parameters (as
/    defined constants.)
/
/    Copyright (C) 1984 Camber-Roth.  All rights reserved.  */

/*: AA  7/29/88 17:46 Source code master starting point */
/*: CR 10/18/88 16:42 Remove stuff to unitcode.h & common.h. */
/*: CR  1/17/89 11:07 Add flag and userreg expwarn element. */
/*: CR  1/31/89 14:29 Add logbyconf element for -u to flag_t. */
/*: JV  2/14/89 14:59 Added loctimeout & remtimeout to flag_template. */
/*: CR  2/24/89 11:27 Add CRLF macro. */
/*: AM  2/07/89 10:28 Jcaucus changes*/
/*: CR  3/29/89 10:27 Add ENTRYEXIT control macro. */
/*: JV  2/14/89 14:59 Added loctimeout & remtimeout to flag_template. */
/*: JV  3/29/89 10:35 Added vcmethod to flag_template. */
/*: JV  4/12/89 22:40 Restructured JAPAN defs to satisfy DG compiler */
/*: JV  8/02/89 15:33 Added handicap.h include file. */
/*: JV  9/28/89 11:07 Add 'persons' field to modbit_t. */
/*: CR  8/10/89 13:27 Restructure JAPAN defs to remove redef. warnings. */
/*: CW  6/12/89 15:00 Add userreg_t.texten for SET TEXT_ENTRY. */
/*: CR  8/31/89 14:17 Add MSG_RRR and receiptsize for return receipt. */
/*: CR  9/05/89 14:47 Add LIFO to modbit_template.  Add userreg_t.mytext. */
/*: CR  9/15/89 16:52 Add userreg_t.read_only, startmenu. */
/*: CR 10/10/89 14:31 Remove modbit.persons. */
/*: CR 10/11/89 12:19 Expand size of userreg_t.setopts. */
/*: JV 11/03/89 12:57 Added MDBUFSIZE. */
/*: CR 11/03/89 11:45 Move SYSTEXT, etc from globals() to here. */
/*: CR 11/22/89 14:57 Changed MDBUFSIZE to 1024. */
/*: CR  1/08/90 16:27 Add userreg.import_mail field. */
/*: JV  1/30/90 16:38 Expand userreg.texten=2 means use wordwrap. */
/*: JV  2/20/90 07:46 Add flag_template.oneuser field. */
/*: CR  3/20/90 16:18 Add struct message_t template. */
/*: CR  4/12/90 15:13 Remove flag.eightbits. */
/*: CR  4/16/90 11:01 Add userreg.export_mail field. */
/*: CR  4/24/90 20:29 Rename WRAP -> DO_WRAP to avoid <termio.h> conflict. */
/*: CR  5/09/90 16:25 Add MAXRESP. */
/*: CR  6/05/90  1:07 Add flag_template.fullscreen for VM. */
/*: CR  7/13/90 14:03 Add userreg.is_organizer field. */

/*** ENTRY/EXIT test control.  If 1, entry_test() gets called on entry to
/    every function, and exit_test() on return from every function. */
#define ENTRYEXIT    0

#if ENTRYEXIT
#define ENTRY(x,y)       entry_test(x,y)
#define RETURN(z)     {  exit_test();        return(z); }
#else
#define ENTRY(x,y)
#define RETURN(z)     {                      return(z); }
/*#define PM printf ("Leaving interpret, startmenu='%s'\n", thisuser.startmenu) */
#endif

/*** Sub-include other caucus include files. */
/* #include "unitcode.h"     I/O unit code numbers. */
/* #include "common.h"       Stuff common to server/client model. */
#ifndef HANDI
/* #include "handicap.h"     Easy-to-read macros. */
#endif

/*** Eye-catchers */
#define DELETED(i)   (master.responses[i] < 0)
#define BOUND(x,a,b) (x<a ? a : (x>b ? b : x))
#define NEWPAGE      "\001"
#define CRLF         "\n"

/*** Types of text contained by BLOCK.TYPE. */
#define ITEM     0
#define RESPONSE 1
#define MESSAGE  2
#define GARBAGE  3
#define NAME     4

/*** Maximum number of items, messages, responses. */
#define MAXMESS  1000
#define MAXRESP   999

/*** Debugging switch codes. */
#define  LOCKREPORT     1

/*** Maximum string length expected from files, terminals, etc. ***/
#define  MAXLEN       200

/*** Size of MDBUFFER. ***/
#define  MDBUFSIZE   1024

/*** Maximum sizes of various textbuffer things */
#define  BIGSHORT 32767  /* Largest SHORT INT, used as infinity */

/*** Size of global text-buffer structures. */
#define SYSTEXT   8000
#define SYSLINE    500
#define SYSBLOCK   200

/*** Pointers to UNCATEGORIZED ITEMS category. */
#define  UNCAT       1
#define  UNCATHEAD   2

/*** Values of overlong line formatting options. */
#define  TRUNCATE    0
#define  DO_WRAP     1
#define  REFORMAT    2

/*** Values of userreg_t.mytext setting. */
#define  LATER       0   /* My text appears NEW, later. */
#define  NOW         1   /* My text appears NEW immediately. */
#define  NEVER       2   /* My text is marked seen immediately. */

/*** Values for var_substitute(). */
#define  COUNT       0   /* Count up size of variable substitutions. */
#define  SUBSTITUTE  1   /* Actually do substitutions. */

/*** Declarations of common functions to make LINT happy. */
long  lseek();
char  *strcpy(), *strcat();

/*** User registration information. */
struct userreg_t {
                            /* The first group is stored in the URG file. */
   char   name[80];               /* User's name. */
   char   lastname[40];           /* Part of name used for alphabetization. */
   char   id[20];                 /* userid */
   char   setopts[160];           /* SET options */
   char   sysopts[80];            /* system dependent SET options */
   char   phone[40];              /* telephone */
   char   laston[40];             /* date/time last on. */
   struct namlist_t *briefs;      /* brief introduction. */
   struct namlist_t *print;       /* user's Print code instructions. */

                            /* The rest of these are derived... */
   char   truncate;               /* truncate (1) or reformat text (0) ? */
   char   editor[60];             /* Default text editor. */
   short  tablength;              /* # spaces tab is converted to */
   char   newpage;                /* What char starts new printer page? */
   char   verbose;                /* Verbose or terse caucus prompts. */
   short  dict;                   /* Which dictionary. */
   char   eot[40];
   char   expwarn;                /* Warn about expiration date? */
   char   texten;              /* TEXT_ENTRY 0=>terminal, 1=>editor, 2=>wwrap */
   short  receiptsize;            /* # lines from orig. message in receipt. */
   char   mytext;                 /* When does my text show up as new? */
   char   read_only;              /* Am I a read-only member of this conf? */
   char   startmenu[20];          /* Name of start-up menu (or OFF). */
   char   import_mail;            /* 0=off, 1=import, 2=copy. */
   char   export_mail;            /* 0=off, 1=export, 2=copy. */
   char   is_organizer;           /* 0=no, 1=has 2ndary organizer perms. */
};

/*** User participation record for a conference. */
struct partic_t {
   short  items;               /* # of items user has "seen" */
   short  responses[MAXITEMS]; /* # of responses user has seen, per item */
   short  messages;            /* Number of messages?????? */
   char   backresp[MAXITEMS];  /* Go back this # responses when viewing
                               /  new responses. */
   char   lastin[60];
};

/*** User's message list record. */
struct message_t {
   short  highest;             /* Highest message number. */
   short  high_seen;           /* Highest message seen by user. */
   char   num[1000];           /* Flags for each message. */
};

/*** Record of things FRESH at the beginning of the session. */
struct fresh_template  {
   short int items;               /* # of items user had seen at start. */
   short int responses[MAXITEMS]; /* # of responses user had seen per item */
   char      backresp [MAXITEMS]; /* Go back this # responses on viewing. */
};

/*** Text buffer data structure definitions.  */
struct text_template {
   short  size;      /* Total size of text buffer. */
   short  used;      /* Number of bytes currently in use. */
   char  *buf;       /* Storage for text */
};

/*** Pointers to beginning of each line in text buffer. */
struct line_template {
   short  size;      /* Total number of line pointers available. */
   short  used;      /* Number of lines (pointers) currently in use. */
   short *ptr;       /* Array of line pointers (byte indices to text.buf) */
};

struct block_template {
   short  size;      /* Total number of responses BLOCK can hold. */
   short  used;      /* Number of responses currently in use. */
   short  item;      /* Item in question. */
   short  type;      /* Unit number (type) of partfile loaded. */
   short  firstresp; /* First response # in buffer. */
   short  lastresp;  /* Last response  # in buffer. */
   short *rstart;    /* # of first line for each response */
   short *rstop;     /* # of last  line for each response */
   short  firstline; /* first line number in first response. */
   short  lastline;  /* last  line number in last  response. */
};

/*** Screen height & width template. */
struct screen_template {
   short lines;
   short width;
};

/*** Command modifier fields. */
struct modbit_template {
   char  none;    /* No modifiers set! */
   char  new;
   char  fresh;
   char  unseen;
   char  brief;
   char  pass;
   char  lifo;
};

/*** Structure for command-line flags. */
struct flag_template {
   int    baud;
   int    print;
   int    loctimeout;
   int    remtimeout;
   short  vcmethod;
   char   login;
   char   escape;
   char   redirect;
   char   helpfile[80];
   char   in_macro;
   char   newuser;
   char   pwfile[80];
   char   userid[30];
   char   logfile[80];
   char   pctype;
   char   exitfile[80];
   char   entrfile[80];
   int    port;         /* For IBM PC: 0=>COM1, 1=>COM2. */
   char   verify;
   char   infile[80];
   char   echo;
   char   no1prompt;
   char   editlist;
   char   loop;
   char   nolower;
   char   expwarn;
   char   logbyconf;
   int    kanji;
   char   japan;
   char   noswkana;    /* no single width katakana */
   char   rawio;       /* let caucus do line buffering */
   char   xlateio;     /* enable translation between different jap */
					   /* char coding schemes */
   char   optfile[80]; /* name of options file */
   char   oneuser;
   char   fullscreen;  /* fullscreen on or off for VM/CMS. */
};

/*** Structure for attribute bits about the current item. */
struct this_template {
   short frozen;
   short number;
};


/**********************  CV2 new definitions start here ************/


/*** Name list structures. */
struct namlist_t {
   char  *str;
   short  num;
   struct namlist_t *next;
};
#define NLNULL   ((struct namlist_t *) NULL)

#define  MSG_NEW   1
#define  MSG_SEE   2
#define  MSG_DEL   4
#define  MSG_MLN   8     /* (Make Like New!) */
#define  MSG_RRR  16     /* Return Receipt Requested. */

#define  MSEND     0
#define  MFORWARD  1
#define  MREPLY    2
#define  MAGAIN    3
#define  MFILE     4

/*** NULL defintions to make Lint happy. */
union null_t {
   char              *str;
   char             **md;
   struct namlist_t  *nl;
   struct partic_t   *par;
};

/*** Caucus license structure. */
struct liceblk_t {
   char   locator[8];
   long   bulk[70];
};
struct license_t {
   char   locator[8];
   long   expires;
   long   maxusers;
   long   function_mask;
   char   serial[16];
   char   sysid[16][16];
};

/*** Japanese version */
#define JAPAN           0

#if ! JAPAN
#define SHIFT_JIS       0
#define UNIX_JIS        0
#endif

/*** double-byte handling */
#if JAPAN 

#define SHIFT_JIS       0
#define UNIX_JIS        1

#define SJIS_CODE       1
#define UJIS_CODE       2

#if SHIFT_JIS
#define SYS_DB_CODE     SJIS_CODE
#endif

#if UNIX_JIS
#define SYS_DB_CODE     UJIS_CODE
#endif

#define SBC_BYTE        'A'
#define DBC_BYTE_1      '1'
#define DBC_BYTE_2      '2'

#define DBC_SPACE       'S'
#define DBC_SPECIAL     'X'
#define DBC_ALPHA       'L'
#define DBC_KANJI       'J'
#define DBC_OTHER       'O'
#define DBC_SW_KANA     'K'

#endif  /*------End of Japanese #defines. */

/*** SYSTYPE.H.  Define the type of this system.  The known
/    definitions are: 
/
/   SS | SN  (together known as SU)
/   A3 | AU | BU | DU | FU | MU | MV | PU | SX | TX | HU | IX | SV | RO | U3
/            (or UNIX)
/   IM | PN | PR | VV
/   CX | CA | CVM     (or SRV)
/   PX | PS           (panel emulation under Xenix or SunOS)
/ */

/*: AA  7/29/88 17:47 Source code master starting point */
/*: CR  9/12/88 16:50 Add Data General systems*/
/*: CR  9/19/88 12:31 Add "CX" type for Client Xenix model. */
/*: CR  9/21/88 15:14 Add "HU" type for HP/UX. */
/*: JV  9/22/88 12:21 Changed the DG system definitions.*/
/*: CR  9/24/88  0:25 Add "IX" system type code. */
/*: CR 10/19/88 12:42 Remove old VM file i/o emulation stuff. */
/*: JV 12/06/88 14:34 Added AOS client code.*/
/*: CR  3/06/89 10:09 Add CVM to SRV definition. */
/*: CR  3/14/89 15:16 Add CVM back in to SRV def (it got removed...) */
/*: CR  4/29/89 13:57 Break SU into SN and SS. */
/*: CR  6/09/89 11:24 Add "SV" type for Sperry 5000. */
/*: CW  5/08/89 14:49 Add PX system type for panel-emulation Xenix code. */
/*: CR 10/12/89 15:28 Add DU for DG/UX. */
/*: CR  1/09/90 10:44 Add PR19 definition. */
/*: CR  4/30/90 20:45 Add more to header comments. */
/*: JV  7/06/90 16:01 Add RO for MIPS RISC/os. */
/*: CR  9/20/90 16:56 Add PS system type. */
/*: CR  9/27/90 12:09 Add U3,AU system types. */
/*: CR  8/20/92 15:08 MV is Coherent now. */

/*** Unix systems. */
#define  A3   0    /* AT&T 3B System V Unix */
#define  AU   0    /* Apple Unix AUX II. */
#define  BU   0    /* Berkeley 4.2 Unix */
#define  DU   0    /* DG/UX. */
#define  FU   0    /* Fortune For:pro Unix. */
#define  HU   0    /* Hewlit-Packard HP/UX. */
#define  IX   0    /* Interactive Systems Unix 286/386. */
#define  MU   0    /* Masscomp RT Unix */
#define  MV   0    /* Coherent (yes, it's silly...) */
#define  PS   0    /* Panel-emulation SunOS. */
#define  PU   0    /* Plexus System V Unix */
#define  PX   0    /* Panel-emulation Xenix. */
#define  RO   0    /* MIPS Computers RISC/os */
#define  SX   0    /* SCO Xenix */
#define  SV   0    /* Sperry 5000 Unix System V. */
#define  SN   1    /* SunOS, for a network. */
#define  SS   0    /* SunOS, for a single processor. */
#define  TX   0    /* Tandy 6000 Xenix */
#define  U3   0    /* Unix 386 "standard" - like SX with IX systemid(). */

#define  SU    SS | SN
#define  UNIX  A3 | AU | BU | DU | FU | MU | MV | PU | SU | SX | TX | HU | IX | SV | RO | U3

/* If GUARD is 1, forces use of guardian lock-files for system V unix
/  systems (even though they ought to be able to use lockf().) */
#define  GUARD  0

/*** Set of Data General systems. */
/*  AOS/VS systems now use "CA", as it uses a server. */
#define  AV   0    /* AOS/VS (Advanced Operating System/ Virtual Storage) */
#define  AR   0    /* AOS/RT32 (Real-Time version of AOS/VS) */
#define  AOS  AV | AR   /* In all cases so far, there is no difference... */

/*** Most other systems. */
#define  IM   0    /* IBM PC MSDOS */
#define  JM   0    /* Japanese(?) IBM PC MSDOS */
#define  PN   0    /* IBM PC Network - DOS 3.x */
#define  PR   0    /* All versions of Prime PRIMOS.  Standard is rev 22. */
#define  PR19 0    /* Also make this 1 if using Primos rev 19. */
#define  VV   0    /* DEC Vax/VMS */

/*** Client-Server models.  SRV is logical OR of all client models. */
#define  CX   0    /* Client Xenix: for testing client/server models. */
#define  CA   0
#define  CVM  0
#define  SRV  CX | CA | CVM

#define  VMU  0    /* Obsolete, but kept for the moment. */
#define  VMR  0    /* Ditto. */
#define  VM   0    /* Ditto. */


/* If Vax, define some Vax-specific macros */
#if VV
   /*** Definitions of resource locking symbols, stolen directly
   /    out of SYS$LIBRARY:STARLET.REQ.  */
#define  LCK$K_EXMODE    5
#define  LCK$M_SYSTEM   16
#define  PSL$C_KERNEL    0
#define  PSL$C_EXEC      1
#define  PSL$C_SUPER     2
#define  PSL$C_USER      3
#endif

/*** If emulation of panel library stuff, undefine some symbols
/    that otherwise conflict with curses. */
#if PX | PS
#undef   CA
#undef   IM
#endif

/*** SYSINIT.H.   Definition of SYSINIT and SYSPUT macros.
/
/    The SYSINIT macro occurs at the very beginning of the Caucus
/    main program.  It is used to insert system-dependent declarations
/    and code that **must** come before anything else.
/
/    The SYSPUT macro displays text on the user's terminal, prior
/    to any initialization of the Caucus output display code.  It
/    is only used for debugging purposes early in the Caucus main
/    program.  */

/*: AA  7/29/88 17:47 Source code master starting point */
/*: JV  8/01/88 13:40 Added AOS code.*/
/*: CR 10/12/88 13:03 Add "CX" type to SYSINIT definition. */
/*: CR 11/09/88 15:20 Remove VM, add CA and CVM. */
/*: CR  4/21/89 16:04 CVM: add _staksize defn to go in main(). */
/*: CW  5/18/89 14:54 Add PX system type code. */
/*: CR  1/29/90 16:44 Add hangup (logout) detection for Primos. */
/*: CR  9/21/90 14:07 Add PS system type. */
/*: CR  9/25/90 15:38 Add SYSPUT macro definition. */

#if UNIX | IM | JM | PN | PR | VV | AOS | CX | CA | PX | PS
#define  SYSINIT
#define  SYSPUT(x)   sysputstr(x)
#endif
 
#if PR
/*** Detect interrupt (^P or break is QUIT) and logout (hangup). */
#define    INIT1   extern sysbrk2(), syshang();   fortran mkon$p()
#define    INIT2   short  quitlen=5, logolen=7
#define    INIT3   mkon$p ("QUIT$",   &quitlen, sysbrk2)
#define    INIT4   mkon$p ("LOGOUT$", &logolen, syshang)

#define SYSINIT    INIT1;   INIT2;   INIT3;   INIT4
#define SYSPUT(x)   sysputstr(x)
#endif

#if CVM
const int _staksize = (25 * 1024);
#define  SYSINIT
#define  SYSPUT(x)   _errdisp (x)
#endif

/*** UNITS.H  Definition of structure & other items used by UNIT_ routines.
/
/    Copyright (C) 1987 Camber-Roth */

/*: AA  7/29/88 17:47 Source code master starting point */
/*: CR  9/30/88 15:17 Add server code in "#if SRV" section. */
/*: CR  6/21/90 11:38 Move LSYS, LUSR, LCNF defs to handicap.h. */
/*: CR  9/27/90 12:27 Remove unused LOCKIT and UNLOCK macros. */

struct unit_template {
   FILE  *fp;                 /* File pointer for open file of this type */
   int   fd;                  /* File descriptor if we need one. */
   short item;                /* Item number file is associated with. */
   short access;              /* READ, WRITE, or APPEND? */
   char  nameis[80];          /* Name of file, created by UNIT_LOCK. */
   long  locknum;             /* Locking record number. */
   short locktype;            /* Locking type (for Unix). */
#if SRV
   char *buffer;              /* Buffer containing text sent by server */
   char *p;                   /* Pointer to what we've read in the buffer. */
   short buflen;              /* Number of chars in the buffer. */
#endif
};

/*** Locking-type structure for Unix systems. */
struct locktype_t {
   int   fd;
   int   nconf;
   char  user[20];
   char  file[80];
};

#if PR
#define KNSAM       0
#define KREAD       1
#define KWRIT       2
#define KPOSN       3
#define KTRNC       4
#define KGETU  040000
#define KCONV    0400
#define EFIUS       5

struct buf_template {
   struct  buf_template *next;
   char   *buf;
   short   buflen;
   short   bufptr;
   short   n;
};
#endif
