/*** ZCHGSUB.   Change subject lists.
/
/    zchgsub (cnum, name, id);
/
/    Parameters:
/       int       cnum;     (conference num)
/       char     *name;     (name of subject)
/       Chix      id;       (psubject owner)
/
/    Purpose:
/       Replace the items listed under a subject with a new list
/       supplied by the user.
/
/    How it works:
/
/    Returns:
/
/    Error Conditions:
/  
/    Side effects: 
/
/    Related functions:
/
/    Called by:  picus
/
/    Operating system dependencies:
/
/    Known bugs:
/
/    Home:  zpicus/zchgsub.c
/ */

/*** Copyright (C) 1993 Camber-Roth.  All rights reserved. */

/*: CR  2/23/93 23:48 New function. */
/*: CK  3/01/93 16:45 return success. */
/*: CP  8/01/93 10:50 Add a_mak...() name arg. */

#include <stdio.h>
#include "caucus.h"
#include "chixuse.h"
#include "api.h"

FUNCTION  zchgsub (cnum, name, id)
   int    cnum;
   char  *name;
   Chix   id;
{
   Namex  namex;
   Rlist  rthis, rlast;
   int    ok, i, success;
   char   answer[200];
   Chix   newlist, word;
   long   item;

   if (cnum < 0)  return(0);

   namex   = a_mak_namex("zchgsub namex");
   rlast   = namex->rlist;
   newlist = chxalloc (80L, THIN, "zchgsub newlist");
   word    = chxalloc (80L, THIN, "zchgsub word");

   printf ("Enter new list of items: ");
   gets   (answer);
   chxcpy (newlist, CQ(answer));

   for (i=1;   chxtoken (word, nullchix, i, newlist) >= 0;   ++i) {
      if (NOT chxnum (word, &item))  continue;
      rthis = a_mak_rlist("zchgsub rthis");
      rthis->i0 = rthis->i1 = item;
      rlast->next = rthis;
      rlast       = rthis;
   }
   chxcpy (namex->namepart, CQ(name));
   chxcpy (namex->owner, id);
   namex->cnum = cnum;

   ok = a_chg_namex (namex, P_SUBJECT, A_WAIT);
   if (ok != A_OK) {
      printf ("error code=%d\n", ok);
      FAIL;
   }
   SUCCEED;

done:
   a_fre_namex (namex);
   chxfree (word);
   chxfree (newlist);
   return  (success);
}
