/*** ZCUSFLAG.   Change basic conference information: change, add, vis, subject.
/
/    zcusflag (cnum, type);
/
/    Parameters:
/       int       cnum;     (conference num)
/       long      type;     (P_FCHANGE, P_FVIS, P_FADD, P_FCHGSUB)
/
/    Purpose:
/       Change the change, add, subject, or visibility flags for a conference.
/
/    How it works:
/
/    Returns:
/
/    Error Conditions:
/  
/    Side effects: 
/
/    Related functions:
/
/    Called by:  picus
/
/    Operating system dependencies:
/
/    Known bugs:
/
/    Home:  zpicus/zcusflag.c
/ */

/*** Copyright (C) 1992 Camber-Roth.  All rights reserved. */

/*: CR 11/30/92 18:09 New function. */
/*: CR 12/07/92 10:38 Make 'type' long. */
/*: CP  8/01/93 10:50 Add a_mak...() name arg. */

#include <stdio.h>
#include "caucus.h"
#include "chixuse.h"
#include "api.h"

FUNCTION  zcusflag (cnum, type)
   int    cnum;
   long   type;
{
   Conf   conf;
   int    value, ok;
   char   answer[40];

   if (cnum < 0)         return;

   printf ("Enter new value: ");
   gets   (answer);
   if (NULLSTR(answer))  return;

   sscanf (answer, "%d", &value);

   conf = a_mak_conf("zcusflag conf");
   conf->cnum = cnum;

   if (type == P_FCHANGE)  conf->change  = value;
   if (type == P_FVIS)     conf->visible = value;
   if (type == P_FADD)     conf->add     = value;
   if (type == P_FCHGSUB)  conf->subject = value;

   ok = a_chg_conf (conf, type, A_WAIT);
   printf ("%s\n", (ok==A_OK ? "Succeeded." : "Failed"));

done:
   a_fre_conf (conf);
   return;
}
