/*** ZCUSTEXT.   Change basic conference information: intro, greeting, userlist.
/
/    zcustext (cnum, type);
/
/    Parameters:
/       int       cnum;     (conference num)
/       long      type;     (P_TEXT, P_GREET, P_USERLIST)
/
/    Purpose:
/       Change the intro, greeting, or userlist text of a conference.
/
/    How it works:
/
/    Returns:
/
/    Error Conditions:
/  
/    Side effects: 
/
/    Related functions:
/
/    Called by:  picus
/
/    Operating system dependencies:
/
/    Known bugs:
/
/    Home:  zpicus/zcustext.c
/ */

/*** Copyright (C) 1992 Camber-Roth.  All rights reserved. */

/*: CR 11/27/92 18:25 New function. */
/*: CR 12/07/92 10:38 Make 'type' long. */
/*: CP  8/01/93 10:50 Add a_mak...() name arg. */

#include <stdio.h>
#include "caucus.h"
#include "chixuse.h"
#include "api.h"

FUNCTION  zcustext (cnum, type)
   int    cnum;
   long   type;
{
   Conf   conf;
   int    ok;
   char   line[100];
   Chix   text;

   if (cnum < 0)  return;

   conf = a_mak_conf("zcustext conf");
   conf->cnum = cnum;

   if (type == P_TEXT)      text = conf->intro->data;
   if (type == P_GREET)     text = conf->greet->data;
   if (type == P_USERLIST)  text = conf->userlist->data;

   chxclear (text);
   printf ("Enter new text.  Blank line to end.\n");
   while (1) {
      gets (line);
      if (NULLSTR(line))  break;
      chxcat (text, CQ(line));
      chxcat (text, CQ("\n"));
   }

   ok = a_chg_conf (conf, type, A_WAIT);
   printf ("%s\n", (ok==A_OK ? "Succeeded." : "Failed"));

done:
   a_fre_conf (conf);
   return;
}
