/*** ZDELRESP.   Delete an item or response.
/
/    zdelresp (cnum, isresp);
/
/    Parameters:
/       int       cnum;     (conference num)
/       int       isresp;   (1=>resp, 0=>item)
/
/    Purpose:
/       Delete an item or a response from this conference.  Ask user for
/       everything.
/
/    How it works:
/
/    Returns:
/
/    Error Conditions:
/  
/    Side effects: 
/
/    Related functions:
/
/    Called by:  picus
/
/    Operating system dependencies:
/
/    Known bugs:
/
/    Home:  zpicus/zdelresp.c
/ */

/*** Copyright (C) 1992 Camber-Roth.  All rights reserved. */

/*: CR 12/06/92 22:24 New function. */
/*: CP  8/01/93 10:50 Add a_mak...() name arg. */

#include <stdio.h>
#include "caucus.h"
#include "chixuse.h"
#include "api.h"

FUNCTION  zdelresp (cnum, isresp)
   int    cnum, isresp;
{
   char   answer[100];
   int    inum, rnum, ok;
   Resp   resp;

   resp = a_mak_resp("zdelresp resp");
   resp->cnum = cnum;

   if (isresp) {
      printf ("Enter item (space) response#: ");
      gets   (answer);
      sscanf (answer, "%d %d", &inum, &rnum);
      resp->inum = inum;
      resp->rnum = rnum;
   }
   else {
      printf ("Enter item#: ");
      gets   (answer);
      sscanf (answer, "%d", &inum);
      resp->inum = inum;
      resp->rnum = 0;
   }

   ok = a_del_resp (resp, P_ALL, A_WAIT);
   if (ok != A_OK)  printf ("error code=%d\n", ok);

   a_fre_resp (resp);
   return (1);
}
