/*** ZREGISTER.   Register user.
/
/    zregister ();
/
/    Parameters:
/
/    Purpose:
/       Register a user when they use picus for the first time.
/
/    How it works:
/
/    Returns:
/
/    Error Conditions:
/  
/    Side effects: 
/
/    Related functions:
/
/    Called by:  picus
/
/    Operating system dependencies:
/
/    Known bugs:
/
/    Home:  zpicus/zregister.c
/ */

/*** Copyright (C) 1992 Camber-Roth.  All rights reserved. */

/*: JV 12/04/92 14:52 New function. */
/*: JV 12/07/92 15:37 Fix Chix. */
/*: CP  8/01/93 10:50 Add a_mak...() name arg. */
/*: JZ 10/18/93 10:39 Remove dust bunnies. */

#include <stdio.h>
#include "caucus.h"
#include "chixuse.h"
#include "api.h"

extern Chix ss_luid, ss_ruid;

FUNCTION  zregister ()
{
   int  ok, success, i;
   char answer[40];
   Person person;
   Chix   userid, tempchx;

   userid = chxalloc (20L, THIN, "zchgper userid");
   tempchx = chxalloc (20L, THIN, "zchgper tempchx");
   sysuserid (userid);

   person = a_mak_person("zregist person");
   chxcpy (person->owner, userid);

   /*** Get the registration info. */
   printf ("What would you like your name to be? ");
   gets   (answer);
   chxcpy    (person->name, CQ(answer));
   chxformat (person->name, CQ(" %s%s"), 0L, 0L, ss_luid, userid);
   chxformat (person->name, CQ("%s"), 0L, 0L, ss_ruid, nullchix);

   /* Figure last name */
   for (i=1; chxtoken (tempchx, nullchix, i, CQ(answer)) != -1; i++)
      chxcpy (person->lastname, tempchx);

   printf ("What is your phone number? ");
   gets   (answer);
   chxcpy (person->phone, CQ(answer));

   printf ("\nEnter a brief introduction.\n");
   printf ("To end, press <RETURN> at the beginning of a line.\n");
   chxclear (person->intro->data);
   while (printf (">"), gets (answer), strlen (answer) != 0) {
      chxcat (person->intro->data, CQ(answer));
      chxcat (person->intro->data, CQ("\n"));
      person->intro->lines++;
   }

   ok = a_add_person (person, P_ALL, A_WAIT);
   if (ok != A_OK) {
      printf ("a_add_person failed, code=%d\n", ok);
      DONE   (ok);
   }

   DONE (A_OK);

done:
   chxfree (userid);
   a_fre_person (person);
   return (success);
}
