/*** ZSHOWCHIX.   Display a chix "file".
/
/    zshowchix (title, x);
/
/    Parameters:
/       char     *title;   (title)
/       Chix      x;       (multi-line chix to be displayed)
/
/    Purpose:
/       Display a multi-line chix, with an informative title.
/
/    How it works:
/
/    Returns:
/
/    Error Conditions:
/  
/    Side effects: 
/
/    Related functions:
/
/    Called by:  picus
/
/    Operating system dependencies:
/
/    Known bugs:
/
/    Home:  zpicus/zshowchi.c
/ */

/*** Copyright (C) 1992 Camber-Roth.  All rights reserved. */

/*: CR 11/19/92 19:36 New function. */
/*: CR 12/11/92 13:16 Chxnextl last arg is long *. */

#include <stdio.h>
#include "caucus.h"
#include "chixuse.h"
#include "api.h"

FUNCTION  zshowchix (title, x)
   char  *title;
   Chix   x;
{
   Chix   line;
   long   pos;

   line = chxalloc (90L, THIN, "zshowchix line");

   printf ("\n%s\n-----------------------------------------\n", title);

   for (pos=0;   chxnextline (line, x, &pos);   )
      printf (" %s\n", ascquick (line));

   chxfree (line);
   return;
}
