/*** ZSHOWSET.   Display current user's SETtings.
/
/    zshowset();
/
/    Parameters:
/
/    Purpose:
/       Display all of this user's settings.
/
/    How it works:
/
/    Returns:
/
/    Error Conditions:
/  
/    Side effects: 
/
/    Related functions:
/
/    Called by:  picus
/
/    Operating system dependencies:
/
/    Known bugs:
/
/    Home:  zpicus/zshowset.c
/ */

/*** Copyright (C) 1992 Camber-Roth.  All rights reserved. */

/*: CR 12/13/92 12:30 New function. */
/*: CP  8/01/93 10:50 Add a_mak...() name arg. */

#include <stdio.h>
#include "caucus.h"
#include "chixuse.h"
#include "api.h"

FUNCTION  zshowset()
{
   Person me;
   int    ok, n_value, i;
   Chix   t_value;

   t_value = chxalloc (30L, THIN, "zshowset t_value");
   me      = a_mak_person("zshowset me");
   sysuserid (me->owner);

   ok = a_get_person (me, P_SETTING, A_WAIT);
   if (ok != A_OK)  goto done;

   for (i=1;   i<=18;   ++i) {
      get_setting (me->setopts, i, t_value, &n_value);
      switch (i) {
         case ( 5):
         case (11):
         case (16):
            printf ("%2d: '%s'\n", i, ascquick(t_value));
            break;

         default:  
            printf ("%2d:  %d\n", i, n_value);
            break;
      }
   }

done:
   a_fre_person (me);
   chxfree (t_value);
   return;
}
