:
#---EXPUSER.SH.    User interface script to "expusr_x" program.
#
#   Invoked as:
#      expuser     confid  op  [date]
#
#   Parameters:
#      confid      Caucus home directory.
#      op          -p for list, -r for delete
#      date        Relevant date (optional, will prompt for it)
#
#   Purpose:
#      Provide a user interface for performing two functions:
#         (a) Listing  users who have not been on Caucus since a given date.
#         (b) Deleting users who have not been on Caucus since a given date.
#
#   How it works:
#
#   Known bugs:
#
#   History of revisions:
#: CR  9/22/93 17:44 New function.
#: JV  9/24/93 17:33 Consistentize name of executable.
#: JZ 10/14/93 19:41 Ditto.
#: CP  1/20/94 18:49 Exit if "-r" and no date.
#-----------------------------------------------------------------------

#---No 'root' access!
if ./amiroot;
   then exit 1
fi

#---Require args 1 and 2.
if test "x$2" = "x"; then
   exit
fi

#---Prompt for date if not specified.
if test "x$3" = "x"; then
   if test "$2" = "-r"; then
      echo "Remove users last on before which date? "
   else
      echo "List users last on before which date? "
   fi
   read date
else
   date=$3
fi

#---If no date given for delete, do nothing.
if test "$2" = "-r" -a "x$date" = "x"; then
   exit
fi

$1/BIN2/expusr_x $1 $2 $date
#-----------------------------------------------------------------------
